/*
*
* Wanted! plugin for DoD 1.0 
*
* (c) Copyright 2003, SidLuke
* This file is provided as is (no warranties).
*
*/

#include <amxmod>

#define MAX_BUFOR 2047 + 1

new pkills[33][33] // player vs player kills

new wantedmsg[3][]={"Go and get him !","Catch him if you can...","Fight for your honnor of die like a coward..."}

// delete player values
public client_disconnect(id) 
  for (new i=1;i<33;i++)
    pkills[id][i] = 0



public get_data()
{
  new killer = read_data(1)
  new victim = read_data(2)

  new victim_team[8]
  get_user_info(victim,"team",victim_team,8)

  if (killer != victim && killer)
  {
    new killer_team[8]
    get_user_info(killer,"team",killer_team,8)

    if ( !equal(killer_team,victim_team) ) // don't count TK's
        pkills[killer][victim] += 1 
  }
  return PLUGIN_CONTINUE 
}

public get_wanted(id)
{
  new player_team[8]
  get_user_info(id,"team",player_team,8)
  new wantedID = 0
  new wStart
  wStart = get_cvar_num("amx_wanted_start")
  new diff 
  diff = wStart
  new savekills
  savekills = 0
  for ( new i=1;i<33;i++)
    if ( (pkills[i][id] - pkills[id][i]) >= diff )
      {
        new wanted_team[8]
        get_user_info(i,"team",wanted_team,8)
	if ( !equal(player_team,wanted_team) ) // players must be in different teams
	  {  
            if ( (pkills[i][id] - pkills[id][i]) == diff ) // ex. 3-0 , 4-1 , 8-5 display 8-5
	      {	
                if ( pkills[i][id]>savekills ) 
		  {
		    wantedID = i 
		    savekills = pkills[i][id]
		  } 
              }
	    else	
	      {
	         wantedID = i
	         savekills = pkills[i][id]
                 diff = (pkills[i][id] - pkills[id][i])
              }
          }
         
       }
  return wantedID
}



public on_respawn(id)
{
  if ( get_cvar_float("amx_wanted") && get_cvar_float("amx_wanted_onrespawn") )
    {
      new wantedID = get_wanted(id)
      if ( wantedID != 0 )
        {
          new wanted_name[32]
          get_user_name(wantedID,wanted_name,32)
          set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 3.0, 3.0, 0.1, 0.2, 1)
          show_hudmessage(id,"Wanted!^n%s %d kill(s) -- %d death(s)^n%s", wanted_name, pkills[wantedID][id],                                            pkills[id][wantedID], wantedmsg[random_num(0,2)])
        }
    }
  return PLUGIN_CONTINUE 
}


public on_say(id)
{
  if ( get_cvar_float("amx_wanted") )
    {
      new wantedID = get_wanted(id)
      if ( wantedID != 0 )
        {
          new wanted_name[32]
          get_user_name(wantedID,wanted_name,32)
          client_print(id,print_chat,"[AMX] Wanted! %s with %d kill(s) -- %d death(s)", wanted_name, pkills[wantedID][id],                           pkills[id][wantedID])
        }
      else client_print(id,print_chat,"[AMX] You have no Wanted!...")
    } 
  return PLUGIN_HANDLED
}

public personal(id)
{
  if ( get_cvar_float("amx_personal") )
    {
	new bufor[MAX_BUFOR]
        new player_team[8]
        get_user_info(id,"team",player_team,8) 
        new pos = 0
	new lp = 1
	for ( new i = 1;i < 33;i++)
	  {
	    if ( is_user_connected(i) )
	      {
		new x_team[8]
		get_user_info(i,"team",x_team,8)
		if ( !equal(player_team,x_team) )
		  {
		    new x_name[32]
		    get_user_name(i,x_name,32)
		    pos += format(bufor[pos],MAX_BUFOR - pos, "%2d  %s  %d kill(s)  -- %d death(s)^n",lp,x_name,                                              pkills[i][id],pkills[id][i])
		    lp++	
		  }
	      } 
	  }
        show_motd(id,bufor,"Personal kills")
    }
  return PLUGIN_HANDLED
}


public plugin_init()
{ 
  register_plugin("Wanted","0.9.4","SidLuke")
  register_event("DeathMsg","get_data","a")
  register_event("ResetHUD","on_respawn","be")
  register_cvar("amx_wanted","1")
  register_cvar("amx_wanted_onrespawn","1")
  register_cvar("amx_wanted_start","3")
  register_cvar("amx_personal","1")
  register_clcmd("say /wanted", "on_say")
  register_clcmd("say /personal","personal")
  return PLUGIN_CONTINUE 
}
