/* RealBot Manager Menu.
*
* (c) 2004, MHOS
* This file is provided for the asstaince of RealBot WIP server owners (Use At Own Risk).
*
*/

#include <amxmod>
#include <amxmisc>

new g_menuPosition[33]

#define MENUS_NUMBER 7

new g_menuBody[MENUS_NUMBER][] = {
"Quick Add",
"End Round",
"Settings",
"Remove Menu^n",

"Random Bot Menu",
"RealBot T Menu",
"Realbot CT Menu"
}

new g_menuCmd[MENUS_NUMBER][] = {
"amx_quick",
"amx_endround",
"amx_settings",
"amx_remove",

"amx_random",
"amx_t_menu",
"amx_ct_menu}"
}

// Second value sets if menu is only for CS...
new g_menuAccess[MENUS_NUMBER][2] = {
  {ADMIN_LEVEL_A,1},
  {ADMIN_LEVEL_A,1},
  {ADMIN_LEVEL_A,1},
  {ADMIN_LEVEL_A,1},

  {ADMIN_LEVEL_A,1},
  {ADMIN_LEVEL_A,1},
  {ADMIN_LEVEL_A,1}
}

new g_cstrikeRunning

public plugin_init()
{
  register_plugin("RealBot Manager Menu","0.1","MHOS")  

  register_menucmd(register_menuid("RealBot Manager Menu"),1023,"actionMenu") 
  register_clcmd("amx_rbmm","cmdMenu",ADMIN_MENU,"- displays menus")    
  
  g_cstrikeRunning = is_running("cstrike")
}

public actionMenu(id,key)
{
  switch(key){
  case 8: displayMenu(id,++g_menuPosition[id])
  case 9: displayMenu(id,--g_menuPosition[id])
  default: client_cmd(id, g_menuCmd[ g_menuPosition[id] * 8 + key ] )
  }
  return PLUGIN_HANDLED
}

displayMenu(id,pos){

  if (pos < 0)  return
    
  new menuBody[512]
  new b = 0
  new start = pos * 8
  
  if ( start >= MENUS_NUMBER )
    start = pos = g_menuPosition[id] = 0
      
  new len = format(menuBody,511,
   g_cstrikeRunning ? "\yRealBot Manager Menu\R%d/%d^n\w^n" : "RealBot Manger Menu %d/%d^n^n" , pos+1, 2 )
    
  new end = start + 8
  new keys = (1<<9)
  
  if (end > MENUS_NUMBER )
    end = MENUS_NUMBER
    
  new flags = get_user_flags(id)
    
  for(new a = start; a < end; ++a)
  {

      if ( (flags & g_menuAccess[a][0]) && ( g_menuAccess[a][1] ? g_cstrikeRunning : 1 ) )
      {
        keys |= (1<<b)
        len += format(menuBody[len],511-len,"%d. %s^n",++b, g_menuBody[ a ] )
      }
      else
      {
        ++b     
        if ( g_cstrikeRunning )
          len += format(menuBody[len],511-len, "\d%d. %s^n\w",b, g_menuBody[ a ] )
        else
          len += format(menuBody[len],511-len, "#. %s^n",g_menuBody[ a ] )

      }
  }
      
  if (end != MENUS_NUMBER )
  {
    format(menuBody[len],511-len,"^n9. More...^n0. %s", pos ? "Back" : "Exit")
    keys |= (1<<8)
  }
  else format(menuBody[len],511-len,"^n0. %s", pos ? "Back" : "Exit")
 
  show_menu(id,keys,menuBody)
}

public cmdMenu(id,level,cid)
{
  if (cmd_access(id,level,cid,1))
    displayMenu(id,g_menuPosition[id] = 0)
  return PLUGIN_HANDLED
}
