/*
*
* AMX_QUIT
*  by JustinHoMi
*
*/

#include <amxmod>

public admin_quit(id,level){
	if (!(get_user_flags(id)&level)){
			console_print(id,"[AMX] You have no access to that command.")
			return PLUGIN_HANDLED
	}
	if (read_argc() < 2){
			console_print(id,"[AMX] Usage: amx_quit < time in seconds >")
			return PLUGIN_HANDLED
	}
	new timeS[5]
	read_argv(1,timeS,4)

	set_task(floatstr(timeS),"shut_down")

	console_print(id,"[AMX] Shutting down server in %s seconds.",timeS)

	set_hudmessage(255, 255, 0, -1.0, 0.30, 0, 6.0, 12.0, 0.5, 0.15, 1)
	show_hudmessage(0,"Server shutting down in %s seconds",timeS)

	return PLUGIN_HANDLED
}

public shut_down(){
	server_cmd("quit")
	return PLUGIN_HANDLED
}

public plugin_init(){
	register_plugin("Admin Quit","0.8","JustinHoMi")
	register_concmd("amx_quit","admin_quit",ADMIN_RCON,"< time in seconds >")
	return PLUGIN_CONTINUE
}
