/* Admin Gag cmd 1.1
About:
This plugin allows you to gag players from using say_team or normal say. It allso echos the actions of admins based on amx_show_activity

Usage:
amx_gag <nick/authid> <flags (a & b)> <time in seconds>
amx_gag <nick/authid>  <time in seconds> // Will automaticly add the ab flag.
amx_gag <nick/authid>	// Will automaticly add ab flag, and 600 secounds gag.

Credits:
This plugin is heavly based on the work of tcquest78 in his gag plugin ( http://djeyl.net/forum/index.php?showtopic=4962 )
OP`s in #amxmod @ Quakenet, for helping me alot with my endless questions.

Changelog:
	1.1
		- Now supports amx_gag <nick> <time> ( Adds ab as flag if no other flag is entered.)
		- Now supports amx_gag <nick/auth>
		- Fixed echoing with amx_show_activity 1 not showing the secounds

	1.0  (Changes are from the orinal plugin to this one)
		- Now echos admin acctions based on amx_show_activity
		- Now echos when a player is ungaged by admin
		- Now echos when a player is ungaged becuse the "time" has run out.
		- Now echos when a gaged player disconnects
		- Admins with immunity flag can do actions on themself.
		- If you try to ungag a player thats not gaged, you get a "error" message
		- Changed the "your gaged" message so its simpler to spot in Steam.
		- Somehow the compiled file is smaller then with the orignal
	
Known issues:
* Trying to ungag a player that does not exist. It will echo that the player is not gaged

*/ 

#include <amxmod> 
#include <amxmisc> 

new gGagPlayers[33] 

public plugin_init() { 
	register_plugin("Admin Gag cmd","1.1","EKS/tcquest78") 
	register_clcmd("say","block_gaged") 
	register_clcmd("say_team","block_gaged") 
	register_concmd("amx_gag","amx_gag",ADMIN_KICK,"<authid, nick or #userid> <a|b> [time]") 
	register_concmd("amx_ungag","amx_ungag",ADMIN_KICK,"<authid, nick or #userid>") 
	return PLUGIN_CONTINUE 
	} 

public block_gaged(id){ 
	if(!gGagPlayers[id]) return PLUGIN_CONTINUE // Checks if player is gaged or not.
	new cmd[6] 
	read_argv(0,cmd,4) 
	if ( cmd[3] == '_' )
		{ 
		if (gGagPlayers[id] & 2){ 
			client_print(id,print_chat,"* You are gagged...") 
			return PLUGIN_HANDLED 
			} 
		} 
	else if (gGagPlayers[id] & 1)   { 
		client_print(id,print_chat,"* You are gagged...") 
		return PLUGIN_HANDLED 
		} 
	return PLUGIN_HANDLED 
	} 
public amx_gag(id,level,cid) { 
	new arg[32],AdminName[32],VictimID
	new sgagtime[8] = 0
	read_argv(1,arg,31)  			// Arg contains Targets nick
	VictimID = find_player("aj",arg) 	// Finds VictimID based on nick found above.
	get_user_name(id,AdminName,31)		// Gets Admin name
	if ((get_user_flags(VictimID) & ADMIN_IMMUNITY) && VictimID != id) { return PLUGIN_HANDLED; } // Checks admin immunity, but will execute on if the admin tried to execute on self.
	if (!VictimID) return PLUGIN_HANDLED // Checks if target is anything else then a "human" player

	new sflags[4] 
	read_argv(2,sflags,3) 

	read_argv(3,sgagtime,7) 
	if(isdigit(sflags[0])) // This code checks if the "flag" contains a number instead. If it does, it move the number to gag time and sets def. flags
		{
		format(sgagtime,7,"%s",sflags)
		sflags = "ab"
		}
	new flags = read_flags(sflags) 
	if (strlen(sgagtime) == 0 ) // This code should check if sgagtime is emty, if it is give sgagtime a value of 600. Also ads the value 3 to flags ( witch means gag all)
		{
		format(sgagtime,7,"600")
		flags = 3
		}
		
	new Float:gagtime = floatstr(sgagtime)	
	gGagPlayers[VictimID] = flags 

	new param[2]
	param[0] = VictimID 
	set_task( gagtime,"ungag",VictimID,param,1) 
   	switch(get_cvar_num("amx_show_activity"))   { 
   		case 2:   client_print(0,print_chat,"ADMIN %s: has gaged %s from speaking for %s seconds ",AdminName,arg,sgagtime) 
   		case 1:   client_print(0,print_chat,"ADMIN: has gaged %s from speaking for %s seconds",arg,sgagtime) 
  	 	}	
	return PLUGIN_HANDLED 
	} 


public ungag(param[]) // Removes gag when the time is passed
	{ 
	new VictimName[32],VictimID
	VictimID = param[0]
	get_user_name(VictimID,VictimName,31)
	gGagPlayers[VictimID] = 0 
	remove_task(VictimID)
	client_print(0,print_chat,"ADMIN: %s is no longer gaged",VictimName)
	return PLUGIN_HANDLED 
	} 

public amx_ungag(id,level,cid) {  /// Removed gaed player ( done via console command )
	new arg[32],AdminName[32],VictimID 
	read_argv(1,arg,31)  			// Arg contains Targets nick
	VictimID = find_player("aj",arg) 	// Finds VictimID based on nick found above.
	get_user_name(id,AdminName,31)		// Gets Admin name
	if(!gGagPlayers[VictimID])		// Checks if player has gaged flag
		{
		client_print(id,print_chat,"%s is not gaged, and cannot be ungaged.",arg)
		return PLUGIN_HANDLED
		}
	gGagPlayers[VictimID] = 0 
	remove_task(VictimID)
	switch(get_cvar_num("amx_show_activity"))   { 
   		case 2:   client_print(0,print_chat,"ADMIN %s: has ungaged %s",AdminName,arg) 
   		case 1:   client_print(0,print_chat,"ADMIN: has ungaged %s",arg) 
  	 	}
	return PLUGIN_HANDLED 
	} 

public client_disconnect(id) 
	{ 
	if(gGagPlayers[id]) // Checks if disconnected player is gaged
		{
		new Temp[32]
		get_user_name(id,Temp,31)
		gGagPlayers[id] = 0 
		remove_task(id)
		client_print(0,print_chat,"%s gaged player has disconnected",Temp)
		}
	return PLUGIN_HANDLED 
	}
