/* AMX Mod script. 
* 
* Bot control
* (c) Copyright 2003, lensky
* This file is provided as is (no warranties). 
*
* Script is meant to give players ability to control bots, and to reduce
* necessity of admins presence
*
* The script provides:
*
*	-Bots autojoin and autokick system. If there is no human players 
*	on server, after a delay number of bots is matched to a preset 
*	number. For Ex. if preset number is 1 and delay is 60 secs, last
*	human player leaves the server and there are no bots left, so 
*	after 60 secs another bot will join. (Done to make ppl think 
*	that there is somebody on server, and to let them play with 
*	someone even if there are no other ppl and they don't know how 
*	to use 	votes mentioned below)
*	-Public kick all bots vote
*	-Public add bots vote
*	-Kickallbots server command (should work with any bot, not only 
*	pl and joe bots)
*  Cvars:
*   amx_bots_autojoin 1 - if not '1' then autojoin and autokick 
* will be deasabled 
*   amx_bots_autojoin_delay 60.0
*   amx_bots_autojoin_number 1
*   amx_bots_type 1 - plbot or joebot, 0 for joebot, 1 for plbot
*
*   amx_publickickallbotsvote 1 - if not '1' then votekickallbots command 
* will be available only to ADMIN_VOTE users, else available to all
*  
*   amx_publicaddbotsvote 1 - if not '1' then voteaddterbot and 
* voteaddctbot commands will be available only to ADMIN_VOTE users
*
*  Commands:
*
*	amx_votekickallbots - start voting session for kick all bots") 
*	say /voteaddterbot - start votingrbot" session for kick all bots") 
*	amx_voteaddterbot - start voting session for kick all bots") 
*	say /voteaddctbot - start voting session for kick all bots") 
*	amx_voteaddctbot - start voting session for kick all bots") 
*  Server command:
*	amx_kickallbots - as plbot doesn't have such command
*   
*  Update 0.9.4a: 
*     Now support plbot, just set amx_bots_type 1 for plbot, and 0 for joebot
*     amx_kickallbots server bot command added
*
*  The script is meant for JoeBot and PLBot, but should work with others, 
*  just change first three functions for Adding TERs and CTs bots, and 
*  kicking all bots. For Ex. change 'joebot kickbots|all' to ' pb kickbots'
*
*/ 

#include <amxmod> 
#include <amxmisc>

new istimeron = 0

public kickallbots() {
	if (get_cvar_num("amx_bots_type")==1){
		new bots[32], bnum
		get_players( bots , bnum, "d")
		new botsid
		for(new i = 0; i < bnum; ++i ) {
			botsid = get_user_userid(bots[i])
			server_cmd("kick #%d",botsid)

		}
	} else server_cmd("joebot kickbots|all")
}

public addterbot() {
	if (get_cvar_num("amx_bots_type")==1)
		server_cmd("plb_add 1")		
	else server_cmd("joebot addbot|1|2")
}

public addctbot() {
	if (get_cvar_num("amx_bots_type")==1)
		server_cmd("plb_add 2")		
	else server_cmd("joebot addbot|2|2")
}

public check_bots() {
	if (get_cvar_num("amx_bots_autojoin")==1) {
		new players[32], pnum, bnum
		get_players( players , pnum, "c"  )
		get_players( players , bnum, "d"  )
		if ((istimeron!=1)&&(pnum<1)&&(bnum!=get_cvar_num("amx_bots_autojoin_number"))) {
			istimeron = 1
			set_task(get_cvar_float("amx_bots_autojoin_delay"),"controlbot", 0)
		}
	}
}

public client_disconnect(id) {

	if (!is_user_bot(id)) check_bots();
	return PLUGIN_CONTINUE
}



public controlbot() {
	new players[32], pnum, bnum
	get_players( players , pnum, "c"  )
	get_players( players , bnum, "d"  )
	if ((pnum<1)&&(bnum!=get_cvar_num("amx_bots_autojoin_number"))&&(istimeron==1)) {
		if (bnum>1) {
			kickallbots()
			istimeron=1
			set_task(get_cvar_float("amx_bots_autojoin_delay"),"controlbot", 0)
		}
		if (bnum<get_cvar_num("amx_bots_autojoin_number")) {
			addterbot()
			istimeron=0
		}
	}
	else istimeron=0
}

public client_connect(id) {

	if (!is_user_bot(id)) {

		istimeron=0
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

public startofround() {
	check_bots()
	return PLUGIN_CONTINUE	
}


// Voting part below
new moption[2] 
new votebots[] = "\yAMX bots: %s?\w^n^n1. Yes^n2. No" 
new votebotstype = 0

public vote_kickallbots(id){
	if ((!cmd_access(id,ADMIN_VOTE,0,1))&&(get_cvar_num("amx_publickickallbotsvote") == 0))
	{
		client_print(id,print_chat,"The command is blocked for you")
		return PLUGIN_HANDLED
	}

	new Float:voting = get_cvar_float("amx_last_voting") 
	if (voting > get_gametime()) { 
		client_print(id,print_chat,"* There is already one voting...") 
		return PLUGIN_HANDLED 
	}

	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"* Voting not allowed at this time...") 
		return PLUGIN_HANDLED 
	}
	new name[32]
	get_user_name(id,name,31)
	switch(get_cvar_num("amx_show_activity"))	{
	case 2:	client_print(0,print_chat,"%s %s: starts kick all bots vote",	(get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN", name)
	case 1:	client_print(0,print_chat,"%s: starts kick all bots vote ", (get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN")
	}
	votebotstype = 1
	new menu_msg[256] 
	format(menu_msg,255,votebots,"kick all") 
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time ) 
	show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(vote_time)) 
	set_task(vote_time,"check_mvotes") 
	client_print(0,print_chat,"* Voting has started...") 
	moption[0]=moption[1]=0 
	return PLUGIN_CONTINUE      
} 

public vote_addterbot(id){
	if ((!cmd_access(id,ADMIN_VOTE,0,1))&&(get_cvar_num("amx_publicaddbotsvote") == 0))
	{
		client_print(id,print_chat,"The command is blocked for you")
		return PLUGIN_HANDLED
	}

	new Float:voting = get_cvar_float("amx_last_voting") 
	if (voting > get_gametime()) { 
		client_print(id,print_chat,"* There is already one voting...") 
		return PLUGIN_HANDLED 
	}

	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"* Voting not allowed at this time...") 
		return PLUGIN_HANDLED 
	}
	new name[32]
	get_user_name(id,name,31)
	switch(get_cvar_num("amx_show_activity"))	{
	case 2:	client_print(0,print_chat,"%s %s: starts add TER bot vote",	(get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN", name)
	case 1:	client_print(0,print_chat,"%s: starts add TER bot vote ", (get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN")
	}
	votebotstype = 2
	new menu_msg[256] 
	format(menu_msg,255,votebots,"add TER bot") 
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time ) 
	show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(vote_time)) 
	set_task(vote_time,"check_mvotes") 
	client_print(0,print_chat,"* Voting has started...") 
	moption[0]=moption[1]=0 
	return PLUGIN_CONTINUE      
} 

public vote_addctbot(id){
	if ((!cmd_access(id,ADMIN_VOTE,0,1))&&(get_cvar_num("amx_publicaddbotsvote") == 0))
	{
		client_print(id,print_chat,"The command is blocked for you")
		return PLUGIN_HANDLED
	}

	new Float:voting = get_cvar_float("amx_last_voting") 
	if (voting > get_gametime()) { 
		client_print(id,print_chat,"* There is already one voting...") 
		return PLUGIN_HANDLED 
	}

	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"* Voting not allowed at this time...") 
		return PLUGIN_HANDLED 
	}
	new name[32]
	get_user_name(id,name,31)
	switch(get_cvar_num("amx_show_activity"))	{
	case 2:	client_print(0,print_chat,"%s %s: starts add CT bot vote",	(get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN", name)
	case 1:	client_print(0,print_chat,"%s: starts add CT bot vote ", (get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN")
	}
	votebotstype = 3
	new menu_msg[256] 
	format(menu_msg,255,votebots,"add CT bot") 
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time ) 
	show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(vote_time)) 
	set_task(vote_time,"check_mvotes") 
	client_print(0,print_chat,"* Voting has started...") 
	moption[0]=moption[1]=0 
	return PLUGIN_CONTINUE      
} 

public mvote_count(id,key){ 
    if ( get_cvar_float("amx_vote_answers") ) { 
        new name[32] 
        get_user_name(id,name,31) 
        client_print(0,print_chat,"* %s voted %s", name, key ? "against" : "for" ) 
    } 
    ++moption[key] 
    return PLUGIN_HANDLED 
} 

public check_mvotes(id){ 
	if (moption[0] > moption[1]){ 
		if (votebotstype == 1) {
			kickallbots()
			set_hudmessage(250, 0, 0, -1.0, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)   
			show_hudmessage(0,"Kicking all bots")
			client_print(id,print_console,"Kicking all bots") 
			server_print("Kicking all bots")
		}
		if (votebotstype == 2) {
			addterbot()
			set_hudmessage(255, 0, 0, -1.0, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)   
			show_hudmessage(0,"TER bot added")
			client_print(id,print_console,"TER bot added") 
			server_print("TER bot added")
		}
		if (votebotstype == 3) {
			addctbot()
			set_hudmessage(255, 0, 0, -1.0, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)   
			show_hudmessage(0,"CT bot added")
			client_print(id,print_console,"CT bot added") 
			server_print("CT bot added")
		}
		client_print(0,print_chat,"* Voting results: (yes ^"%d^") (no ^"%d^").",moption[0],moption[1])
	} 
	else{
		client_print(0,print_chat,"* Voting results: failed (yes ^"%d^") (no ^"%d^").",moption[0],moption[1])
	} 
	return PLUGIN_CONTINUE 
}

public plugin_init() {
	register_plugin("Botcontrol","0.9.4a","lensky")
	register_logevent("startofround",2,"1=Round_Start")
	// Voting part below
	register_clcmd("say /votekickallbots","vote_kickallbots",0,"- start voting session for kick all bots") 
	register_clcmd("amx_votekickallbots","vote_kickallbots",ADMIN_VOTE,"- start voting session for kick all bots") 
	register_clcmd("say /voteaddterbot","vote_addterbot",0,"- start voting session for kick all bots") 
	register_clcmd("amx_voteaddterbot","vote_addterbot",ADMIN_VOTE,"- start voting session for kick all bots") 
	register_clcmd("say /voteaddctbot","vote_addctbot",0,"- start voting session for kick all bots") 
	register_clcmd("amx_voteaddctbot","vote_addctbot",ADMIN_VOTE,"- start voting session for kick all bots") 
	register_srvcmd("amx_kickallbots","kickallbots",ADMIN_MENU,"- kicks all bots") 
	register_menucmd(register_menuid("AMX bots:"),(1<<0)|(1<<1),"mvote_count") 
	register_cvar("amx_publickickallbotsvote","1") 
	register_cvar("amx_publicaddbotsvote","1") 
	// Voting part above
	register_cvar("amx_bots_autojoin","1") 
	register_cvar("amx_bots_autojoin_delay","60.0") 
	register_cvar("amx_bots_autojoin_number","1") 
	register_cvar("amx_bots_type","1") 

	return PLUGIN_CONTINUE
	                
}	                     
