
/* 
*
* DoD grenade events plugin  by SidLuke 
*
* (c) Copyright 2003, SidLuke
* This file is provided as is (no warranties).
*
*/

#include <amxmod>

public plugin_precache()
{
 precache_sound( "misc/impressive.wav" )
 precache_sound( "misc/excellent.wav" )
 precache_sound( "misc/godlike.wav" )
 return PLUGIN_CONTINUE
}

public grenade_kill()
{
 if ( get_cvar_float("amx_gre_events") )
 {
  new killer = read_data(1)
  new victim = read_data(2)
  new weaponID = read_data(3)

  new victim_team[8] 
  get_user_info(victim,"team",victim_team,8)

  new victim_name[32] 
  get_user_name(victim,victim_name,32)

  set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)

  if (killer != victim && killer) 
  {
    new killer_team[8]
    get_user_info(killer,"team",killer_team,8)
    new killer_name[32]
    get_user_name(killer,killer_name,32)
    if ( !equal(killer_team,victim_team) )
      if ( (equal(killer_team,"allies") && weaponID==14) || (equal(killer_team,"axis") && (weaponID==13 || weaponID==36)) )
      {
        client_cmd(0,"spk misc/godlike")
        show_hudmessage(0,"%s is grenade master !!!",killer_name)
      }
      else
      {
	client_cmd(0,"spk misc/excellent")
	show_hudmessage(0,"%s sends a little gift to %s",killer_name,victim_name)
      } 
    else 
      if ( (equal(killer_team,"allies") && weaponID==14) || (equal(killer_team,"axis") && (weaponID==13 || weaponID==36)) )
        show_hudmessage(victim,"%s killed you trying to throw back enemy grenade.",killer_name)
  }
  else 
    if ( (equal(victim_team,"allies")  && weaponID==14) || (equal(victim_team,"axis") && (weaponID==13 || weaponID==36)) )
      show_hudmessage(0,"%s failed to throw back enemy grenade...",victim_name)
    else
    {
      client_cmd(0,"spk hgrunt/c2a3_hg_laugh")
      show_hudmessage(0,"%s becomes another grenade suicide victim.",victim_name)
    }
 }
 return PLUGIN_CONTINUE
}

public grenade_catch(id)
{
 if (get_cvar_float("amx_gre_events"))
 {
  new weaponID = read_data(2)

  new player_team[8]
  get_user_info(id,"team",player_team,8)

  if ( (equal(player_team,"allies") && weaponID==15) || (equal(player_team,"axis") && weaponID==16) )
    {
     new player_name[32] 
     get_user_name(id,player_name,32)
  
     client_cmd(0,"spk misc/impressive")
     set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
     show_hudmessage(0,"%s catched enemy grenade !!!",player_name) 
    }
 }
 return PLUGIN_CONTINUE
}

public plugin_init() 
{
 register_plugin("DoD Grenade Events","0.9.4","SidLuke")
 register_event("DeathMsg","grenade_kill","a","3=13","3=14","3=36")
 register_event("CurWeapon","grenade_catch","b","1=1","2=15","2=16")
 register_cvar("amx_gre_events","1")
 return PLUGIN_CONTINUE
}

