
/***************************************************************************
 *  amx_ejl_logallsay.sma
 *   beta version 1.0         Date: 10/29/2002
 *   Author: Eric Lidman     ejlmozart@hotmail.com
 *   Alias: Ludwig van       Upgrade: http://lidmanmusic.com/cs/plugins.html
 *          
 *  Its simple really, no commands, it just logs everything said on the
 *   server to a single file every day. Everything includes admin_tsay etc.
 *   It writes in the format:
 *
 *    month/date/year time  command(like say)  authid   name   what was said   
 *
 *  Setup:
 *   Important: For the logging to work, you need to set up some folders
 *   on your server. You need: ../%moddir%/admin_logs/say_logs
 *
 *     example:      ../cstrike/admin_logs/say_logs
 * 
 ***************************************************************************/


#include <amxmod>

public plugin_init() {
	register_plugin("EJL Log all say",".7","EJL")
	register_clcmd("amx_tsay", "HandleSay")
	register_clcmd("amx_csay", "HandleSay")
	register_clcmd("amx_fsay", "HandleSay")
	register_clcmd("amx_scrollsay","HandleSay")
	register_clcmd("amx_tsayy", "HandleSay")
	register_clcmd("amx_csayy", "HandleSay")
	register_clcmd("amx_fsayy", "HandleSay")
	register_clcmd("amx_scrollsayy","HandleSay")
	register_clcmd("tsay", "HandleSay")
	register_clcmd("csay", "HandleSay")
	register_clcmd("fsay", "HandleSay")
	register_clcmd("scrollsay","HandleSay")
	register_clcmd("tsayy", "HandleSay")
	register_clcmd("csayy", "HandleSay")
	register_clcmd("fsayy", "HandleSay")
	register_clcmd("scrollsayy","HandleSay")
	register_clcmd("psay", "HandleSay")
	register_clcmd("amx_chat", "HandleSay")
	register_clcmd("amx_say", "HandleSay")
	register_clcmd("amx_psay", "HandleSay")
	register_clcmd("amx_vote", "HandleSay")
	register_clcmd("say_team", "HandleSay")
	register_clcmd("say", "HandleSay")

	new ThisMap[33]
	get_mapname(ThisMap,33)
	new saylog[192]
	new logtime[64]
	new filename[100]
	get_time("%m/%d/%Y  %H:%M",logtime,64)
	get_time("admin_logs/say_logs/%Y-%m-%d--allsay.log",filename,100)
	format(saylog,192,"%s  START MAP:  %s", logtime,ThisMap)
	write_file(filename, saylog, -1)

	return PLUGIN_CONTINUE
}

public HandleSay(id){

	new Data[192]
	new User[32]
	new Command[32]
	new AUTHID[39]
	new saylog[192]
	new logtime[64]
	new filename[100]
	get_time("%m/%d/%Y  %H:%M",logtime,64)
	get_time("admin_logs/say_logs/%Y-%m-%d--allsay.log",filename,100)

	get_user_authid(id,AUTHID,39)
	get_user_name(id,User,32)

	read_argv(0,Command,32)
	read_args(Data,192)
	remove_quotes(Data)

	format(saylog, 192, "%s  %s %s ........ %s .................. %s",logtime, Command, AUTHID, User, Data)
	write_file(filename, saylog, -1)

	return PLUGIN_CONTINUE
}

