/*
*
* Mortar plugin for DoD 1.0 
*
* (c) Copyright 2003, SidLuke
* This file is provided as is (no warranties).
*
*/

#include <amxmod>

new mortarmsg[2][]={"%s set up mortar well and blow out %s ",
"%s made long range kill to %s"}

public plugin_init()
{ 
  register_plugin("Mortar","0.9.4","SidLuke")
  register_event("DeathMsg","mortar_kill","a","3=0")
  register_cvar("amx_mortarkill","1")
}

public plugin_precache()
  precache_sound( "misc/impressive.wav")

public mortar_kill()
{
  if ( get_cvar_float("amx_mortarkill") )
  {
    new killer = read_data(1)
    new victim = read_data(2)

    if (killer != victim && killer)
    {
      new victim_team[8]
      get_user_info(victim,"team",victim_team,8)

      new killer_team[8]
      get_user_info(killer,"team",killer_team,8)

      if ( !equal(killer_team,victim_team) )
      {
        new killer_name[32]
        new victim_name[32]
      
        get_user_name(killer,killer_name,32)
        get_user_name(victim,victim_name,32)      

        set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
        show_hudmessage(0,mortarmsg[random_num(0,1)],killer_name,victim_name)
        client_cmd(0,"spk misc/impressive")
      }
    }
  }
}
