
/* AMX Mod script. 
* 
* (c) Copyright 2002-2003, OLO 
* This file is provided as is (no warranties). 
* 
*/ 

#include <amxmod> 

new mkills[33][2] 

#define LEVELS 4
new levels[LEVELS] = {3,4,5,6}
new messages[LEVELS][] = {
	"MultiKill: %s^nwith %d kills (%d hs)",
	"UltraKill: %s^nwith %d kills (%d hs)",
	"MonsterKill: %s^nwith %d kills (%d hs)",
	"KillingSpree: %s^nwith %d kills (%d hs)"
}
new sounds[LEVELS][] = {
	"multikill",
	"ultrakill",
	"monsterkill",
	"killingspree"	
}

public deathmsg_event(){
	new killer = read_data(1)
	new victim = read_data(2)
	if (killer&&get_user_team(killer)!=get_user_team(victim)) { 
		mkills[killer][0]++ 
		mkills[killer][1] += read_data(3) /* headshot */ 
		new param[4]
		param[0] = killer 
		param[1] = mkills[killer][0] 
		set_task(5.0,"check_mkill",0,param,3)
	}
} 

public check_mkill(param[]){
	new id = param[0] 
	new ckills = param[1] 
	if (ckills != mkills[id][0]) /* still killing */
		return PLUGIN_CONTINUE
	if (ckills >= levels[0]){
		for(new a=0;a<LEVELS;++a)
			if (ckills == levels[a]){
				new name[32] 
				get_user_name(id,name,31) 
				set_hudmessage(0, 100, 200, 0.05, 0.65, 2, 0.02, 6.0, 0.01, 0.1, 2) 	
				client_cmd(0,"spk misc/%s",sounds[a])
				show_hudmessage(0,messages[a],name,ckills,mkills[id][1])
				break
			}
	}
	mkills[id][0] = 0
	mkills[id][1] = 0
	return PLUGIN_CONTINUE	
}

public client_putinserver(id){
	mkills[id][0] = 0
	mkills[id][1] = 0
	return PLUGIN_CONTINUE	
}

public plugin_init(){
	register_plugin("MultiKill","0.8","default") 
	register_event("DeathMsg","deathmsg_event","a") 
	return PLUGIN_CONTINUE 
} 

