
/* AMX Mod script.
*
* (c) Copyright 2002, Noplay
* This file is provided as is (no warranties).
*
*/

/*
=========================================================================
MySQL CODE

--------------------------------------------------------
CREATE TABLE `plugins` (
  `id` int default '',
  `plugin` varchar(32) NOT NULL default '',
  `loading` tinyint(1) NOT NULL default '1'
) TYPE=MyISAM;

INSERT INTO `plugins` VALUES (1, 'language', 1);
INSERT INTO `plugins` VALUES (2, 'admin', 0);
INSERT INTO `plugins` VALUES (3, 'admin_mysql', 1);
INSERT INTO `plugins` VALUES (4, 'plugins_from_mysql', 1);
INSERT INTO `plugins` VALUES (5, 'admincmd', 1);
INSERT INTO `plugins` VALUES (6, 'adminhelp', 1);
INSERT INTO `plugins` VALUES (7, 'adminslots', 1);
INSERT INTO `plugins` VALUES (8, 'menufront', 1);
INSERT INTO `plugins` VALUES (9, 'cmdmenu', 1);
INSERT INTO `plugins` VALUES (10, 'plmenu', 1);
INSERT INTO `plugins` VALUES (11, 'restmenu', 1);
INSERT INTO `plugins` VALUES (12, 'mapsmenu', 1);
INSERT INTO `plugins` VALUES (13, 'antiflood', 1);
INSERT INTO `plugins` VALUES (14, 'adminchat', 1);
INSERT INTO `plugins` VALUES (15, 'adminvote', 1);
INSERT INTO `plugins` VALUES (16, 'nextmap', 1);
INSERT INTO `plugins` VALUES (17, 'timeleft', 1);
INSERT INTO `plugins` VALUES (18, 'mapchooser', 1);
INSERT INTO `plugins` VALUES (19, 'scrollmsg', 1);
INSERT INTO `plugins` VALUES (21, 'imessage', 1);
INSERT INTO `plugins` VALUES (22, 'welcomemsg', 1);
INSERT INTO `plugins` VALUES (23, 'statsx', 1);
INSERT INTO `plugins` VALUES (24, 'stats_logging', 1);
INSERT INTO `plugins` VALUES (25, 'telemenu', 1);
INSERT INTO `plugins` VALUES (26, 'miscstats', 1);
INSERT INTO `plugins` VALUES (27, 'pausecfg', 1);
INSERT INTO `plugins` VALUES (28, 'statscfg', 1);
INSERT INTO `plugins` VALUES (29, 'mapconfig', 1);
--------------------------------------------------------
(Without stripes)
=========================================================================

=========================================================================
Change ure original plugins.ini,
located in amx/config/ into:

--------------------------------------------------------
language.amx
admin_mysql.amx
plugins_from_mysql.amx
--------------------------------------------------------
(Without stripes)
=========================================================================

=========================================================================
Notes :
. check $moddir/addons/amx/mysql.cfg for MySQL access configuration
. plugins starts to work after 2 times
=========================================================================

*/

#include <amxmod>
#include <mysql>

public load_plugins()
{

	new mysql,cnt
	new plugin[33]
	new error[257]
	new host[65]
	new user[33]
	new pass[33]
	new db[33]
	
	get_cvar_string("amx_mysql_host",host,64)
	get_cvar_string("amx_mysql_user",user,32)
	get_cvar_string("amx_mysql_pass",pass,32)
	get_cvar_string("amx_mysql_db",db,32)

	mysql = mysql_connect(host,user,pass,db,error,256)
	if(mysql>0)
	{
		if(mysql_query(mysql,"SELECT plugin FROM plugins WHERE `loading`='1' ORDER by `id`")>0)
		{
			cnt = 0
			delete_file("addons/amx/config/plugins.ini")
			while(mysql_nextrow(mysql)>0)
			{
				mysql_getfield(mysql,1,plugin,32)
				format(plugin,32,"%s.amx",plugin)
				write_file("addons/amx/config/plugins.ini",plugin,-1)
				cnt++				
			}
			server_print("[AMX] Loaded %d plugin(s) from database",cnt)
		}
		else
		{
			mysql_error(mysql,error,32)
			server_print("MySQL error : could not load plugins : '%s'",error)
		}
		mysql_close(mysql)
	}
	else
	{
		server_print("MySQL error : could not connect : '%s'",error)
	}
	return PLUGIN_HANDLED
}

public plugin_init()
{
	register_plugin("Plugins from MySQL","0.2","Noplay")
	register_cvar("amx_mysql_host","127.0.0.1")
	register_cvar("amx_mysql_user","root")
	register_cvar("amx_mysql_pass","")
	register_cvar("amx_mysql_db","amx")
	set_task(5.0,"load_plugins")
	return PLUGIN_CONTINUE
}


