/* AMX Mod script.
*
* Round Scheduler 0.3
*  by SniperBeamer
*
* thx to JustinHoMi and sonic
*  for the plugins Task Scheduler/RoundCount
*
* This file is provided as is (no warranties).
*
*/

//----------------------------------------------------------------------------------------------
#include <amxmod>
//----------------------------------------------------------------------------------------------
new roundsnum = 0
new tasksum = 0
new taskround[32], taskcmd[32][128], taskflag[32]
//----------------------------------------------------------------------------------------------
public plugin_init(){
	register_plugin("Round Scheduler","0.3","SniperBeamer")
	register_event("TextMsg","reset_counter","a","2&#Game_C","2&#Game_w")
	register_event("RoundTime","new_round","bc")
	register_srvcmd("amx_roundtask","load_task")
}
//----------------------------------------------------------------------------------------------
public new_round(){
	new roundtime = get_cvar_num("mp_roundtime") * 60
	if (roundtime != read_data(1))
		return PLUGIN_CONTINUE

	++roundsnum

	for(new i=0; i<tasksum; i++){
		if ( (equal(taskflag[i],"a")) && (roundsnum==taskround[i]) ) server_cmd(taskcmd[i])
		if ( (equal(taskflag[i],"b")) && ((roundsnum%taskround[i])==0) ) server_cmd(taskcmd[i])
	}

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public reset_counter()
	roundsnum = 0
//----------------------------------------------------------------------------------------------
public load_task(){
	if (read_argc() != 4){
		server_print("[AMX] Usage:  amx_roundtask < round > ^"command^" < flag >")
		return PLUGIN_HANDLED
	}
	if (tasksum>31){
		server_print("[AMX] Too many tasks (max 32)")
		return PLUGIN_HANDLED
	}


	new args[128], tRound[1]
	read_args(args,128)
	parse(args,tRound,1,taskcmd[tasksum],128,taskflag[tasksum],1)
	taskround[tasksum] = str_to_num(tRound)

	++tasksum

	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
