
   /*
   * Plugin by {W`C} Bludy
   *
   *  I  made this plugin so you can send hud messages to specific groups
   of players
   *  based  on  their  names.  I needed a command that could let me send
   private messages
   * to all members of a clan that were in a server at one time.  But not
   all of the clan
   * has admin so admin chat doesnt work.
   *
   *  This  plugin  will send a (white) hud message to all clients with a
   matching part
   * of their name which is good for clan tags
   *
   * Usage: amx_talk |StS| "Hey StS members we have a scrim at 9 est"
   *
   *  This  would sent all StS members, and only StS members whether they
   have admin or not
   *  its  case  sensitive  and can be used down to single letters if you
   want to
   * Hope you find it useful!!!
   *
   * NOTE: When this is compiled it gives a warning, but the plugin still
   works fine
   */
   #include <amxmod>
   #include <amxmisc>
   public admin_talk(id,level,cid){
       if  (!cmd_access(id,level,cid,3)) /* standard check for access and
   number of arguments */
           return PLUGIN_HANDLED
       new arg1[32], arg2[192], name[32]
       get_user_name(id,name,31)    /* get admin name */
       read_argv(1,arg1,31) /* get first argument */
       read_argv(2,arg2,191) /* get second argument */
       new group[32], gnum
       get_players(group,gnum,"f",arg1)  /*  get  ppl matching to name of
   group */
       set_hudmessage(255,255,255,0.05, -0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
       for(new  i=0;i<gnum;++i)  {/*  display  message  to all members of
   group */
           show_hudmessage(group[i],"(%s) %s :   %s",arg1,name,arg2)
           console_print(group[i],"(%s) %s :   %s",arg1,name,arg2)
       }
       if (gnum)
           console_print(id,"Message:   ^"%s^"   was   sent   go   group:
   ^"%s^"*",arg2,arg1)
       else
           console_print(id,"There is no group matching that criteria")
       return PLUGIN_HANDLED
   }
   public plugin_init() {
       register_plugin("AMX Talk","0.9.3","{W`C} Bludy")
       register_concmd("amx_talk","admin_talk",ADMIN_CHAT,"<group>
   <message> - use quotes")
       return PLUGIN_CONTINUE
   }
