
   /* AMX Mod script.
   *
   * Force Model 0.1
   *  by SniperBeamer
   *
   *
   * Description:
   *  You can specify a model for CT/T admin/user.
   *
   * Settings:
   *  model_force - enable/disable
   *  model_adminct - CT admin model
   *  model_admint - T admin model
   *  model_userct - CT user model
   *  model_usert - T user model
   *
   * Requires the Vexd Utilities!
   *
   */
   //--------------------------------------------------------------------
   --------------------------
   #include <amxmod>
   #include <Vexd_Utilities>
   //--------------------------------------------------------------------
   --------------------------
   #define ACCESS_LEVEL ADMIN_LEVEL_A
   //--------------------------------------------------------------------
   --------------------------
   public plugin_init()
   {
       register_plugin("Force Model","0.1","SniperBeamer")
       register_event("ShowMenu","force_model_ct","b","4&CT_Select")
       register_event("ShowMenu","force_model_t","b","4&Terrorist_Select"
   )
       register_cvar("model_force","1")
       register_cvar("model_adminct","vip")
       register_cvar("model_admint","vip")
       register_cvar("model_userct","gsg9")
       register_cvar("model_usert","terror")
   }
   //--------------------------------------------------------------------
   --------------------------
   public force_model_ct(id)
   {
       if (!get_cvar_num("model_force"))
           return PLUGIN_CONTINUE
       client_cmd(id,"slot5")
       new admin[16],user[16]
       get_cvar_string("model_adminct",admin,15)
       get_cvar_string("model_userct",user,15)
       if (get_user_flags(id) & ACCESS_LEVEL)
           CS_SetModel(id,admin)
       else
           CS_SetModel(id,user)
       return PLUGIN_CONTINUE
   }
   //--------------------------------------------------------------------
   --------------------------
   public force_model_t(id)
   {
       if (!get_cvar_num("model_force"))
           return PLUGIN_CONTINUE
       client_cmd(id,"slot5")
       new admin[16],user[16]
       get_cvar_string("model_admint",admin,15)
       get_cvar_string("model_usert",user,15)
       if (get_user_flags(id) & ACCESS_LEVEL)
           CS_SetModel(id,admin)
       else
           CS_SetModel(id,user)
       return PLUGIN_CONTINUE
   }
   //--------------------------------------------------------------------
   --------------------------AMXMOD?>
