
   /* AMX Mod script.
   *
   * (c) Copyright 2002, OLO
   * This file is provided as is (no warranties).
   *
   * Modified by Hephaistos from amxmod.net
   * (original plugin is "Weapon Tracers")
   * to draw tracers on every bullet.
   *
   * To disable plugin use "amx pause war_wea" from server console.
   */
   #include <amxmod>
   new lastammo[33]
   public make_tracer(id){
       new ammo = read_data(3)

       if ( lastammo[id] > ammo ) {
           new vec1[3], vec2[3]
           get_user_origin(id,vec1,1)
           get_user_origin(id,vec2,3)

           message_begin(MSG_PAS, SVC_TEMPENTITY,vec1 )
           write_byte( 6 ) /* TE_TRACER - see commo/const.h in HLSDK */
           write_coord(vec1[0])
           write_coord(vec1[1])
           write_coord(vec1[2])
           write_coord(vec2[0])
           write_coord(vec2[1])
           write_coord(vec2[2])
           message_end()
       }

       lastammo[id] = ammo
   }
   public plugin_init() {
       register_plugin("War Weapon Tracers","0.9","Hephaistos")
       register_event("CurWeapon","make_tracer","be","1=1","3>0")
       return PLUGIN_CONTINUE
   }
