/*********************************************************************
AMX MOD Script
Superior Pistols Mode
Version 1.0
Created by Zaltoa
Email = Darkelite1776@yahoo.com
AIM = WhorableExistens

Console Commands - amx_pistolmode <numberhere>
Numbers -
0 = pistols only off
1 = deagles only
2 = glocks only
3 = usp only
4 = fiveseven only
5 = duelies only

amx_pistolammo <1|0> 1 = on 0 = off
Unlimited ammo for the hand gun when a pistol mode is on...
Will not work if it is not on....

Client say commands - 
/votepistolmode
/voteammo
*********************************************************************/

#include <amxmod>
#include <amxmisc>
#include <fun>
//---------------------------------------------------------------------------------------
new choseString[6][256] = {"For All Guns.","For Deagles Only","For Glocks Only","For USPs Only","For FiveSevens Only","For Duelies Only"}
new off = 1
new deagle = 0
new glock = 0
new usp = 0
new fiveseven = 0
new elite = 0
new unlimitedammo = 0
new choice[2]
new pistolchoice[6]
new voteammo[] = "\yUnlimited Ammo Mode?\w^n^n1. On^n2. Off"
new votepistolmode[] = "\yPistol Mode?\w^n^n1. All Guns^n2. Deagles Only^n3. Glocks Only^n4. USPs Only^n5. FiveSevens Only^n6. Duelies Only"

//---------------------------------------------------------------------------------------

public plugin_init(){
register_plugin("SuperiorPistolMode","1.0","Zaltoa")
register_concmd("amx_pistolmode","cmdpistol",0,"- switch the modes of pistols")
register_concmd("amx_pistolammo","cmdpistolammo",0,"- turn off and on unlimited ammo for the pistols")
register_clcmd("say /voteammo","vote_ammo",0,"- start a vote for unlimited ammo, pistols mode must be on.")
register_menucmd(register_menuid("Unlimited Ammo Mode?"),(1<<0)|(1<<1),"count_votes")
register_clcmd("say /votepistolmode","vote_pistolmode",0,"- start a vote for pistol mode")
register_menucmd(register_menuid("Pistol Mode?"),(1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5),"count_the_votes")
}

//---------------------------------------------------------------------------------------

public cmdpistol(id){ 
new parm[1] 
parm[0]=id 
set_task(0.1,"pistoldrop",0,parm,1,"b")
new arg[2]
read_argv(1,arg,1)
set_hudmessage(200, 100, 0, -1.0, 0.25, 0, 1.0, 3.0, 0.1, 0.2, 2)
if(equal(arg,"0")){
unlimitedammo = 0
off = 1
deagle = 0
usp = 0
glock = 0
fiveseven = 0
elite = 0
console_print(id,"Pistols Mode has been turned off.")
show_hudmessage(0,"All guns are now allowed.")
} else if(equal(arg,"1")){
off = 0
deagle = 1
usp = 0
glock = 0
fiveseven = 0
elite = 0
console_print(id,"Pistols Mode has been turned on to Deagles Only.")
show_hudmessage(0,"Deagles only has been turned on.")
} else if(equal(arg,"2")){
off = 0
deagle = 0
usp = 0
glock = 1
fiveseven = 0
elite = 0
console_print(id,"Pistols Mode has been turned on to Glocks Only.")
show_hudmessage(0,"Glocks only mode has been turned on.")
} else if(equal(arg,"3")){
off = 0
deagle = 0
usp = 1
glock = 0
fiveseven = 0
elite = 0
console_print(id,"Pistols Mode has been turned on to USPs Only.")
show_hudmessage(0,"USPs only mode has been turned on.")
} else if(equal(arg,"4")){
off = 0
deagle = 0
usp = 0
glock = 0
fiveseven = 1
elite = 0
console_print(id,"Pistols Mode has been turned on to FiveSevens Only.")
show_hudmessage(0,"FiveSevens only mode has been turned on.")
} else if(equal(arg,"5")){
off = 0
deagle = 0
usp = 0
glock = 0
fiveseven = 0
elite = 1
console_print(id,"Pistols Mode has been turned on to Duelies Only.")
show_hudmessage(0,"Duelies only mode has been turned on.")
} else {
console_print(id,"Usage: amx_pistolmode <number>")
console_print(id,"0 = pistols only off")
console_print(id,"1 = deagles only")
console_print(id,"2 = glocks only")
console_print(id,"3 = usp only")
console_print(id,"4 = fiveseven only")
console_print(id,"5 = duelies only")
}
return PLUGIN_CONTINUE
}

//---------------------------------------------------------------------------------------

public pistoldrop(parm[]){
new players[32], inum, ammo, clip
get_players(players,inum) 
for(new a=0;a<inum;++a) {
new userweapon = get_user_weapon(players[a],clip,ammo)
if(off==1){
//do nothing
}
if(deagle==1){
give_item(players[a],"weapon_deagle")
if(userweapon==CSW_DEAGLE){
return PLUGIN_CONTINUE
} else {
client_cmd(players[a],"weapon_deagle")
}
}
if(glock==1){
give_item(players[a],"weapon_glock18")
if(userweapon==CSW_GLOCK18){
return PLUGIN_CONTINUE
} else {
client_cmd(players[a],"weapon_glock18")
}
}
if(usp==1){
give_item(players[a],"weapon_usp")
if(userweapon==CSW_USP){
return PLUGIN_CONTINUE
} else {
client_cmd(players[a],"weapon_usp")
}
}
if(elite==1){
give_item(players[a],"weapon_elite")
if(userweapon==CSW_ELITE){
return PLUGIN_CONTINUE
} else {
client_cmd(players[a],"weapon_elite")
}
}
if(fiveseven==1){
give_item(players[a],"weapon_fiveseven")
if(userweapon==CSW_FIVESEVEN){
return PLUGIN_CONTINUE
} else {
client_cmd(players[a],"weapon_fiveseven")
}
}
}
return PLUGIN_CONTINUE
}

//---------------------------------------------------------------------------------------

public cmdpistolammo(id){
new parm[1] 
parm[0]=id 
new arg[2]
read_argv(1,arg,1)
set_hudmessage(200, 100, 0, -1.0, 0.25, 0, 1.0, 3.0, 0.1, 0.2, 2)
if(equal(arg,"1")){
if(off==0){
set_task(0.1,"ammunition",0,parm,1,"b")
unlimitedammo = 1
console_print(id,"Unlimited ammo has been turned on.")
show_hudmessage(0,"Unlimited ammo has been turned on.")
}
if(off==1){
console_print(id,"You must have a pistol mode on before you can do unlimited ammo.")
}
} else if(equal(arg,"0")){
unlimitedammo = 0
console_print(id,"Unlimited ammo has been turned off.")
show_hudmessage(0,"Unlimited ammo has been turned off.")
} else {
if(unlimitedammo==1){
console_print(id,"Usage: amx_pistolammo <1|0> 1 = on 0 = off Currently: ON")
}
if(unlimitedammo==0){
console_print(id,"Usage: amx_pistolammo <1|0> 1 = on 0 = off Currently: OFF")
}
}
return PLUGIN_CONTINUE
}

//---------------------------------------------------------------------------------------

public ammunition(parm[]){
if(unlimitedammo==0){
//do nothing
}
if(unlimitedammo==1){
if(off==1){
return PLUGIN_HANDLED
}
new id = parm[0]
new clip, ammo
new wpn_id=get_user_weapon(id, clip, ammo);
new wpn[32]
if(clip==0){
get_weaponname(wpn_id,wpn,31)
client_cmd(id,"drop",wpn)
give_item(id,wpn)
}
}
return PLUGIN_CONTINUE
}

/*********************************************************************
Unlimited Ammo Voting
*********************************************************************/

public vote_ammo(id){
	if(off==1){
	client_print(id,print_chat,"*A pistol mode has to be on before you can use unlimited ammo.*")
	client_print(id,print_chat,"*Type /votepistolmode to start a voting session for a pistol mode.*")
	return PLUGIN_HANDLED
	}
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()){ 
		client_print(id,print_chat,"*A vote has already been cast.*") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"*Please wait awhile before you can vote again.*") 
		return PLUGIN_HANDLED 
	}
	new menu_msg[256]
	format(menu_msg,255,voteammo)
	new Float:votetime = get_cvar_float("amx_vote_time") + 3.0 
	set_cvar_float("amx_last_voting",  get_gametime() + votetime )
	show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(votetime))
	set_task(votetime,"check_the_votes")
	client_print(0,print_chat,"*Voting has started.*") 
	choice[0]=choice[1]=0
	return PLUGIN_HANDLED 	
}

public count_votes(id,key){ 
	if (get_cvar_float("amx_vote_answers") ) { 
		new name[32] 
		get_user_name(id,name,31)
		client_print(0,print_chat,"* %s voted %s", name, key ? "against Unlimited Ammo" : "for Unlimited Ammo" )
	}
	++choice[key]
	return PLUGIN_HANDLED
} 

public check_the_votes(id){
	if (choice[0] > choice[1]){
		server_cmd("amx_pistolammo 1")
		client_print(0,print_chat,"* Votes For Yes Succeded (yes ^"%d^") (no ^"%d^"). *",choice[0],choice[1])
	}
	else{
		server_cmd("amx_pistolammo 0")
		client_print(0,print_chat,"* Votes For No Succeded (yes ^"%d^") (no ^"%d^"). *",choice[0],choice[1])
	}
	return PLUGIN_CONTINUE
}

/*********************************************************************
Pistols Mode Voting
*********************************************************************/

public vote_pistolmode(id){
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()){ 
		client_print(id,print_chat,"*A vote has already been cast.*") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"*Please wait awhile before you can vote again.*") 
		return PLUGIN_HANDLED 
	}
	new menu_msg[256]
	format(menu_msg,255,votepistolmode)
	new Float:votetime = get_cvar_float("amx_vote_time") + 3.0 
	set_cvar_float("amx_last_voting",  get_gametime() + votetime )
	show_menu(0,(1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5),menu_msg,floatround(votetime))
	set_task(votetime,"votes_check")
	client_print(0,print_chat,"*Voting has started.*") 
	pistolchoice[0]=pistolchoice[1]=pistolchoice[2]=pistolchoice[3]=pistolchoice[4]=pistolchoice[5]=0
	return PLUGIN_HANDLED 	
}

public count_the_votes(id,key){ 
	if (get_cvar_float("amx_vote_answers") ) { 
		new name[32] 
		get_user_name(id,name,31)
		client_print(0,print_chat,"* %s voted %s",name,choseString[key])
	}
	++pistolchoice[key]
	return PLUGIN_HANDLED
} 

public votes_check(id){
	if(pistolchoice[0] > pistolchoice[1] && pistolchoice[0] > pistolchoice[2] && pistolchoice[0] > pistolchoice[3] && pistolchoice[0] > pistolchoice[4] && pistolchoice[0] > pistolchoice[5]){
		server_cmd("amx_pistolmode 0")
		client_print(0,print_chat,"* Votes For All Guns Succeded *")
	} else if(pistolchoice[1] > pistolchoice[0] && pistolchoice[1] > pistolchoice[2] && pistolchoice[1] > pistolchoice[3] && pistolchoice[1] > pistolchoice[4] && pistolchoice[1] > pistolchoice[5]){
		server_cmd("amx_pistolmode 1")
		client_print(0,print_chat,"* Votes For Deagles Only Succeded *")
	} else if(pistolchoice[2] > pistolchoice[0] && pistolchoice[2] > pistolchoice[1] && pistolchoice[2] > pistolchoice[3] && pistolchoice[2] > pistolchoice[4] && pistolchoice[2] > pistolchoice[5]){
		server_cmd("amx_pistolmode 2")
		client_print(0,print_chat,"* Votes For Glocks Only Succeded *")
	} else if(pistolchoice[3] > pistolchoice[0] && pistolchoice[3] > pistolchoice[1] && pistolchoice[3] > pistolchoice[2] && pistolchoice[3] > pistolchoice[4] && pistolchoice[3] > pistolchoice[5]){
		server_cmd("amx_pistolmode 3")
		client_print(0,print_chat,"* Votes For USPs Only Succeded *")
	} else if(pistolchoice[4] > pistolchoice[0] && pistolchoice[4] > pistolchoice[1] && pistolchoice[4] > pistolchoice[2] && pistolchoice[4] > pistolchoice[3] && pistolchoice[4] > pistolchoice[5]){
		server_cmd("amx_pistolmode 4")
		client_print(0,print_chat,"* Votes For FiveSevens Only Succeded *")
	} else if(pistolchoice[5] > pistolchoice[0] && pistolchoice[5] > pistolchoice[1] && pistolchoice[5] > pistolchoice[2] && pistolchoice[5] > pistolchoice[3] && pistolchoice[5] > pistolchoice[4]){
		server_cmd("amx_pistolmode 5")
		client_print(0,print_chat,"* Votes For Duelies Only Succeded *")
	}
	return PLUGIN_CONTINUE
}
