/* AMX Mod Script 
* Script Name: Simple TD Warn  - simple Team Damabe Warning announce by say_hud and sound
* Coded By: _KaszpiR_
* Version 0.2beta
* This file is provided as is (no warranties). 
* tested on cs 1.5 linux 3.1.1.0 on amx 0.9.7 with linux podbot 2.5
* tdwarn.sma
* 
* Put sma in examples dir
	run compile
	copy conpiled/tdarn.amx to ../plugins dir
	add tdwarn.amx to plugins.ini

by default the sound will be played on client machine
<moddir>/sound/misc/tdwarn.wav
<moddir>/sound/misc/tk.wav
<moddir>/sound/misc/tkhs.wav
respectively for teammate damage warning, teammate kill, teammate kill via headshot

there should be option to turn it on/off via statscfg menu (where you can turn off in example bomb announces etc) 
so after installing and runnin server go to stats menu and enable it, cause it is disabled by default

edit sma file to suit your needs - in example chage the warning message

Notice: this is my first AMXMOD plugin from scratch :P
i just rewrote my own old tdwarn statsme script 


KNOWN BUGS:
- when you attack a teamplay then on every next round at the beginnig you will recieve the TDWarn text and audio 
	if they are enabled
	this is not a critical error but a minor bug, not harmful one

TODO:
- format()
- sounds precaching and fixing the spk (or maybe making a emit_sound form it?
- fix on miscstats.sma  - headshot triggeredn on TK -the headshot script has a bug cause it is triggered even on tk

below text is not true cause i have not implemented those features fully
make sure you go that files on server!!!!!!!!
so if player and server has enabled download option then if player does not have the sound then will download it

*/ 

#include <amxmod> 

public TDWarn
public TDWarnSound
public TKAnn
public TKAnnSound
public TKAnnHS
public TKAnnHSSound
//warn
new TDWarnMsg[] = "* TeamMate *"
//new TDWarnWav[] = "sound/misc/tdwarn.wav" 
new TDWarnWav[] = "misc/tdwarn" 

//normal tk :P
//new TKAnnMsg[] = "%s killed %s"
//new TKAnnWav[] = "sound/misc/tk.wav" 
new TKAnnWav[] = "misc/tk" 

//headshot tk
//new TKAnnHSMsg[] = "%s killed %s ^n with a HEADSHOT"
//new TKAnnHSWav[] = "sound/misc/tkhs.wav"  
new TKAnnHSWav[] = "misc/tkhs"  
//////////////////////////////////////////////////////////////////////

//alpha, not implemented, do not touch it or crash
 //comment out this whole function to disable sound caching
/*
public plugin_precache() 
{ 
   precache_model(TDWarnWav) 
   precache_model(TKAnnWav) 
   precache_model(TKAnnHSWav) 
} 
*/

//////////////////////////////////////////////////////////////////////
public plugin_init() { 
   register_plugin("TDWarn", "0.1beta", "_KaszpiR_") 
   register_event("Damage","damage_tdwarn","b") 
   register_event("DeathMsg","death_tdwarn","a") 
} 
//////////////////////////////////////////////////////////////////////
public plugin_cfg(){
//should add to statscfg menu
  new g_addStast[] = "amx_statscfg add ^"%s^" %s"
  server_cmd(g_addStast,"TDWarn for Attacker","TDWarn") 
  server_cmd(g_addStast,"TDWarn Sound for Attacker","TDWarnSound") 
  server_cmd(g_addStast,"TK Announce","TKAnn") 
  server_cmd(g_addStast,"TK Sound","TKAnnSound") 
  server_cmd(g_addStast,"TK HS Announce","TKAnnHS") 
  server_cmd(g_addStast,"TK HS Sound","TKAnnHSSound") 

}
//////////////////////////////////////////////////////////////////////
public damage_tdwarn() 
{ //what to to on damage event
   new idVictim = read_data(0) 
   new idAttacker = get_user_attacker(idVictim) //returns id of the attacker, i guess it could be taken more easily
   if(!idAttacker || (idVictim==idAttacker) || (get_user_team(idAttacker) != get_user_team(idVictim)) || (get_user_health(idAttacker) < 1) )   return PLUGIN_CONTINUE   
   // no non-player damage (bomb/server)
   // no self damage
   // no different team damage
   // no message if the attacker was dead already (grenades, snaily bulets or missiles)
   
   new nAttacker[33] 
   new nVictim[33] 
   get_user_name(idAttacker,nAttacker,32)
   get_user_name(idVictim,nVictim,32)

   //otherwise ...
   if (TDWarn && !is_user_bot(idAttacker)){
     //showimg hud message to anyone exept bot
       set_hudmessage(50, 200, 50, -1.0, 0.85, 0, 0.01, 6.0, 0.01, 0.2, 2) //centered message, green
       show_hudmessage(idAttacker,  TDWarnMsg )
    }
    
   if (TDWarnSound && !is_user_bot(idAttacker) ) client_cmd( idAttacker ,  "spk %s",TDWarnWav)

   return PLUGIN_CONTINUE 
} 
//////////////////////////////////////////////////////////////////////
public death_tdwarn() 
{ //what to to on kill of the teammate event
   new idKiller = read_data(1)
   new idVictim = read_data(2) 
   new headshot = read_data(3)
   if(!idKiller || (idVictim==idKiller) || (get_user_team(idKiller) != get_user_team(idVictim)) || (get_user_health(idKiller) < 1) )   return PLUGIN_CONTINUE   
   // no non-player damage (bomb/server)
   // no self damage
   // no different team damage
   // no message if the attacker was dead already (grenades, snaily bulets or missiles)
  
   
   new nKiller[33] 
   new nVictim[33] 
   get_user_name(idKiller,nKiller,32)
   get_user_name(idVictim,nVictim,32)

   if(headshot) 
   {   //headshot!!!!!!!!!!!!!!
       if (TKAnnHS)
       {
         set_hudmessage(200, 100, 50, -1.0, 0.1, 0, 0.01, 6.0, 0.01, 0.2, 2) //centered message, green
         show_hudmessage(0,  "%s^nkilled teammate^n%s^nWith a^nHEADSHOT", nKiller, nVictim)
       //i wish strings would be more nice , in future versions i will use the format()
       }
    
       if (TKAnnHSSound)  client_cmd( 0 ,  "spk %s",TKAnnHSWav)
   }
   else
   {   
       if (TKAnn)
       {
         set_hudmessage(200, 100, 50, -1.0, 0.1, 0, 0.01, 6.0, 0.0, 0.2, 2) //centered message, green
         show_hudmessage(0,  "%s^nkilled teammate^n%s", nKiller, nVictim)
       }
    
       if (TKAnnSound)  client_cmd( 0 ,  "spk %s",TKAnnWav)
   }

   return PLUGIN_CONTINUE
} 



//end of file
