/*
*
* Top! plugin for DoD 1.0 
*
* (c) Copyright 2003, SidLuke
* This file is provided as is (no warranties).
*
*/

#include <amxmod>

#define MAX_BUFOR 2047 + 1
#define MOTD_MAX_GRE 15
#define MOTD_MAX_HUM 15

new pgrekills[33]
new grekills 
new phumkills[33]
new humkills

// delete player values
public client_disconnect(id) 
{
  pgrekills[id] = 0
  phumkills[id] = 0
}


public get_data() // zbieranie danych
{
  if (  get_cvar_float("amx_topgre") || get_cvar_float("amx_tophum")  )
    {
      new killer = read_data(1)
      new victim = read_data(2)
      new weaponID = read_data(3)

      new victim_team[8]
      get_user_info(victim,"team",victim_team,8)
      new victim_name[32] 
      get_user_name(victim,victim_name,32)

      if (killer != victim && killer)
        {
          new killer_team[8]
          get_user_info(killer,"team",killer_team,8)
          new killer_name[32]
          get_user_name(killer,killer_name,32)
          if ( !equal(killer_team,victim_team) )
            {
              if ( weaponID==13 || weaponID==14 || weaponID==36)
	        {
                  grekills++
                  pgrekills[killer]++
	        }
              else if ( weaponID==1 || weaponID==2 || weaponID==19 || weaponID==34 || weaponID==37 || weaponID==38 ||                         weaponID==39)
	        {
 	          humkills++
	          phumkills[killer]++
	        }
            }
        }
    }
  return PLUGIN_CONTINUE
}

public gre_motd(id)
{
  if ( get_cvar_float("amx_topgre") )
    {
      new bufor[MAX_BUFOR]
      new pos
      new tempkills[33]
      tempkills = pgrekills

      new Max
      new greID
 
      Max = 0
      greID = 0

      new pnumber
      pnumber = get_cvar_num("amx_set_motdgre")
      if ( pnumber > MOTD_MAX_GRE ) pnumber = MOTD_MAX_GRE 

      for ( new i = 1; i < pnumber + 1; i++ )
        {
          for ( new j = 1; j < 33; j++)
            if ( tempkills[j] > Max ) 
	      {
	         Max = tempkills[j]
                 greID = j
	      }
          if ( greID != 0 )
            {
               tempkills[greID] = 0
               Max = 0
               new player_name[32]
               get_user_name(greID,player_name,32)
               pos += format(bufor[pos],MAX_BUFOR - pos, "%2d  %s  %d kill(s)^n",i,player_name,pgrekills[greID])
            }
          else pnumber = i - 1
          greID = 0
        }
      pos += format(bufor[pos],MAX_BUFOR - pos,"^n Total : %d kill(s)",grekills)
      show_motd( id, bufor, "Top grenadiers" )
    }
  return PLUGIN_HANDLED
}

public hum_motd(id)
{
  if ( get_cvar_float("amx_tophum") )
    {
      new bufor[MAX_BUFOR]
      new pos
      new tempkills[33]
      tempkills = phumkills

      new Max
      new humID
 
      Max = 0
      humID = 0

      new pnumber
      pnumber = get_cvar_num("amx_set_motdhum") 
      if ( pnumber > MOTD_MAX_HUM) pnumber = MOTD_MAX_HUM 
 
      for ( new i = 1; i < pnumber + 1; i++ )
        {
          for ( new j = 1; j < 33; j++)
	    if ( tempkills[j] > Max ) 
	      {
                 Max = tempkills[j]
                 humID = j
              }        
          if ( humID != 0 )
            {
               tempkills[humID] = 0
               Max = 0
               new player_name[32]
               get_user_name(humID,player_name,32)
               pos += format(bufor[pos],MAX_BUFOR - pos, "%2d  %s  %d kill(s)^n",i,player_name,phumkills[humID])
            }
          else pnumber = i - 1
          humID = 0
        }
      pos += format(bufor[pos],MAX_BUFOR - pos,"^n Total : %d kill(s)",humkills)
      show_motd( id, bufor, "Top humiliators" )
    }
  return PLUGIN_HANDLED
}

public plugin_init()
{ 
  register_plugin( "Top","0.9.4","SidLuke" )
  register_event( "DeathMsg","get_data","a" )
  register_cvar( "amx_topgre","1" ) // enable/disable  top grenades
  register_cvar( "amx_tophum","1" ) // enable/disable  top humiliators
  register_cvar( "amx_set_motdgre","5" ) //show 5 players on default (15 max)
  register_cvar( "amx_set_motdhum","5" ) // show 5 players on default (15 max)
  register_clcmd( "say /grenadiers", "gre_motd" )
  register_clcmd( "say /humiliators", "hum_motd" )
  return PLUGIN_CONTINUE 
}


