/* AMX Mod script. 
* 
*	AMX Mod Plugin - Friendly Fire Management
*	By Rav aka RavenousShadow
*	Email: Rav@efficientdeath.com 
* 
*	Configuration file is ffconfig.cfg (location addons/cstrike/amx) with full explantions.
*
*   Changelog
*	Version 1.0 - First Build with basic revenge menu
*	Version 1.2 - Added Special effects, vote kick, vote ban & spawn protection
*	Version 1.3 - Seperated most punishments for easier calling, added more option to spawn proteection.
*	Version 1.4 - Added Cvar Menu for ingame control - file addons/amx/ffcvars.ini
*		1.42b UPDATE: Corrected spelling error (spwan) and added Spawn protections message on new round.
*
*   Credit to all that have helped along the way in making this plugin.
*
*/

// inc files needed
#include <amxmod>
#include <amxmisc>
#include <fun>

#define ON 1
#define OFF 0
#define YES 1
#define NO 0
#define HUD 1
#define MAX_CVARS 	32

new Punishnextround[33] 	// 1 if to be punished next round
new TeamKillers[33] 		// Team Killer id
new Teamkillcount[33]		// Number of team kills made
new Teamattackcount[33]		// Number of team attacks counted
new Playerattackcount[33]	// Number of player attacks counted
new Effectsonkill[33]		// Use special effects when killed
new Effectsonslap[33]		// Use special effects when slapped
new Spawnattacker[33]		// Call seperate option if at spawn
new Votetoban[33]		// Set vote ban on player
new Votetokick[33]		// Set vote kick on player
new Slapcount[33]		// Multiple slap counter
new Fmenu			// Punishment menu
new Float:sv_spawn = 0.0

// Punishment vars
new Legs = 192			// Target legs only
new Arms = 48			// Target arms only
new Stomach = 8			// Target stomach only

// Prison Functions
new PreprisonOrigin[33][3]
new PlayerIsprisoned[33]

// TimeBomb Settings
new Float:ejl_ff
new IsBomb[33]
new IsKamik[33] 
new bool:rs = false 
new BOMB_FUSE = 10		// Bomb countdown timer

// Effects
new smoke  
new white
new light
new fire
new bloodspray  
new blooddrop 

// Cvar Menu System
new g_ffcvarNames[MAX_CVARS][32]
new g_cvarMisc[MAX_CVARS][3]
new g_cvarCmd[MAX_CVARS*5][32]
new g_cvarCmdNum
new g_cvarNum

new g_menuPosition[33]
new g_menuSelect[33][64]
new g_menuSelectNum[33]

// Hud messages format
set_hudtype_punisdedmsg() set_hudmessage( 230, 75, 0, 0.05, 0.50, 2, 0.1, 3.0, 0.02, 0.02, 4)		// General punish
set_hudtype_timebomb() set_hudmessage(255,50,50, 0.03, 0.76, 2, 0.02, 2.0, 0.01, 0.1, 2)		// Timebomb
set_hudtype_bankick() set_hudmessage(225, 25, 25, -1.0, 0.32, 0, 2.0, 9.0, 0.8, 0.8, 2)			// Vote ban or kick warning

// Random glow
public glow_player(param[]){
	new randomred = random_num(0,255)
	new randomgreen = random_num(0,255)
	new randomblue = random_num(0,255)
	set_user_rendering(param[0],kRenderFxGlowShell,randomred,randomgreen,randomblue,kRenderNormal,16)
	return PLUGIN_HANDLED
}

// Bury Player
public bury_player(param[]){
	new origin[3]
	get_user_origin(param[0], origin)
	origin[2] -= 20
	set_user_origin(param[0], origin)
	client_cmd(param[0],"drop")
	client_cmd(param[0],"drop")
	return PLUGIN_HANDLED
}

// Un-Bury Player
public unbury_player(param[]){
	new origin[3]
	get_user_origin(param[0], origin)
	origin[2] += 30
	set_user_origin(param[0], origin)
	return PLUGIN_HANDLED
}

//slap player
public slap_player(param[]){
	if(Effectsonslap[param[0]] == YES){ // Add special effects to slap
		new origin[3]
		get_user_origin(param[0],origin)
		origin[2] = origin[2] - 26
		new sorigin[3]
		sorigin[0] = origin[0] + 150
		sorigin[1] = origin[1] + 150
		sorigin[2] = origin[2] + 400
		lightning(sorigin,origin)
		bloody(origin)
		emit_sound(0,CHAN_ITEM, "ambience/thunder_clap.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
	if(Spawnattacker[param[0]] == YES){ // Check if slapped for spawn attack
		client_cmd(param[0],"drop")
		client_cmd(param[0],"drop")
		new origin[3]
		get_user_origin(param[0], origin)
		new slapheight = random_num(20,50)
		origin[2] += slapheight
		set_user_origin(param[0], origin)
		Spawnattacker[param[0]] = NO
	}
	if(Slapcount[param[0]] == 1){ 
		set_task(5.0,"slap_player",12,param,2)  // Multiple slap player
		client_cmd(param[0],"drop")
		client_cmd(param[0],"drop")
		Slapcount[param[0]] = 0
	}	
	if(get_user_health(param[0]) < get_cvar_num("sv_slap") + 1){ // Make sure slap will not kill player
		user_slap(param[0],0)
	}
	else
	user_slap(param[0],get_cvar_num("sv_slap")) // slap killer
	return PLUGIN_HANDLED 
}

//  kill player
public kill_player(param[]){
	if(Effectsonkill[param[0]] == YES){ // Add special effects to kill
		new origin[3]
		get_user_origin(param[0],origin)
		origin[2] = origin[2] - 26
		new sorigin[3]
		sorigin[0] = origin[0] + 150
		sorigin[1] = origin[1] + 150
		sorigin[2] = origin[2] + 400
		blood(origin)
		bloody(origin)
		explode(origin,param[0])
	}
	user_kill(param[0])
	client_print(param[0],print_chat,"[AMX] You have been punished for team killing")
	return PLUGIN_CONTINUE
}

// vote kick player
public votekick_player(param[]){
	new Kickname[33]
	get_user_name(param[0],Kickname,32)
	client_cmd(0, "spk ^"warning idiot has reached checkpoint^"") 
	set_hudtype_bankick()
	show_hudmessage(0,"WARNING!!^nVote to kick %s for multiple Team Kills",Kickname)
	client_print(0,print_chat,"[AMX] Vote to kick %s for multiple Team Kills",Kickname)
	server_cmd("amx_votekick %s", Kickname) //set vote kick off
	Votetokick[param[0]] = NO
	return PLUGIN_CONTINUE
}

// Vote ban player
public voteban_player(param[0]){
	new Banname[33]
	get_user_name(param[0],Banname,32)
	//client_cmd(0,"spk ^"vox/warning^"")
	client_cmd(0, "spk ^"warning idiot has reached checkpoint^"") 
	set_hudtype_bankick()
	show_hudmessage(0,"WARNING!!^nVote to ban %s for multiple Team Kills",Banname)
	client_print(0,print_chat,"[AMX] Vote to ban %s for multiple Team Kills",Banname)
	server_cmd("amx_voteban %s", Banname) //set vote ban off
	Votetoban[param[0]] = NO
	return PLUGIN_CONTINUE
}
	
// Put in Prison
public prison_player(param[]){
if (file_exists("addons\amx\prison\prison.cor")){
			new readdata[50]
			new currentmap[32]
			new prisonlocation[3]
			new len
			get_mapname(currentmap,32)
			for(new i=0; i < 100 && read_file("addons\amx\prison\prison.cor",i,readdata,50,len) != 0; i += 1)
				{ 
				read_file("addons\amx\prison\prison.cor",i,readdata,50,len)
				new map[32]
				new x[12]
				new y[12]
				new z[12]
				parse(readdata,map,32,x,12,y,12,z,12)
				if(equal(map,currentmap)){
					prisonlocation[0] = str_to_num(x)
					prisonlocation[1] = str_to_num(y)
					prisonlocation[2] = str_to_num(z)
					}
				}
			get_user_origin(param[0],PreprisonOrigin[param[0]])
			PreprisonOrigin[param[0]][2] += 5
			engclient_cmd(param[0],"drop")
			engclient_cmd(param[0],"drop")
			engclient_cmd(param[0],"drop")
			set_user_origin(param[0],prisonlocation)
			client_cmd(0, "spk ^"located _comma _comma security will detain idiot^"")	
			new Kindex = param[0]
			PlayerIsprisoned[Kindex] = YES
			new SKindex[32]
			num_to_str(Kindex,SKindex,32)
			set_task(get_cvar_float("sv_prisontime"), "release_player",13,SKindex,32)
		}
	return PLUGIN_HANDLED 
}

// Prison release
public release_player(SKindex[])
{
	new Kindex = str_to_num(SKindex)
	new Kname[32]
	get_user_name(Kindex,Kname,32)
	if (is_user_alive(Kindex) == 1)
		if(PlayerIsprisoned[Kindex] == YES){	
			set_user_origin(Kindex,PreprisonOrigin[Kindex]) // Return player to origional position
			client_cmd(Kindex, "spk ^"security have authorized your release^"")
			PlayerIsprisoned[Kindex]=NO
			client_print(0,print_chat,"[AMX] %s has been released from prison", Kname)
		}
}

//  Timebomb Countdown
public timebomb_timer(param[]){
	new hibomb = 100
	new maxpl = get_maxplayers() +1
	new a
	for(a = 1; a < maxpl; a++) {
		if ((IsBomb[a] != 0) && (IsBomb[a] < hibomb)){
			hibomb = a
			}
		}
	for(a = 1; a < maxpl; a++) {
		if (IsBomb[a] > 0){
			emit_sound(a,CHAN_ITEM, "buttons/blip2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			if (IsBomb[a] == 1){
				blowem_up(a)
			}else{
				IsBomb[a] -= 1
				if (a == hibomb){
					new name[32]
					new team[32]
					get_user_name(a,name,32)
					get_user_team(a,team,32)
					if(equal(team,"T", 1)){
						set_hudmessage(200,0,0, 0.03, 0.76, 2, 0.02, 2.0, 0.01, 0.1, 2)
					}else{
						set_hudmessage(0,100,200, 0.03, 0.76, 2, 0.02, 2.0, 0.01, 0.1, 2)
						}
					show_hudmessage(0,"%s will explode in %d seconds.",name,IsBomb[a])
					if (IsBomb[a] == 11){
						client_cmd(0,"spk ^"fvox/remaining^"")
						}
					if (IsBomb[a] < 11){
						new temp[48]
						num_to_word(IsBomb[a],temp,48)
						client_cmd(0,"spk ^"fvox/%s^"",temp)
						}
					}
				if(is_user_alive(a) == 0){
					blowem_up(a)
					}
				}
			}
		}
	}

//  Timebomb Explode
public blowem_up(id){
	if(id == 100){
		new maxpl = get_maxplayers() +1
		for(new a = 1; a < maxpl; a++) {
			if ((IsBomb[a] > 0) || (IsKamik[a] == 1)){
				IsKamik[a] = 0
				IsBomb[a] = 0
				new name[32]
				get_user_name(a,name,32)
				set_user_rendering(a,kRenderFxNone,255,255,255, kRenderNormal,16)
				set_hudtype_timebomb()
				show_hudmessage(0,"%s has exploded.",name)
				new origin[3]
				get_user_origin(a,origin)
				origin[2] = origin[2] - 26
				user_kill(a,1)
				}
			}
		}else{
			if (IsBomb[id] > 0){
				new name[32]
				new team[32]
				get_user_name(id,name,32)
				set_user_rendering(id,kRenderFxNone,255,255,255, kRenderNormal,16)
				set_hudtype_timebomb()
				show_hudmessage(0,"%s has exploded.",name)
				set_cvar_string("mp_friendlyfire","1")
				ejl_ff = get_cvar_float("mp_friendlyfire")
				new origin[3]
				get_user_origin(id,origin)
				get_user_team(id, team , 32)
				new maxpl = get_maxplayers() +1
				for(new a = 1; a < maxpl; a++) {
					new origin1[3]
					new team1[32]
					get_user_origin(a,origin1)
					get_user_team(a, team1 , 32)
					if(is_user_alive(a) != 0){
						if( ! (origin[0]-origin1[0] > get_cvar_num("sv_bombrange") || origin[0]-origin1[0] < - get_cvar_num("sv_bombrange") ||
						origin[1]-origin1[1] > get_cvar_num("sv_bombrange") || origin[1]-origin1[1] < - get_cvar_num("sv_bombrange") ||
						origin[2]-origin1[2] > get_cvar_num("sv_bombrange") || origin[2]-origin1[2] < - get_cvar_num("sv_bombrange")) ){
							if(ejl_ff == 0){
								if(!equal(team, team1, 1)){
									client_print(a,print_chat,"[AMX] Sorry, the bomb killed you.")
									user_kill(a,1)
									a = id
									explode(origin1,id)
									}
								}
							if(ejl_ff == 1){
								if(rs == false){
									client_print(a,print_chat,"[AMX] Sorry, the bomb killed you.")
									if(a != id){
										explode(origin1,id)
										}
									user_kill(a,1)
								}else{
									client_print(a,print_chat,"[AMX] Sorry, the bomb killed you.")
									if(a == id)
									user_kill(a,1)
									}
								}
							}
						}
					}
				IsBomb[id] = 0
				IsKamik[id] = 0
				if(ejl_ff == 0){
					client_print(id,print_chat,"[AMX] Sorry, the bomb killed you.")
					user_kill(id,1)
					}
				origin[2] = origin[2] - 26
				explode(origin,id)
				set_cvar_string("mp_friendlyfire","1")
				}
			}
		}

// Main punishment menu format
public show_ffsystemenu(param[]){
	new ffsmenu[256], Kname[32]
	if(Teamkillcount[param[1]] > 1){
		format(ffsmenu,255,"\yFF Management Menu ^n^n\w1. Kill Now!^n2. Multiple Slap^n3. Set Glowing^n4. Bury Killer^n5. Put in Prison \r(45 Secs)\w^n6. Make TimeBomb \r (Evil)\w^n7. Give Bad Aim^n8. Punish Next Round^n^n\y9. Forgive Team Kill", Kname) 
		++Slapcount[param[1]]
		show_menu(param[0],((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)),ffsmenu)
	}
	else
	format(ffsmenu,255,"\yFF Management Menu ^n^n\w1. Kill Now!^n2. Slap Killer^n3. Set Glowing^n4. Bury Killer^n5. Put in Prison \r(45 Secs)\w^n6. Make TimeBomb \r (Evil)\w^n7. Give Bad Aim^n8. Punish Next Round^n^n\y9. Forgive Team Kill", Kname) 
	show_menu(param[0],((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)),ffsmenu) 
}

// Menu option 1 - kill now
public menu_option1(id,keys){
	if(is_user_alive(TeamKillers[id]) == NO){
		client_print(id,print_chat,"[AMX] Too late for any punishment!")
		return PLUGIN_HANDLED
	} 
	if (Punishnextround[TeamKillers[id]]) {
		Punishnextround[TeamKillers[id]] = NO
		Effectsonkill[TeamKillers[id]] = YES
		new Kname[32] 
		get_user_name(TeamKillers[id],Kname,31)
		new param[2]
		param[0] = TeamKillers[id]
		set_task(0.25,"kill_player",1,param,2)  // Kill player	
		if(get_cvar_num("sv_punishmessages") == HUD){
			set_hudtype_punisdedmsg()	
			show_hudmessage(0,"%s has been punished for team killing", Kname)
			return PLUGIN_HANDLED 
		}
	}
	return PLUGIN_HANDLED 
}

// Menu option 2 - Slap Killer
public menu_option2(id,keys){
	if(is_user_alive(TeamKillers[id]) == NO){
		client_print(id,print_chat,"[AMX] Too late for any punishment!")
		return PLUGIN_HANDLED
	} 
	if (Punishnextround[TeamKillers[id]]) {
		Punishnextround[TeamKillers[id]] = NO
		Effectsonslap[TeamKillers[id]] = YES
		new Kname[32] 
		get_user_name(TeamKillers[id],Kname,31)
		new param[2]
		param[0] = TeamKillers[id]
		set_task(0.25,"slap_player",2,param,2)  // Slap player		
		if(get_cvar_num("sv_punishmessages") == HUD){
			set_hudtype_punisdedmsg()	
			show_hudmessage(0,"%s has been slapped for team killing", Kname)
			return PLUGIN_HANDLED 
		}
		client_print(0,print_chat,"[AMX] %s has been slapped for team killing", Kname)
	}
	return PLUGIN_HANDLED 
}

// Menu option 3 - Set glowing
public menu_option3(id,keys){
	if(is_user_alive(TeamKillers[id]) == NO){
		client_print(id,print_chat,"[AMX] Too late for any punishment!")
		return PLUGIN_HANDLED
	}
	if (Punishnextround[TeamKillers[id]]) {
		Punishnextround[TeamKillers[id]] = NO 
		new Kname[32] 
		get_user_name(TeamKillers[id],Kname,31)
		new param[2]
		param[0] = TeamKillers[id]
		set_task(0.25,"glow_player",3,param,2)  // Set killer glowing
		if(get_cvar_num("sv_punishmessages") == HUD){
			set_hudtype_punisdedmsg()	
			show_hudmessage(0,"%s is now glowing for team killing", Kname)
			return PLUGIN_HANDLED 
		}
		client_print(0,print_chat,"[AMX] %s is now glowing for team killing", Kname)
	}
	return PLUGIN_HANDLED 
}

// Menu option 4 - Bury Killer
public menu_option4(id,keys){
	if(is_user_alive(TeamKillers[id]) == NO){
		client_print(id,print_chat,"[AMX] Too late for any punishment!")
		return PLUGIN_HANDLED
	}
	if (Punishnextround[TeamKillers[id]]) {
		Punishnextround[TeamKillers[id]] = NO 
		new Kname[32]
		get_user_name(TeamKillers[id],Kname,32)
		new param[2]
		param[0] = TeamKillers[id]
		set_task(0.25,"bury_player",4,param,2)  // Bury killer
		if(get_cvar_num("sv_punishmessages") == HUD){
			set_hudtype_punisdedmsg()	
			show_hudmessage(0,"%s has been burried for team killing", Kname)
			return PLUGIN_HANDLED 
		}
		client_print(0,print_chat,"[AMX] %s has been burried for team killing", Kname)
	}
	return PLUGIN_HANDLED 
}

// Menu option 5 - Put in prison
public menu_option5(id,keys){
	if(is_user_alive(TeamKillers[id]) == NO){
		client_print(id,print_chat,"[AMX] Too late for any punishment!")
		return PLUGIN_HANDLED
	} 
	if (Punishnextround[TeamKillers[id]]) {
		Punishnextround[TeamKillers[id]] = NO 
		new Kname[33]
		get_user_name(TeamKillers[id],Kname,31)
		client_print(TeamKillers[id],print_chat,"[AMX] %s put you behind bars as punishment", Kname)
		set_hudtype_punisdedmsg()
		show_hudmessage(0,"%s is now is prison for killing team mates", Kname)
		new param[2]
		param[0] = TeamKillers[id]
		set_task(0.25,"prison_player",5,param,2)  // Prison killer (sv_prisontime)
	}
	return PLUGIN_HANDLED 
}

// Menu option 6 - Make timebomb
public menu_option6(id,keys){
	if(is_user_alive(TeamKillers[id]) == NO){
		client_print(id,print_chat,"[AMX] Too late for any punishment!")
		return PLUGIN_HANDLED
	} 
	if (Punishnextround[TeamKillers[id]]) {
		Punishnextround[TeamKillers[id]] = NO 
		new Vname[32], Kname[33]
		get_user_name(TeamKillers[id],Vname,32)
		get_user_name(TeamKillers[id],Kname,32)
		client_print(TeamKillers[id],print_chat,"[AMX] %s turned you into a walking timebomb", Vname)
		new param[2]
		param[0] = TeamKillers[id]
		IsBomb[param[0]] = BOMB_FUSE
		client_cmd(0,"spk ^"vox/warning _comma _comma detonation device activated^"")
		client_print(0,print_chat,"[AMX] %s has become a human timebomb, run for cover!!!", Kname)
	}
	return PLUGIN_HANDLED 
}

// Menu option 7 - Give bad aim
public menu_option7(id,keys){
	if(is_user_alive(TeamKillers[id]) == NO){
		client_print(id,print_chat,"[AMX] Too late for any punishment!")
		return PLUGIN_HANDLED
	} 
	if (Punishnextround[TeamKillers[id]]) {
		Punishnextround[TeamKillers[id]] = NO 
		new Kname[32]
		get_user_name(TeamKillers[id],Kname,32)
		new randombodypart = random_num(1,3) // randomze killers aim
		if(randombodypart == 1){
			set_user_hitzones(TeamKillers[id],Legs)
		}
		if(randombodypart == 2){
			set_user_hitzones(TeamKillers[id],Arms)
		}
		if(randombodypart == 3){
			set_user_hitzones(TeamKillers[id],Stomach)
		}
		if(get_cvar_num("sv_punishmessages") == HUD){
			set_hudtype_punisdedmsg()	
			show_hudmessage(0,"%s has been given bad aim as punishment", Kname)
			return PLUGIN_HANDLED 
		}
		client_print(0,print_chat,"[AMX] %s has been given bad aim as punishment", Kname)
	}
	return PLUGIN_HANDLED 
}

// Menu option 8 - Punish next round
public menu_option8(id,keys){ 
	if(is_user_alive(TeamKillers[id]) == NO){
		client_print(id,print_chat,"[AMX] Too late for any punishment!")
		return PLUGIN_HANDLED
	}
	if (Punishnextround[TeamKillers[id]]) { 
		new Kname[32]
		get_user_name(TeamKillers[id],Kname,32)
		if(get_cvar_num("sv_punishmessages") == HUD){
			set_hudtype_punisdedmsg()
			show_hudmessage(0,"%s will be punished next round", Kname)
			return PLUGIN_HANDLED 
		}
		client_print(0,print_chat,"[AMX] %s has been given bad aim as punishment", Kname)
	}
	return PLUGIN_HANDLED 
}

// Menu option 9 - Forgive team kill
public menu_option9(id,keys){
	if(is_user_alive(TeamKillers[id]) == NO){
		client_print(id,print_chat,"[AMX] Too late to forgive team kill!")
		return PLUGIN_HANDLED
	} 
	if (Punishnextround[TeamKillers[id]]) { 
		Punishnextround[TeamKillers[id]] = NO
		if(get_cvar_num("sv_forgivetk") == ON){
			--Teamkillcount[TeamKillers[id]]
		}
		new Vname[32], Kname[33]
		get_user_name(id,Vname,32)
		get_user_name(TeamKillers[id],Kname,32)
		if(get_cvar_num("sv_punishmessages") == HUD){
			set_hudtype_punisdedmsg()	
			show_hudmessage(0,"%s has forgiven %s isnt that nice!", Vname, Kname)
			return PLUGIN_HANDLED 
		}
		client_print(0,print_chat,"[AMX] %s has forgiven %s isnt that nice!", Vname, Kname)
	}		
	return PLUGIN_HANDLED 
}

//  Handle player death events
public playerdeath(id){
	if(get_cvar_num("sv_ffmode") == OFF){
	return PLUGIN_HANDLED
	}
	new Killer = read_data(1)
	new Victim = read_data(2)
	if ( Killer && (Killer!=Victim) && (get_user_team(Killer)==get_user_team(Victim)) ) { // Check Killer & Victim on same team
		TeamKillers[Victim] = Killer
		if(get_cvar_num("sv_adminimmune") == ON){
			if (get_user_flags(Killer)&ADMIN_IMMUNITY){
				new Kname[33]
				get_user_name(Killer,Kname,32)
				client_print(Victim,print_chat,"[AMX] %s has Admin Immunity and will not be punished", Kname)
				return PLUGIN_HANDLED //Checked admin immnunity
			}
		}
		Punishnextround[Killer] = YES // Killer to be punished next round
		if(get_cvar_num("sv_allowban") == ON){
			++Teamkillcount[Killer]
			if(Teamkillcount[Killer] == get_cvar_num("sv_bancount")){
				Votetoban[Killer] = YES
			}
		}
		new param[2]
		param[0] = Victim
		param[1] = Killer 
		if(get_cvar_num("sv_warcraft3") == 1){ // WarCraft 3 XP Enabled delay revenge menu
			set_task(5.0,"show_ffsystemenu",6,param,2) // Delayed Menu by 5 seconds
			set_hudmessage(0, 80, 255, -1.0, 0.32, 0, 2.0, 4.0, 0.8, 0.8, 4)
			show_hudmessage(Victim,"** Delaying Punishment Menu for warcraft3 skills selection **")
			
			}
		else
			set_task(0.2,"show_ffsystemenu",7,param,2) // Menu shown directly after death
		}
	return PLUGIN_CONTINUE
}

public damage_event(){
		if(get_cvar_num("sv_ffmode") == ON){
			new Victim = read_data(0)
			new Attacker = get_user_attacker(Victim)
			if(get_cvar_num("sv_adminimmune") == ON){
				if (get_user_flags(Attacker)&ADMIN_IMMUNITY){
					return PLUGIN_HANDLED //Checked admin immnunity
				}
			}			
			if (Attacker && (Attacker!=Victim) ){
				if (get_user_team(Attacker)==get_user_team(Victim)){
					if(get_cvar_num("sv_allowkick") == ON){
						++Teamattackcount[Attacker]
						++Playerattackcount[Victim]
						if(Teamattackcount[Attacker] == get_cvar_num("sv_teamattackcount")){
							Votetokick[Attacker] = YES
							}				
						}
					if (sv_spawn > get_gametime()){
						new param[2]
						param[0] = Attacker
						get_user_health(Victim)
						set_user_health(Victim,100)
						new Varmor = get_user_armor(Victim)
						if (Varmor > 1){
						set_user_armor(Victim, 100)
						return PLUGIN_CONTINUE
						}
						if(get_cvar_num("sv_spawnpunish") == 0){ //	Spawn punish handle type 0 - warn player
							client_print(param[0],print_chat,"[AMX] STOP ATTACKING TEAM MATES! You may be punished!")
						}
						if(get_cvar_num("sv_spawnpunish") == 1){ // Spawn punish handle type 1 - slap player
							set_task(0.05,"slap_player",14,param,2)  // Slap player
							Spawnattacker[param[0]] = YES
						}
						if(get_cvar_num("sv_spawnpunish") == 2){ //	Spawn punish handle type 2 - kill player
							set_task(0.05,"kill_player",15,param,2)  // Kill player
							Effectsonkill[param[0]] = YES
						}
						if(get_cvar_num("sv_spawnpunish") == 3){ //	Spawn punish handle type 3 - bury player
							set_task(0.05,"bury_player",16,param,2)  // Bury player
							set_task(30.0,"unbury_player",20,param,2)  // Un bury player
						}
						if(get_cvar_num("sv_spawnpunish") == 4){ //	Spawn punish handle type 4 - Prison player
							set_task(0.25,"prison_player",17,param,2)  // Prison player (sv_prisontime)
						return PLUGIN_HANDLED
						}
					}
				}
			}
		}
	return PLUGIN_HANDLED
}
	

//  Spawn protection handling
public new_roundtime(){
	sv_spawn = get_gametime() + get_cvar_float("sv_spawn")
} 

public roundtime(id) {
	new remaining = read_data(1)
	if (remaining == get_cvar_float("mp_roundtime") * 60) {
		new_roundtime()
	}
	return PLUGIN_CONTINUE
} 

//  Punish next round handling
public new_round(id){
	remove_task(13) // Remove prison relase task
	remove_task(12) // Remove multiple slap task 
	if(get_cvar_num("sv_spawnpunish") > 0){
		if(get_cvar_num("sv_spawn") > 0){
			client_print(id,print_chat,"[AMX] Spawn protection is enabled DO NOT attack your Team Mates ")
		}
	}
	if(get_cvar_num("sv_allowban") == ON){
		if(Teamkillcount[id] > 0){
			if(Teamkillcount[id] < get_cvar_num("sv_bancount")){
			client_print(id,print_chat,"[AMX] You have killed %i out of %i team mates, be careful", Teamkillcount[id], get_cvar_num("sv_bancount"))
			}
			else
			client_print(id,print_chat,"[AMX] You have killed too many team mates, vote to ban will start")
		}
		if(Votetokick[id] == YES){ // Check total tk's and vote to kick
			new Kparam[2]
			Kparam[0] = id 
			set_task(6.0,"votekick_player",18,Kparam,2)  // Vote to kick player
			set_task(4.0,"bury_player",19,Kparam,2)  // Bury player during vote
			Teamattackcount[Kparam[0]] = 0
			}
		if(Votetoban[id] == YES){ // Check total tk's and vote to ban
			new Bparam[2]
			Bparam[0] = id 
			set_task(6.0,"voteban_player",8,Bparam,2)  // Vote to ban player
			set_task(4.0,"bury_player",2,Bparam,2)  // Bury player during vote
			Teamkillcount[Bparam[0]] = 0
			}
		if(Punishnextround[id]){
			Punishnextround[id] = NO // Reset punish on next round
			new param[2]
			param[0] = id
			set_task(7.0,"kill_player",9,param,2) // set task for punish next round delayed kill
			set_task(0.25,"glow_player",10,param,2)  // Player to be punished glows red untill death
			}
		remove_task(6)
		set_user_rendering(id)
		new param[2]
		param[0] = id
		}
	return PLUGIN_HANDLED
}


// FF autoreply 
public reply_ff(id){ 
    
   if(get_cvar_num("mp_friendlyfire") == OFF){ 
      set_hudmessage(50,255,50, 0.05, 0.50, 2, 0.1, 4.0, 0.02, 0.02, 10)  
      show_hudmessage(id,"Friendly Fire is OFF^nShoot what you like!") 
      } 
      else 
      {      
      set_hudmessage(255,50,50, 0.05, 0.50, 2, 0.1, 4.0, 0.02, 0.02, 10)  
      show_hudmessage(id,"Friendly Fire is ON^nWatch your fire!")          
   } 
   return PLUGIN_HANDLED 
}


//  Set levels for new players
public client_connect(id){
	Punishnextround[id] = NO
	Votetoban[id] = NO
	Teamkillcount[id] = 0
	Teamattackcount[id] = 0
	Playerattackcount[id] = 0
	Slapcount[id] = 0
	return PLUGIN_CONTINUE
}

//  Set levels for leaving players
public client_disconnect(id){
	Punishnextround[id] = NO
	Votetoban[id] = NO
	Teamkillcount[id] = 0
	Teamattackcount[id] = 0
	Playerattackcount[id] = 0
	Slapcount[id] = 0
	return PLUGIN_CONTINUE
}

// Start of Cvar Menu 
public actionffCvarMenu(id,key)
{
	switch(key){
	case 8: displayCvarMenu(id,++g_menuPosition[id])
	case 9:	displayCvarMenu(id,--g_menuPosition[id])
	default:{

			new option = g_menuSelect[ id ][ g_menuPosition[id] * 8 + key ]
						
			new szValue[32]
			get_cvar_string( g_ffcvarNames[ option ], szValue ,31)
			
			new end = g_cvarMisc[ option ][ 2 ]
			new start = g_cvarMisc[ option ][ 1 ]
			
			for(new i = start ; ; ++i )
			{
				if ( i < end )
				{
					if ( equal( szValue , g_cvarCmd[ i  ]  ) )	
					{
						if (++i >= end)		
						{
							i = start
						}
						set_cvar_string( g_ffcvarNames[ option ], g_cvarCmd[ i ] )
						break
					}
				}
				else
				{
					set_cvar_string( g_ffcvarNames[ option ], g_cvarCmd[ start ] )
					break
				}
			}			
			
			displayCvarMenu(id, g_menuPosition[id] )
		}
	}
	return PLUGIN_HANDLED
}


displayCvarMenu(id,pos){

	if (pos < 0)	return
		
	new menuBody[512]
	new b = 0
	new start = pos * 8
	
	if (start >= g_menuSelectNum[id])
		start = pos = g_menuPosition[id] = 0
		
	new len = format(menuBody,511,"\yFF Cvar Menu\R%d/%d^n\w^n",
		pos+1,(  g_menuSelectNum[id] / 8 + ((g_menuSelectNum[id] % 8) ? 1 : 0 )) )
		
	new end = start + 8
	new keys = (1<<9)
	new szValue[64]
	
	if (end > g_menuSelectNum[id])
		end = g_menuSelectNum[id]
		
	for(new a = start; a < end; ++a)
	{
		get_cvar_string( g_ffcvarNames[ g_menuSelect[id][ a ] ],szValue,31)
		keys |= (1<<b)
		len += format(menuBody[len],511-len,"%d. %s\R%s^n\w",
			++b, g_ffcvarNames[ g_menuSelect[id][ a ] ], szValue )
	}
			
	if (end != g_menuSelectNum[id])
	{
		len += format(menuBody[len],511-len,"\y^n9. More...^n0. Back")
		keys |= (1<<8)
	}
	else
	{
		len += format(menuBody[len],511-len,"\y^n0. Back")
	}
	
	show_menu(id,keys,menuBody)
}

public ffCvarMenu(id,level,cid)
{
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	
	new flags = get_user_flags(id)
	
	g_menuSelectNum[id] = 0
	
	for(new a = 0; a < g_cvarNum; ++a)
		if ( g_cvarMisc[ a ][0] & flags )
			g_menuSelect[id][ g_menuSelectNum[id]++ ] = a
		
	displayCvarMenu(id,g_menuPosition[id] = 0)
	
	return PLUGIN_HANDLED
}

loadCvarSettings( szFilename[] )
{
	if ( !file_exists ( szFilename ) ) 
		return 0
	
	new text[256], szValues[12][32]
	new inum , a,  pos = 0
	new cvar_values = MAX_CVARS * 5
	// a b c d
	while ( g_cvarNum < MAX_CVARS && read_file (szFilename,pos++,text,255,a) )
	{
		if ( text[0] == ';' ) continue
		
		inum = parse( text , g_ffcvarNames[ g_cvarNum ] , 31 ,
			szValues[0] ,31 , szValues[1] ,31 , szValues[2] ,31 ,
			szValues[3] ,31 , szValues[4] ,31 , szValues[5] ,31 ,
			szValues[6] ,31 , szValues[7] ,31 , szValues[8] ,31 ,
			szValues[9] ,31 , szValues[10] ,31 , szValues[11] ,31 )
					
		inum -= 2
					
		if ( inum < 2 ) continue
		
		g_cvarMisc[ g_cvarNum ][1] = g_cvarCmdNum
			
		for( a = 0 ; a < inum && g_cvarCmdNum < cvar_values ; ++a )
		{
				while ( replace( szValues[ a ] ,31 , "\'" , "^"" ) ) {
					// do nothing
				}
				
				copy ( g_cvarCmd[ g_cvarCmdNum ] , 31 , szValues[ a ]  )
				g_cvarCmdNum++
		}
		
		g_cvarMisc[ g_cvarNum ][2] = g_cvarCmdNum
		g_cvarMisc[ g_cvarNum ][0] = read_flags( szValues[ inum ] )			
		g_cvarNum++
		
	}
	
	return 1
}

explode(vec1[3],id){ 
   // blast circles 
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1) 
   write_byte( 21 ) 
   write_coord(vec1[0]) 
   write_coord(vec1[1]) 
   write_coord(vec1[2] + 16) 
   write_coord(vec1[0]) 
   write_coord(vec1[1]) 
   write_coord(vec1[2] + 1936) 
   write_short( white ) 
   write_byte( 0 ) // startframe 
   write_byte( 0 ) // framerate 
   write_byte( 3 ) // life 2 
   write_byte( 20 ) // width 16 
   write_byte( 0 ) // noise 
   write_byte( 188 ) // r 
   write_byte( 220 ) // g 
   write_byte( 255 ) // b 
   write_byte( 255 ) //brightness 
   write_byte( 0 ) // speed 
   message_end() 
     
   //Explosion2 
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
   write_byte( 12 ) 
   write_coord(vec1[0]) 
   write_coord(vec1[1]) 
   write_coord(vec1[2]) 
   write_byte( 188 ) // byte (scale in 0.1's) 188 
   write_byte( 10 ) // byte (framerate) 
   message_end() 

   //TE_Explosion 
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1) 
   write_byte( 3 ) 
   write_coord(vec1[0]) 
   write_coord(vec1[1]) 
   write_coord(vec1[2]) 
   write_short( fire ) 
   write_byte( 65 ) // byte (scale in 0.1's) 188 
   write_byte( 10 ) // byte (framerate) 
   write_byte( 0 ) // byte flags 
   message_end() 

   //TE_KILLPLAYERATTACHMENTS 
   message_begin(MSG_BROADCAST,SVC_TEMPENTITY,{0,0,0},id) 
   write_byte( 125 ) // will expire all TENTS attached to a player. 
   write_byte( id ) // byte (entity index of player) 
   message_end() 

   //Smoke 
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1) 
   write_byte( 5 ) // 5 
   write_coord(vec1[0]) 
   write_coord(vec1[1]) 
   write_coord(vec1[2]) 
   write_short( smoke ) 
   write_byte( 20 )  // 2 
   write_byte( 10 )  // 10 
   message_end() 
}

blood(vec1[3])
{

//LAVASPLASH
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( 10 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	message_end()
}

bloody(vec1[3])
{
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
	write_byte( 115 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2] +25)
	write_short( bloodspray )
	write_short( blooddrop )
	write_byte( 70 )	// color index
	write_byte( 15 )	// size
	message_end()
}

lightning(vec1[3],vec2[3])
{ 
//Lightning
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( 0 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_coord(vec2[0])
	write_coord(vec2[1])
	write_coord(vec2[2])
	write_short( light )
	write_byte( 1 )	// framestart
	write_byte( 5 )	// framerate]
	write_byte( 2 )	// life
	write_byte( 20 ) // width
	write_byte( 30 ) // noise
	write_byte( 12 ) // r, g, b
	write_byte( 50 ) // r, g, b
	write_byte( 200 ) // r, g, b
	write_byte( 200 ) // brightness
	write_byte( 200 ) // speed
	message_end()

//Sparks
	message_begin( MSG_PVS, SVC_TEMPENTITY,vec2)
	write_byte( 9 )
	write_coord( vec2[0] )
	write_coord( vec2[1] )
	write_coord( vec2[2] )
	message_end()
} 

public plugin_precache(){ 
	precache_sound( "ambience/thunder_clap.wav")
	precache_sound( "weapons/headshot2.wav")
    precache_sound( "buttons/blip2.wav") 
	smoke = precache_model("sprites/steam1.spr")
	light = precache_model("sprites/lgtning.spr")
	white = precache_model("sprites/white.spr")
    fire = precache_model("sprites/explode1.spr") 
	bloodspray = precache_model("sprites/bloodspray.spr")
	blooddrop = precache_model("sprites/blood.spr")  
    return PLUGIN_CONTINUE 
}

// Initialize Event Commands & Menus
public plugin_init(){
	register_plugin("FF Management","1.42b","Rav")
	register_cvar("sv_ffmanagemnet", "1.42b",FCVAR_SERVER)
	// Main Punishment Menu
	Fmenu = register_menuid("\yFF Management Menu") 
	register_menucmd(Fmenu,(1<<0),"menu_option1") 
	register_menucmd(Fmenu,(1<<1),"menu_option2") 
	register_menucmd(Fmenu,(1<<2),"menu_option3")    
	register_menucmd(Fmenu,(1<<3),"menu_option4")
	register_menucmd(Fmenu,(1<<4),"menu_option5")
	register_menucmd(Fmenu,(1<<5),"menu_option6")
	register_menucmd(Fmenu,(1<<6),"menu_option7")
	register_menucmd(Fmenu,(1<<7),"menu_option8")
	register_menucmd(Fmenu,(1<<8),"menu_option9")
	// Catch Game Events
	register_event("DeathMsg","playerdeath","a")		// Death of player handling
	register_event("ResetHUD","new_round","b")			// Reset Round - Next Round Handling	 
	server_cmd("exec addons/amx/ffconfig.cfg") 			// Execute All CVAR Settings
	register_event("RoundTime", "roundtime", "bc")  	// Round Timing
	register_event("Damage", "damage_event", "b", "2!0")// Catch damage events
	// Register Plugin Cvars and Settings
	register_cvar("sv_adminimmune", "0.0")				// Admins immune to punishment menu (1 enabled)
	register_cvar("sv_ffmode", "1.0")					// Enable or Disbale revenge system & Menu
	register_cvar("sv_prisontime", "45.0")				// Number of seconds killer is in prison for
	register_cvar("sv_slap", "50.0")					// Amount of damage when slapped
	register_cvar("sv_allowban", "1.0")					// Enable ban system
	register_cvar("sv_allowkick", "1.0")				// Enable kick system
	register_cvar("sv_bancount", "4.0")					// Total TK's before vote for ban
	register_cvar("sv_teamattackcount", "40.0")			// Total team attacks before vote to kick
	register_cvar("sv_bombrange", "4.0")				// Reange of timebomb
	register_cvar("sv_spawn", "10.0")					// Spawn safety time limit
	register_cvar("sv_spawnpunish", "1.0")				// Spawn safety type
	register_cvar("sv_punishmessages", "1.0")			// Punish messages in HUD or CHAT
	register_cvar("sv_forgivetk", "1.0")				// Forgive Tk (not counted towards killers total)
	// Tasks
	set_task(1.0,"timebomb_timer",11,"",0,"a",9999)		// Time Bomb Task
	// Cvar Menu
	register_menucmd(register_menuid("\yFF Cvar Menu"),1023,"actionffCvarMenu")		
	register_clcmd("amx_ffmenu","ffCvarMenu",ADMIN_CVAR,"- displays ff cvars menu menu")		
	loadCvarSettings("addons/amx/ffcvars.ini")
	// FF Reply
	register_clcmd("say ff","reply_ff") 
   	register_clcmd("say ffon","reply_ff") 
	return PLUGIN_CONTINUE
}

