/*************************************************************
**Weapon Kickback v 1.3***************************************
*****by PaintLancer*******************************************
***ver 1.0 -just support awp**********************************
***ver 1.1 -supports all guns with own force lvl and list*****
***ver 1.2 -made little more efficient************************
***ver 1.3 -added reset option for everything or certain gun**
*************************************************************/
 
#include <amxmod> 
#include <amxmisc>
#include <Vexd_Utilities>

stock get_user_velocity(id, velocity[3]) {
  new Float:vel[3]
  entity_get_vector(id, EV_VEC_velocity, vel)
  FVecIVec(vel, velocity)
}

new lastammo[33] 
new lastweap[33]
new bool:gmode
new kbWeapon[21]
new kbForce[21]
new gunswkb = 0 
new weaponString[50]
new weaponNumbers[] = "\ 
   SCOUT          3^n\ 
   XM1014         5^n\ 
   MAC10          7^n\ 
   AUG            8^n\ 
   ELITE         10^n\ 
   FIVESEVEN     11^n\ 
   UMP45         12^n\ 
   SG550         13^n\ 
   USP           16^n\ 
   GLOCK18       17^n\ 
   AWP           18^n\ 
   MP5NAVY       19^n\ 
   M249          20^n\ 
   M3            21^n\ 
   M4A1          22^n\ 
   TMP           23^n\ 
   G3SG1         24^n\ 
   DEAGLE        26^n\ 
   SG552         27^n\ 
   AK47          28^n\ 
   P90           30"  

public plugin_init()
{ 
	register_plugin("Weapon KickBack","1.3","PaintLancer") 
	register_event("CurWeapon", "kickback", "be", "1=1") 
	register_concmd("amx_kickback","set",ADMIN_LEVEL_B," <weaponnumber|list|on|off|reset> <force 50-1000|reset>") 
	register_cvar("amx_kickback_defpwr","50") 
	set_cvar_string("amx_kickback_defpwr","50") 
	return PLUGIN_CONTINUE 
}

public set(id,level,cid) 
{ 
   	if (!cmd_access(id,level,cid,2)) 
   	{ 
      	return PLUGIN_HANDLED 
   	} 

   	new bool:originalState = gmode

   	if (read_argc() > 4) 
   	{ 
      	console_print(id,"[AMX] Use:  amx_kickback <weaponnumber|list|on|off|reset> <force 50-1000|reset>") 
      	return PLUGIN_HANDLED 
   	} 

   	new arg1[7], arg2[7]   	 
	read_argv(1,arg1,6)
	read_argv(2,arg2,6)		
	strtolower(arg1) 
	strtolower(arg2)
	if (equal(arg1,"list")) //if first arg is list just handle this
   	{ 
      		if (id >= 1 && id <= 32) 
         		show_motd(id,weaponNumbers,"Weapon Kickback") 
      		else 
         		console_print(id,weaponNumbers)
		return PLUGIN_HANDLED 
   	}
   	else if (equal(arg1,"off")) //disable totally
   	{ 
      		if (!gmode)
		{ 
        		console_print(id,"[AMX] Kickback is already off.") 
         		return PLUGIN_HANDLED 
      		} 
      		else 
		{ 
         		gmode = false 
      		} 
   	} 
	else if(equal(arg1,"reset"))
	{
		gunswkb = 0
		console_print(id,"[AMX] Kickback has been reset")
		return PLUGIN_HANDLED 
   	}
   	else if(equal(arg1,"on")) //enable totally
   	{
		if (gmode)
		{ 
        		console_print(id,"[AMX] Kickback is already on.") 
         		return PLUGIN_HANDLED 
		} 
      		else 
		{ 
         		gmode = true 
      		}
   	}	
   	else
	{ 
      		new wpnNumber = str_to_num(arg1) 
		new check = haskickback(wpnNumber)
		new forceNum = str_to_num(arg2)
		
		if (equal(arg2,"reset"))
		{
			setWeapon(wpnNumber,forceNum)
			if(check < 0)
			{				
				console_print(id,"[AMX] %c%s doesn't have any Kickback to reset",weaponString[7] - 32,weaponString[8])
				return PLUGIN_HANDLED
			}
			deleteWeaponkb(wpnNumber)
			client_print(0,print_chat,"[AMX]  Kickback for %c%s has been turned OFF",weaponString[7] - 32,weaponString[8])
			console_print(id,"[AMX] Kickback has been removed from %c%s ",weaponString[7] - 32,weaponString[8])			
			return PLUGIN_HANDLED			
		}				
		else if(check >= 0)
		{
			if(forceNum < 50 || forceNum > 1000)
			{ 
				forceNum = get_cvar_num("amx_kickback_defpwr")
				console_print(id,"[AMX] Force set to default(%d)",forceNum)							
			}
			setWeapon(wpnNumber,forceNum)
			kbForce[check] = forceNum
			console_print(id,"[AMX] Force for %c%s has been changed",weaponString[7] - 32,weaponString[8])
			client_print(0,print_chat,"[AMX]  Kickback force for %c%s has changed!",weaponString[7] - 32,weaponString[8])
			return PLUGIN_HANDLED 
		}		
		else if (setWeapon(wpnNumber,forceNum))
		{
			if(forceNum < 50 || forceNum > 1000)
			{ 
				forceNum = get_cvar_num("amx_kickback_defpwr")
				console_print(id,"[AMX] Force set to default(%d)",forceNum)							
			}				
			gmode = true
			client_print(0,print_chat,"[AMX]  Kickback for %c%s has been turned ON",weaponString[7] - 32,weaponString[8])     
		}		 
      		else 
        	console_print(id,"[AMX] Use : amx_kickback <weaponnumber|list|on|off|reset> <force 50-1000|reset>") 
   	}  	    
   	if (originalState != gmode) 
   	{ 
      		if (gmode)
		{          
            		client_print(0,print_chat,"[AMX]  Weapon Kickback has been ENABLED") 
      		} 
      		else
		{ 
        		client_print(0,print_chat,"[AMX]  Weapon Kickback has been DISABLED")  
      		} 
   	}    
	return PLUGIN_HANDLED 
}

public deleteWeaponkb(wpnNumber)
{
	new dgun = haskickback(wpnNumber)
	if(dgun != gunswkb)	
	{	
		for(new i = dgun; i < gunswkb - 1; i++)
		{
			kbWeapon[i] = kbWeapon[i+1]
			kbForce[i] = kbForce[i+1]	
		}
	}
	gunswkb--
}

public setWeapon(newWeapon,newForce)
{ 
   	new returnValue = 0 
	if (newWeapon < 1 || newWeapon > 30 
   	|| newWeapon == 2 || newWeapon == 14 || newWeapon == 15 
   	|| newWeapon == CSW_C4 
   	|| newWeapon == CSW_HEGRENADE 
   	|| newWeapon == CSW_SMOKEGRENADE 
   	|| newWeapon == CSW_FLASHBANG) 
   	{} 
	else 
   	{ 		
		kbWeapon[gunswkb] = newWeapon
		kbForce[gunswkb] = newForce      		
		setWpnString(gunswkb)		
		gunswkb++
		//client_print(1,print_chat,"%d %d %d",gunswkb,kbWeapon[gunswkb],kbForce[gunswkb]) //debug check
	     	returnValue = 1 
   	}
	return returnValue 
} 

public setWpnString(num) 
{ 
   	switch (kbWeapon[num]) 
   	{ 
		case CSW_P228           : weaponString = "weapon_p228" 
      		case CSW_SCOUT          : weaponString = "weapon_scout" 
	      	case CSW_XM1014         : weaponString = "weapon_xm1014" 
      		case CSW_MAC10          : weaponString = "weapon_mac10" 
	      	case CSW_AUG            : weaponString = "weapon_aug" 
      		case CSW_ELITE         : weaponString = "weapon_elite" 
	      	case CSW_FIVESEVEN      : weaponString = "weapon_fiveseven" 
      		case CSW_UMP45         : weaponString = "weapon_ump45" 
	      	case CSW_SG550         : weaponString = "weapon_sg550" 
      		case CSW_USP         : weaponString = "weapon_usp" 
	      	case CSW_GLOCK18      : weaponString = "weapon_glock18" 
      		case CSW_AWP         : weaponString = "weapon_awp" 
	      	case CSW_MP5NAVY      : weaponString = "weapon_mp5navy" 
      		case CSW_M249         : weaponString = "weapon_m249" 
	      	case CSW_M3            : weaponString = "weapon_m3" 
      		case CSW_M4A1         : weaponString = "weapon_m4a1" 
	      	case CSW_TMP         : weaponString = "weapon_tmp" 
      		case CSW_G3SG1         : weaponString = "weapon_g3sg1" 
	      	case CSW_DEAGLE         : weaponString = "weapon_deagle" 
      		case CSW_SG552         : weaponString = "weapon_sg552" 
	      	case CSW_AK47         : weaponString = "weapon_ak47" 
      		case CSW_KNIFE         : weaponString = "weapon_knife" 
	      	case CSW_P90         : weaponString = "weapon_p90" 
      		default               : 
	      	{} 
	}    
}

public kickback(id)
{
	if (!gmode) return PLUGIN_CONTINUE

	new weap = read_data(2) // id of the weapon
	new windex = haskickback(weap)

	if (windex == -1) return PLUGIN_CONTINUE	

	new ammo = read_data(3) // ammo left in clip
	new force = kbForce[windex]	
	
	if ((weap == kbWeapon[windex]) && (lastammo[id] > ammo) && (lastweap[id] == weap))
	{ 
		new Float:velocity[3] 
		new curvelocity[3]	
	
		//client_print(id,print_chat,"FING GOING!! weap = %d ammo = %d guns = %d",weap, ammo, gunswkb) //debug check

		VelocityByAim(id, 0 - force, velocity)
		get_user_velocity(id,curvelocity) //keeps the velocity your already going at so its not so choppy
		velocity[2] = velocity[2] + curvelocity[2] //z axis
		velocity[1] = velocity[1] + curvelocity[1] //y axis  
		velocity[0] = velocity[0] + curvelocity[0] //x axis
		Entvars_Set_Vector(id, EV_VEC_velocity, velocity)		
	}
	lastammo[id] = ammo 
	lastweap[id] = weap 

	return PLUGIN_HANDLED
}

public haskickback(weapon) //if weapon has kickback returns its index in gunswkb else -1
{
	for(new i = 0; i < gunswkb; i++)
	{
		if(weapon == kbWeapon[i])
			return i 
	}
	return -1
}
