/* AMX Mod script. 
* 
* AMX RANDOM PASSWORD (amx_rndpass)
* 
* (c) Copyright 2003 by Marach (marach@phreaker.net, ICQ: 242122535, AIM: marach24, MSN IM: marach24@hotmail.com)
* 
* This file is provided as is (no warranties). 
*
* Usage:
*	- open file addons\amx\admin.cfg
*	- add this line to admin.cfg to make a list of passwords:
*		amx_rndpass_list pass1 pass2 pass3 ...
*		(where 'passX' is the password you're adding to the list)
*	- save the changes to file admin.cfg :)
*	- when playing on server just enter this command in console:
* 		amx_rndpass
*
* Random password from the list will be set and announced. Plugin will also 
* set 'password' CVAR at all clients to match the current server password.
* So if a player needs to reconnect he'll already have the correct password
* set and will be able to connect to the server.
*
* Example (admin.cfg):
* 	amx_rndpass_list cw war fight fw private
* 
* This will add five password to the list. Plugin will choose one password
* of all five when 'amx_rndpass' command is executed.
*
* To do:
*	- make plugin able to generate new random passwords instead of only choosing them from the list
* 	- new random password generation by user's criteria (number of characters, character set, etc.)
*/

#include <amxmod> 
#include <amxmisc> 

#define MAX_PWDS 32

new pwds[MAX_PWDS][32]
new pwdpos = 0

public amx_rndpass(id, level, cid) { 
	if (!cmd_access(id, level, cid, 1))
                return PLUGIN_HANDLED
	if (pwdpos < 1) {
		console_print(id, "* No passwords in list (amx_rndpass)")
		return PLUGIN_HANDLED
	}
        new pwd[32]
        pwd = pwds[random_num(0, pwdpos - 1)]
        set_cvar_string("sv_password", pwd)
	client_print(0, print_chat, "* [AMX] Server password changed to: %s", pwd)
	new msg[1024]
	format(msg, 1023, "Server password changed to:^n%s", pwd)
	set_hudmessage(255, 255, 255, -1.0, 0.32, 0, 2.0, 6.0, 0.8, 0.8, 2)
	show_hudmessage(0, msg)
	new players[32], n
	get_players(players, n, "c", "")
	if (n > 0) 
		for(new a = 0; a < n; ++a)
			if (!is_user_bot(players[a])) {
				client_cmd(players[a], "password %s", pwd)
				//client_print(players[a], print_chat, "* [AMX] CVAR 'password' changed to match server password")
			}
	return PLUGIN_HANDLED
}

public add_pwd_to_list(id, level, cid) {
	if (!cmd_access(id, level, cid, 2)) 
		return PLUGIN_HANDLED 
	new argc = read_argc()
	for(new i = 1; i < argc; i++) {
		if (pwdpos < MAX_PWDS) {
			new tmp[32]
			read_argv(i, tmp, 31)
			pwds[pwdpos] = tmp
			pwdpos++
		}
		else {
			console_print(id, "* Too many passwords added to list (amx_rndpass)")
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_HANDLED
}

public plugin_init() {
	register_plugin("AMX Random Password", "0.1", "Marach")
	register_concmd("amx_rndpass", "amx_rndpass", ADMIN_PASSWORD, "- sets random server password and announces it")
	register_srvcmd("amx_rndpass_list", "add_pwd_to_list")
	return PLUGIN_CONTINUE
}
