/* AMX Mod script.
*
* (c) 2003, T(+)rget
* Animated Hostname is provided as is (no warranties)
* 
* v1.0:
*    Initial Release
*
* Known Issues:
*    Doesn't work with Steam
*/
#include <amxmod>
#include <amxmisc>
#define ADMIN	(1<<1)
//---------------------------------------------------------------------------------
new MAX_NAME
new dName[32]
new Name[33][32]
new times = 1
//---------------------------------------------------------------------------------
public hostname_animate(id, level, cid)
{
	if(!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED

	if(get_cvar_num("hostname_anim"))
	{
		set_cvar_num("hostname_anim", 0)
		remove_task(7331)
		set_cvar_string("hostname", dName)
		times = 1
		client_print(id, 1, "Hostname Animation is:   OFF")
	}
	else
	{
		set_cvar_num("hostname_anim", 1)
		set_task(get_cvar_float("hostname_freq"), "change_hostname", 7331)
		client_print(id, 1, "Hostname Animation is:   ON")
	}
	return PLUGIN_HANDLED
}
//---------------------------------------------------------------------------------
public plugin_init()
{
	register_plugin("Animated Hostname", "1.0", "T(+)rget")
	loadcfg("addons/amx/hostname.cfg")
	
	register_clcmd("hostname_animate", "hostname_animate", ADMIN, "- starts/stops server name animation")
	register_cvar("hostname_anim", "1")
	register_cvar("hostname_debug", "0")
	register_cvar("hostname_freq", "1.0")

	server_cmd("exec addons/amx/hostname.cfg")
	set_task(get_cvar_float("hostname_freq"), "change_hostname", 7331)
}
//---------------------------------------------------------------------------------
public change_hostname()
{
	if(!get_cvar_num("hostname_anim"))
		return PLUGIN_HANDLED

	new host[33]
	
	switch(times)
	{
		default:
		{
			format(host, 32, Name[times])
			set_cvar_string("hostname", host)
		}
	}
	times++
	if(times > MAX_NAME || times > 32)
		times = 1
	
	if(get_cvar_num("hostname_debug"))
		server_print("Servername is now: %s", host)

	set_task(get_cvar_float("hostname_freq"), "change_hostname", 7331)
	return PLUGIN_HANDLED
}
//---------------------------------------------------------------------------------
loadcfg(filename[])
{ 
	if(file_exists(filename))
	{
		new readdata[100]
		new set[30], val[32], len
		for(new i = 0; i < 100 && read_file(filename, i, readdata, 99, len); ++i)
		{
			parse(readdata, set, 29, val, 31)
			if(equal(set, "DefaultName")) copy(dName, 31, val)
			if(equal(set, "MaxName")) MAX_NAME = strtonum(val)
			if(equal(set, "Name1")) copy(Name[1], 31, val)
			if(equal(set, "Name2")) copy(Name[2], 31, val)
			if(equal(set, "Name3")) copy(Name[3], 31, val)
			if(equal(set, "Name4")) copy(Name[4], 31, val)
			if(equal(set, "Name5")) copy(Name[5], 31, val)
			if(equal(set, "Name6")) copy(Name[6], 31, val)
			if(equal(set, "Name7")) copy(Name[7], 31, val)
			if(equal(set, "Name8")) copy(Name[8], 31, val)
			if(equal(set, "Name9")) copy(Name[9], 31, val)
			if(equal(set, "Name10")) copy(Name[10], 31, val)
			if(equal(set, "Name11")) copy(Name[11], 31, val)
			if(equal(set, "Name12")) copy(Name[12], 31, val)
			if(equal(set, "Name13")) copy(Name[13], 31, val)
			if(equal(set, "Name14")) copy(Name[14], 31, val)
			if(equal(set, "Name15")) copy(Name[15], 31, val)
			if(equal(set, "Name16")) copy(Name[16], 31, val)
			if(equal(set, "Name17")) copy(Name[17], 31, val)
			if(equal(set, "Name18")) copy(Name[18], 31, val)
			if(equal(set, "Name19")) copy(Name[19], 31, val)
			if(equal(set, "Name20")) copy(Name[20], 31, val)
			if(equal(set, "Name21")) copy(Name[21], 31, val)
			if(equal(set, "Name22")) copy(Name[22], 31, val)
			if(equal(set, "Name23")) copy(Name[23], 31, val)
			if(equal(set, "Name24")) copy(Name[24], 31, val)
			if(equal(set, "Name25")) copy(Name[25], 31, val)
			if(equal(set, "Name26")) copy(Name[26], 31, val)
			if(equal(set, "Name27")) copy(Name[27], 31, val)
			if(equal(set, "Name28")) copy(Name[28], 31, val)
			if(equal(set, "Name29")) copy(Name[29], 31, val)
			if(equal(set, "Name30")) copy(Name[30], 31, val)
			if(equal(set, "Name31")) copy(Name[31], 31, val)
			if(equal(set, "Name32")) copy(Name[32], 31, val)
		}
	}
}
