
/***************************************************************************/
/*                          Echo Commands v1.0                             */
/*                                             by Downtown1                */
/***************************************************************************/
/* This plugin will read a file for console commands, and  each time       */
/* someone uses a command it will echo it to the people and/or admins.     */

/*   Come to 208.254.35.18 if you wish to see it in action first.          */
/*                                                                         */
/* To use this plugin, simply make an echocmd.txt in your addons/amx/      */
/* folder and put the cmds there, separating them with a line break        */
/*
========================= Version History ===================================
*** 1.0  - first version of plugin: features command echoing
         - returns person who uses command, the command, and whatever client
           typed in after the command
*/

#include <amxmod>

new cmdlist[128][64]
new cmdcount = 0

public readfile ()
{
	new txtlength, txtline
	new txt[64]

	if (file_exists("addons/amx/echocmd.txt"))
	{
		while (read_file("addons/amx/echocmd.txt", txtline++, txt, 63, txtlength))
		{
			copy (cmdlist[txtline], 63, txt)
			cmdcount++
		}
	}
	return PLUGIN_CONTINUE
}

public echocmd(id)
{
	new cmd[32]
	new param[32]
	new echo[64]
	new get_ename[32]
	new get_eplayers[32]
	new get_numplayers
	get_user_name (id, get_ename, 31)
	get_players(get_eplayers, get_numplayers, "c")
	read_argv(0, cmd,31)
	read_args(param, 31)
	format (echo, 63, "%s has used command: %s %s", get_ename, cmd, param)
	for (new i=0; i < get_numplayers; i++)
	{
		if (get_user_flags(get_eplayers[i])&ADMIN_CHAT)
		{
			client_print(get_eplayers[i], print_chat, echo)
		}
	}

	return PLUGIN_CONTINUE
}

public plugin_init()
{
	register_plugin("Echo Commands","1.0","default")
	readfile()
	for (new i=0; i<cmdcount; i++)
	{
		register_clcmd(cmdlist[i], "echocmd")
	}
	return PLUGIN_CONTINUE
}

