/* AMXMOD script. 
* 
* (c) Copyright 2000-2002, KroKette
* This file is provided as is (no warranties). 
* 
* 
* This plugin load a config file to init match rules or FFa rules
*
* First create 2 files (cfgwar.cfg & cfgffa.cfg) and put them in your cstrike folder
* 
* Commands :
* 
* amx_cfgwar <password> // Load cfgwar.cfg file + init server password
* amx_cfgffa <password>	// Load cfgffa.cfg file + uninit server password
*
* NOTE : amx_cfgffa "" load cfgffa.cfg file and reset password.
*
*
*/ 

#include <amxmod>
#include <amxmisc>

new war_inprogress
new sv_pass[32]

public admin_modewar(id, level, cid)
{
	if (war_inprogress == 0)
	{
		if (!cmd_access(id, level, cid, 2)) 
			return PLUGIN_HANDLED 
		new newpass[32] 
		read_argv(1, newpass, 32) 
	        set_cvar_string("sv_password", newpass)


		get_cvar_string("sv_password", sv_pass, 32)

		// Check if admin init a password
		if (!newpass[0])
		{
			client_print(id,print_console,"* You must init a password to load config file *")
		}
		else
		{
			war_inprogress = 1
			set_hudmessage(0, 255, 0, -1.0, 0.40, 0, 6.0, 6.0, 0.1, 0.1, 9)
			show_hudmessage(0, "* Loadind Match rules... Please wait... *")
			server_cmd("exec cfgwar.cfg")
			set_task(4.0, "hudendload", 0)
			set_task(9.0, "hudnewtpass", 0)
			set_task(12.0, "hudnewtpass", 0)
			set_task(15.0, "hudnewtpass", 0)
			set_task(18.0, "hudnewtpass", 0)
			set_task(21.0, "hudnewtpass", 0)
		}
	}
	else
	{
		client_print(id,print_console,"* This file is already load *")	
	}
		
	return PLUGIN_CONTINUE		
}

public admin_modeffa(id, level, cid)
{
	if (war_inprogress == 1)
	{	
		if (!cmd_access(id, level, cid, 2)) 
			return PLUGIN_HANDLED 
		new newpass[32] 
		read_argv(1, newpass, 32) 
		set_cvar_string("sv_password", newpass)


		war_inprogress = 0
		set_hudmessage(0, 255, 0, -1.0, 0.40, 0, 6.0, 6.0, 0.1, 0.1, 9)
		show_hudmessage(0,"* Loadind FFa rules... Please wait... *")
		server_cmd("exec cfgffa.cfg")

		get_cvar_string("sv_password", sv_pass, 32)
		
		if (!newpass[0])
		{
			set_task(4.0, "hudendload", 0)
			set_task(9.0, "hudinitpass", 0)
		}
		else
		{
			set_task(4.0, "hudendload", 0)
			set_task(9.0, "hudnewtpass", 0)
			set_task(12.0, "hudnewtpass", 0)
			set_task(15.0, "hudnewtpass", 0)
			set_task(18.0, "hudnewtpass", 0)
			set_task(21.0, "hudnewtpass", 0)
		}
	
	}
	else
	{
		client_print(id,print_console,"* This file is already load *")	
	}
		
	return PLUGIN_CONTINUE		
}


public hudendload()
{
	set_hudmessage(0, 255, 0, -1.0, 0.40, 0, 6.0, 6.0, 0.1, 0.1, 9)
	show_hudmessage(0,"* Done... *")
	return PLUGIN_CONTINUE
}

public hudnewtpass()
{
	set_hudmessage(100, 100, 100, -1.0, 0.40, 0, 6.0, 6.0, 0.1, 0.1, 9)
	show_hudmessage(0, "/!\ Server password is : %s /!\", sv_pass)
	return PLUGIN_CONTINUE
}

public hudinitpass()
{
	set_hudmessage(100, 100, 100, -1.0, 0.40, 0, 6.0, 6.0, 0.1, 0.1, 9)
	show_hudmessage(0, "/!\ Password deleted /!\")
	return PLUGIN_CONTINUE
}

public plugin_init()
{
    register_plugin("AMX Load Config File","0.9.3a","KroKette") 
    register_concmd("amx_cfgwar","admin_modewar",ADMIN_LEVEL_A,"<password> - Load cfgwar.cfg + init password")
    register_concmd("amx_cfgffa","admin_modeffa",ADMIN_LEVEL_A,"<password> - Load cfgffa.cfg + init password")
    return PLUGIN_CONTINUE
}
