
/*
*					AMX Mod script
*				sqlnames.sma by Similar
*					v. 0.5.4 (beta)
*			Beta version - only for testing !!!
*
*		This file is provided as-is (no warranties)
*
*	Read README.TXT in .zip file for tables structure,
*	insructions,cvars,changelog & other stuff !
*
*	WARNING: if you not use other MySQL plugins uncomment all
*	'register_cvar' in plugin_init and set you options THERE !!!
*
*	Thanks to OLO and all the AMX community !
*	( & sorry for my bad english ;-) )
*/

#include <amxmod>
#include <mysql>

#define DB_ADMIN		(1<<0) // a - database admin
#define BANNED			(1<<1) // b - banned (not used yet)
#define CAN_CHPASS		(1<<2) // c - change password
#define CAN_DELETEUC	(1<<3) // d - delete users/clans
#define CAN_ADDUC		(1<<4) // e - add uses/clans
#define CAN_USESHOW		(1<<5) // f - read data for registrations DB (too little for now)
#define CLANFOUNDER		(1<<6) // g - clan founder


new prerror[128], prhost[16], pruser[32], prpass[32], prdb[32] 
new mysql = 0
new uname[32], passwd[8], pfield[20]
new mysqlUsersTbl[32], mysqlClansTbl[32]
new bool:dontcheck[33]
new bool:registered[33]
new bool:allowall = true

new msgs[11][] = {
	"echo [AMX] Hmmmm, give me password with '/setinfo %s password'",
	"echo [AMX] or change your nick with '/name newnick' and reconnect !;disconnect",
	"echo [AMX] Wrong password !",
	"echo [AMX] Type the correct password with '/setinfo %s <password>'",
	"echo [AMX] or change your nick with '/name newnick' and reconnect !;disconnect",
	"echo [AMX] Hmzzz, caps in nick not match...",
	"echo [AMX] The right registered nick is %s ",
	"echo [AMX] Correct your nick with '/name %s' and reconnect !;disconnect",
	"echo [AMX] Password accepted !!!",
	"[AMX] You can`t do that !",
	"[AMX] You can`t use this command !"
}

new notallowed [2][] = {
	"echo [Server] Access denied !",
	"echo [Server] Only players with registered names may play !;disconnect"
}

plugin_initialisation () {
	get_cvar_string("amx_regusers_table",mysqlUsersTbl,32)
	get_cvar_string("amx_regclans_table",mysqlClansTbl,32)
	get_cvar_string("amx_mysql_host",prhost,16) 
	get_cvar_string("amx_mysql_user",pruser,32) 
	get_cvar_string("amx_mysql_pass",prpass,32) 
	get_cvar_string("amx_mysql_db",prdb,32) 
	mysql = mysql_connect(prhost,pruser,prpass,prdb,prerror,32)
	if(mysql < 1){ 
		mysql_error(mysql,prerror,127) 
		server_print("[AMX_REG] MySQL error : could not connect : '%s'",prerror) 
		return PLUGIN_HANDLED 
	}
	new prquery[128]
	format(prquery,127,"SELECT nick,pass,flags FROM %s",mysqlUsersTbl)
	if(mysql_query(mysql,prquery) < 1)	{
		mysql_error(mysql,prerror,127)
		server_print("[AMX_REG] MySQL error: can't load users: '%s'",prerror)
		return PLUGIN_HANDLED
	}
	format(prquery,127,"SELECT clan,founder,lastus from %s",mysqlClansTbl)
	if(mysql_query(mysql,prquery) < 1)	{
		mysql_error(mysql,prerror,127)
		server_print("[AMX_REG] MySQL error: can't load clans: '%s'",prerror)
		return PLUGIN_HANDLED
	}
	else server_print("[AMX_REG] SQL connection OK !")
	registered[0] = true
	new temp = get_cvar_num("amx_allowallppl")
	if (temp > 0) allowall = true
	else allowall = false
	return PLUGIN_CONTINUE
}

check_user(id){
	new found = 0
	new clanName[15], prquery[128]
	format(prquery,127,"SELECT clan from %s",mysqlClansTbl)
	mysql_query(mysql,prquery)
	while( mysql_nextrow(mysql) > 0 )	{		// check if username contain registered clan
		mysql_getfield(mysql,1,clanName,15)
		if (containi(uname,clanName) != -1){	
			user_clanmember(id,clanName)
			found = 1
		}
	}
	if (found == 0) user_noclan(id)		// not in clan, or clan is not registered, check nick
	return PLUGIN_CONTINUE
}

user_noclan(id){
	new regUser[32], regPass[10], rquery[128]
	format(rquery,128,"SELECT nick,pass FROM %s WHERE nick = '%s'",mysqlUsersTbl,uname)
	mysql_query(mysql,rquery)
	if ( mysql_nextrow(mysql) > 0 )	{
		mysql_getfield(mysql,1,regUser,32)
		mysql_getfield(mysql,2,regPass,10)
		if (equali(uname,regUser)) {			// found registered nick 
			if (tolower(passwd[0]) == 0) {	// ... without password
				client_cmd(id,msgs[0],pfield)
				client_cmd(id,msgs[1])
				return PLUGIN_HANDLED
			}
			if (!equal(passwd,regPass)) {		// ... but password not match
				client_cmd(id,msgs[2])
				client_cmd(id,msgs[3],pfield)
				client_cmd(id,msgs[4])
				return PLUGIN_HANDLED
			} 
			if ((equal(passwd,regPass)) && (!equal(uname,regUser))) {		// caps not match
				client_cmd(id,msgs[5])
				client_cmd(id,msgs[6], regUser)
				client_cmd(id,msgs[7],regUser)
				return PLUGIN_HANDLED
			}
			if ((equal(passwd,regPass)) && (equal(uname,regUser))) {		// all is OK 
				client_cmd(id,msgs[8])
				client_cmd(id,"echo [AMX] Enjoy the game %s ...",uname)
				registered[id] = true
				return PLUGIN_CONTINUE
			}
		}
	}
	if (!allowall) {
		client_cmd(id,notallowed[0])
		client_cmd(id,notallowed[1])
		return PLUGIN_HANDLED
	}
	client_cmd(id,"echo [AMX] You play with non-registered nick.")
	registered[id] = false
	return PLUGIN_CONTINUE
}

user_clanmember(id,clanName[15]) {	// first check if player use only clanname, e.g name = [newbie]
	if (equali(uname,clanName)) {
		if (allowall){
			client_cmd(id,"echo [AMX] You can`t play only with clanname !")
			client_cmd(id,"echo [AMX] Must have also and name : e.g. %ssomething.",clanName)
			client_cmd(id,"echo [AMX] Change your name with '/name newnick' to mach requirements and reconnect !;disconnect")
			return PLUGIN_HANDLED
		} else {
			client_cmd(id,notallowed[0])
			client_cmd(id,notallowed[1])
			return PLUGIN_HANDLED
		}
	}
	new regUser[32], regPass[10], rquery[128]
	format(rquery,128,"SELECT nick,pass FROM %s WHERE nick = '%s'",mysqlUsersTbl,uname)
	mysql_query(mysql,rquery)
	if ( mysql_nextrow(mysql) > 0 )	{
		mysql_getfield(mysql,1,regUser,32)
		mysql_getfield(mysql,2,regPass,10)
		if (equali(uname,regUser)) {				// user with registered clan  
			if (tolower(passwd[0]) == 0) {		// ... without password
				client_cmd(id,msgs[0],pfield)
				client_cmd(id,msgs[1])
				return PLUGIN_HANDLED
			}
			if (!equal(passwd,regPass)) {			// ... password not match
				client_cmd(id,msgs[2])
				client_cmd(id,msgs[3],pfield)
				client_cmd(id,msgs[4])
				return PLUGIN_HANDLED
			} 
			if ((equal(passwd,regPass)) && (!equal(uname,regUser))) {	// caps not match
				client_cmd(id,msgs[5])
				client_cmd(id,msgs[6], regUser)
				client_cmd(id,msgs[7],regUser)
				return PLUGIN_HANDLED
			}
			if ((equal(uname,regUser)) && (equal(passwd,regPass))) {	// all is OK
				client_cmd(id,msgs[8])
				client_cmd(id,"echo [AMX] Welcome in clan %s... Enjoy the game !",clanName)
				registered[id] = true
				return PLUGIN_CONTINUE
			}
		}
	}
	if (!allowall) {
		client_cmd(id,notallowed[0])
		client_cmd(id,notallowed[1])
		return PLUGIN_HANDLED
	}
	client_cmd(id,"echo [AMX] You are not member of clan %s !",clanName)
	client_cmd(id,"echo [AMX] Remove the clan from your nick and reconnect !;disconnect")
	return PLUGIN_HANDLED
}

read_user_flags(id) {
	if (id == 0) {
		return read_flags("adefg")
	}
	new regFlags[32], regUser[32], rquery[128]
	get_user_name(id,regUser,32)
	format(rquery,127,"SELECT flags FROM %s WHERE nick = '%s'",mysqlUsersTbl,regUser)
	mysql_query(mysql,rquery)
	if (mysql_nextrow(mysql) > 0) {
		mysql_getfield(mysql,1,regFlags,32)
	}
	new flags = read_flags(regFlags) 
	if (flags&DB_ADMIN) return read_flags("acdefg")
	return read_flags(regFlags)
}

public admin_regname(id){
	new uFlags = 0
	if (registered[id]) {
		uFlags = read_user_flags(id)
	}
	if (!(uFlags&CAN_ADDUC))  {
		console_print(id,msgs[9])
		return PLUGIN_HANDLED
	}
	if (read_argc() < 3) {
		console_print(id,"Use: amx_regname <name> <password> [flags]")
		console_print(id,"Hint: If <name> contain spaces put it into quotes.")
		return PLUGIN_HANDLED
	}
	new regUser[32], usrPass[11], regFlags[42], rquery[128]
	read_argv(1,regUser,32)
	read_argv(2,usrPass,11)
	read_argv(3,regFlags,32)
	new bool:defaultf = false
	if (tolower(regFlags[0] == 0)) {
		get_cvar_string("amx_regdefuflags",regFlags,32)
		defaultf = true
	}
	if (!(check_player_name(id,regUser))) return PLUGIN_HANDLED
	if (!(check_new_passwd(id,usrPass))) return PLUGIN_HANDLED
	format(rquery,128,"SELECT nick FROM %s WHERE nick = '%s'",mysqlUsersTbl,regUser)
	mysql_query(mysql,rquery)
	if ( mysql_nextrow(mysql) > 0 ) {
		console_print(id,"[AMX] Name '%s' is already registered.",regUser)
		return PLUGIN_HANDLED
	}
	format(rquery,128,"INSERT INTO %s (nick,pass,flags,lastus) VALUES ('%s','%s','%s',NOW())",mysqlUsersTbl,regUser,usrPass,regFlags)
	mysql_query(mysql,rquery)
	if (tolower(regFlags[0]) == 0) regFlags = "none"
	if (defaultf) add(regFlags,42," (default)")
	console_print(id,"[AMX] Registration sucessful.")
	console_print(id,"[AMX] Playername: %s, password: %s, flags: %s",regUser,usrPass,regFlags)
	new newUsrIndex = get_user_index(regUser)
	if (is_user_connected(newUsrIndex) == 1){
		client_cmd(newUsrIndex,"setinfo %s %s",pfield,usrPass)
		client_print(newUsrIndex,print_chat,"[AMX] You are now registered.")
	}
	return PLUGIN_HANDLED
}

public admin_delname(id) {
	new uFlags = 0
	if (registered[id]) {
		uFlags = read_user_flags(id)
	}
	if (!(uFlags&CAN_DELETEUC))  {
		console_print(id,msgs[9])
		return PLUGIN_HANDLED
	}
	if (read_argc() < 2) {
		console_print(id,"Use: amx_delname <name>")
		console_print(id,"Hint: If <name> contain spaces put it into quotes.")
		return PLUGIN_HANDLED
	}
	new delUser[32], rquery[128]
	read_argv(1,delUser,32)
	format(rquery,128,"SELECT nick FROM %s WHERE nick = '%s'",mysqlUsersTbl,delUser)
	mysql_query(mysql,rquery)
	if ( mysql_nextrow(mysql) > 0 ) {
		format(rquery,128,"DELETE FROM %s WHERE nick = '%s'",mysqlUsersTbl,delUser)
		mysql_query(mysql,rquery)
		console_print(id,"[AMX] Player <%s> and all his info deleted.",delUser)
		return PLUGIN_HANDLED
	} else {
		console_print(id,"[AMX] Player <%s> not exist.",delUser)
		return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

public admin_regclan(id){
	new uFlags = 0
	if (registered[id]) {
		uFlags = read_user_flags(id)
	}
	if (!(uFlags&CAN_ADDUC))  {
		console_print(id,msgs[9])
		return PLUGIN_HANDLED
	}
	if (read_argc() < 4) {
		console_print(id,"Use: amx_regclan <clanname> <founder> <founderpass> [flags]")
		console_print(id,"  When you register clan, the given founder name are created")
		console_print(id,"in players database (like with amx_regname command). Flag 'g'")
		console_print(id,"will be added automaticaly to this player flags.")
		console_print(id,"Hint: If any command option contain spaces put it into quotes.")
		return PLUGIN_HANDLED
	}
	new regClan[16], clanFound[32], foundPass[11], foundFlags[32], rquery[128]
	read_argv(1,regClan,16)
	read_argv(2,clanFound,32)
	read_argv(3,foundPass,10)
	read_argv(4,foundFlags,32)
	if ((strlen(regClan) < 3) || (strlen(regClan) > 15)){
		console_print(id,"[AMX] Clanname must be between 3 and 15 characters...")
		return PLUGIN_HANDLED
	}
	if (!(check_player_name(id,clanFound))) return PLUGIN_HANDLED
	if (!(check_new_passwd(id,foundPass))) return PLUGIN_HANDLED
	format(rquery,128,"SELECT clan FROM %s WHERE clan = '%s'",mysqlClansTbl,regClan)
	mysql_query(mysql,rquery)
	if ( mysql_nextrow(mysql) > 0 ) {
		console_print(id,"[AMX] Clanname '%s' is already registered.",regClan)
		return PLUGIN_HANDLED
	}
	format(rquery,128,"INSERT INTO %s (clan,lastus) VALUES ('%s',NOW())",mysqlClansTbl,regClan)
	mysql_query(mysql,rquery)
	add(foundFlags,32,"g")
	console_print(id,"[AMX] Clanname: %s, Founder: %s",regClan,clanFound)
	format(rquery,128,"amx_regname %s %s %s",clanFound,foundPass,foundFlags)
	if (id == 0) server_cmd(rquery)
	else client_cmd(id,rquery)
	return PLUGIN_HANDLED
}

public admin_delclan(id) {
	new uFlags = 0
	if (registered[id]) {
		uFlags = read_user_flags(id)
	}
	if (!(uFlags&CAN_DELETEUC))  {
		console_print(id,msgs[9])
		return PLUGIN_HANDLED
	}
	if (read_argc() < 2) {
		console_print(id,"Use: amx_delclan <clanname> [option]")
		console_print(id,"Without options deletes only clanname")
		console_print(id,"Valid options:")
		console_print(id," all   - deletes and clanmembers")
		console_print(id," unreg - deletes clanname and renames clanmembers")
		console_print(id,"Hint: If <clanname> contain spaces put it into quotes.")
		return PLUGIN_HANDLED
	}
	new delClan[17], delUsers[32], rquery[128]
	read_argv(2,delUsers,32)
	read_argv(1,delClan,15)
	if (tolower(delUsers[0]) != 0) {
		if (!equal(delUsers,"all")) {
			if (!equal(delUsers,"unreg")){
				console_print(id,"Invalid command option: '%s'",delUsers)
				return PLUGIN_HANDLED
			}
		}
	}
	format(rquery,128,"SELECT clan FROM %s WHERE clan = '%s'",mysqlClansTbl,delClan)
	mysql_query(mysql,rquery)
	if ( mysql_nextrow(mysql) > 0 ) {
		format(rquery,128,"DELETE FROM %s WHERE clan = '%s'",mysqlClansTbl,delClan)
		mysql_query(mysql,rquery)
		if (equal(delUsers,"all")) {
			format(rquery,128,"SELECT nick FROM %s WHERE nick LIKE '%%%%%s%%%%'",mysqlUsersTbl,delClan)
			mysql_query(mysql,rquery)
			new usrName[32], i = 0
			while (mysql_nextrow(mysql) > 0) {
				mysql_getfield(mysql,1,usrName,32)
				i++
				console_print(id,"Clanmember: %s  ---> deleted",usrName)
			}
			format(rquery,128,"DELETE FROM %s WHERE nick LIKE '%%%%%s%%%%'",mysqlUsersTbl,delClan)
			mysql_query(mysql,rquery)
			console_print(id,"Clan <%s> and %i clanmembers are deleted",delClan,i)
			return PLUGIN_HANDLED
		}
		if (equal(delUsers,"unreg")) {
			format(rquery,128,"SELECT nick FROM %s WHERE nick LIKE '%%%%%s%%%%'",mysqlUsersTbl,delClan)
			mysql_query(mysql,rquery)
			new usrName[32], newName[32], i = 0
			while (mysql_nextrow(mysql) > 0) {
				mysql_getfield(mysql,1,usrName,32)
				i++
				copy(newName,32,usrName)
				replace(newName,32,delClan,"")
				console_print(id,"Clanmember: %s  ---> renamed to %s",usrName,newName)
				format(rquery,127,"UPDATE %s SET nick = '%s' WHERE nick = '%s'",mysqlUsersTbl,newName,usrName)
				mysql_query(mysql,rquery)
				format(rquery,128,"SELECT nick FROM %s WHERE nick LIKE '%%%%%s%%%%'",mysqlUsersTbl,delClan)
				mysql_query(mysql,rquery)
			}
			console_print(id,"Clan <%s> deleted and %i clanmembers are renamed.",delClan,i)
			return PLUGIN_HANDLED
		}
		console_print(id,"[AMX] Clanname <%s> is deleted.",delClan)
		return PLUGIN_HANDLED
	} else {
		console_print(id,"[AMX] No registered clan with that name :--> <%s> ",delClan)
		return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

public user_chpass(id){
	new uFlags = 0
	if (registered[id]) {
		uFlags = read_user_flags(id)
	}
	if (!(uFlags&CAN_CHPASS))  {
		console_print(id,msgs[10])
		return PLUGIN_HANDLED
	}
	if (read_argc() < 2) {
		console_print(id,"Use: amx_chpass <newpass>")
		return PLUGIN_HANDLED
	}
	new regUser[32], newPass[11], rquery[128], nowPass[10]
	get_user_name(id,regUser,32)
	read_argv(1,newPass,11)
	get_user_info(id,pfield,nowPass,10)
	if (equal(newPass, nowPass)) {
		console_print(id,"[AMX] Do you kidding me ?")
		return PLUGIN_HANDLED
	}
	if (!(check_new_passwd(id,newPass))) return PLUGIN_HANDLED
	format(rquery,127,"UPDATE %s SET pass = '%s' WHERE nick = '%s'",mysqlUsersTbl,newPass,regUser)
	mysql_query(mysql,rquery)
	console_print(id,"[AMX] Password changed.")
	console_print(id,"[AMX] Your new password is %s",newPass)
	client_cmd(id,"setinfo %s %s",pfield,newPass)
	return PLUGIN_HANDLED
}

public admin_claninfo(id){
	new uFlags = 0
	if (registered[id]) {
		uFlags = read_user_flags(id)
	}
	if (!(uFlags&CAN_USESHOW))  {
		console_print(id,msgs[10])
		return PLUGIN_HANDLED
	}
	if (read_argc() < 2) {
		console_print(id,"Use: amx_showclan <clanname>")
		console_print(id,"Hint: If <clanname> contain spaces put it into quotes.")
		return PLUGIN_HANDLED
	}
	new clanName[16], rquery[128]
	read_argv(1,clanName,15)
	format(rquery,128,"SELECT clan FROM %s WHERE clan = '%s'",mysqlClansTbl,clanName)
	mysql_query(mysql,rquery)
	if ( mysql_nextrow(mysql) > 0 ) {
		format(rquery,128,"SELECT nick,pass,flags,lastus FROM %s WHERE nick LIKE '%%%%%s%%%%'",mysqlUsersTbl,clanName)
		if (mysql_query(mysql,rquery) > 0) {
  		new i = 0, mflags = 0
  		new regUser[32], regPass[10], regFlags[32], lastSeen[20], clanFound[32],showStr[128]
  		while( mysql_nextrow(mysql) > 0 ) {
  			i++
  			mysql_getfield(mysql,4,lastSeen,20)
  			mysql_getfield(mysql,1,regUser,32)
  			mysql_getfield(mysql,2,regPass,10)
  			mysql_getfield(mysql,3,regFlags,32)
  			mflags = read_flags(regFlags)
  			if (mflags == 0) regFlags = "none"
  			else if (mflags&CLANFOUNDER) clanFound = regUser
  			if (uFlags&DB_ADMIN) format(showStr,128,"%i. %s, password: %s, flags: %s, last seen: %s",i,regUser,regPass,regFlags,lastSeen)
  			else format(showStr,128,"%i. %s, last seen: %s",i,regUser,lastSeen)
  			console_print(id,showStr)
  		}
  		console_print(id,"Clan: %s, Founder: %s, Members: %i",clanName,clanFound,i)
    }
	} else {
		console_print(id,"[AMX] No registered clan with that name :--> %s ",clanName)
		return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

public admin_infodb(id){
	new uFlags = 0
	if (registered[id]) {
		uFlags = read_user_flags(id)
	}
	if (!(uFlags&DB_ADMIN))  {
		console_print(id,"[AMX] You can`t do that !")
		return PLUGIN_HANDLED
	}
	new rquery[128], numRegs[5]
	console_print(id,"Information for database: MySQLNameMngmt 0.5.4 (beta):")
	console_print(id,"Database: %s",prdb)
	format(rquery,127,"SELECT COUNT(*) from %s",mysqlUsersTbl)
	mysql_query(mysql,rquery)
	if ( mysql_nextrow(mysql) > 0 ) {
		mysql_getfield(mysql,1,numRegs,5)
		console_print(id,"Users table: %s  :-->  %s registered names in table",mysqlUsersTbl,numRegs)
	}
	format(rquery,127,"SELECT COUNT(*) from %s",mysqlClansTbl)
	mysql_query(mysql,rquery)
	if ( mysql_nextrow(mysql) > 0 ) {
		mysql_getfield(mysql,1,numRegs,5)
		console_print(id,"Clans table: %s  :-->  %s registered clans in table",mysqlClansTbl,numRegs)
	}
	return PLUGIN_HANDLED
}

public client_infochanged(id){
	new oldName[32]
	get_user_info(id,"name",uname,32)
	get_user_info(id,pfield,passwd,20)
	get_user_name(id,oldName,32)
	if ((get_cvar_num("amx_allowchnick")) && (is_user_connected(id)) && (!equal(uname,oldName))) {
		store_time_data(id,oldName)
		check_user(id)
	}
	else {
		if (dontcheck[id]) dontcheck[id] = false
		else if ((is_user_connected(id)) && (!equal(uname,oldName))){
			dontcheck[id] = true
			client_print(id,print_chat,"[AMX] You are not allowed to change your name")
			set_user_info(id,"name",oldName)
		}
	}
	return PLUGIN_CONTINUE 
}

store_time_data(id,usrName[32]){  // stores last seen plyer time
	new rquery[128]
	if (registered[id]) {
		format(rquery,127,"UPDATE %s SET lastus = NOW() WHERE nick = '%s'",mysqlUsersTbl,usrName)
		mysql_query(mysql,rquery)
	}		
	return PLUGIN_CONTINUE
}

check_new_passwd(id,newPass[11]){ 
	new nPassLen = strlen(newPass)
	new minPassLen = get_cvar_num("amx_minpasslen")
	new maxPassLen = get_cvar_num("amx_maxpasslen")
	new bool:match = true
	if (nPassLen < minPassLen) {
		console_print(id,"[AMX] Password must be at least %i characters.",minPassLen)
		match = false
	}
	if (nPassLen > maxPassLen) {
		console_print(id,"[AMX] Password can be at most %i characters.",maxPassLen)
		match = false
	}
	if (containi(newPass," ") != -1) {
		console_print(id,"[AMX] Password cannot contain spaces.")
		match = false
	}
	return match
}

check_player_name(id,usrName[32]){
	new bool:match = true
	new minLen = get_cvar_num("amx_minnicklen")		// first check nick lenght
	new maxLen = get_cvar_num("amx_maxnicklen")
	if ((strlen(usrName) < minLen) || (strlen(usrName) > maxLen)){
		console_print(id,"[AMX] Player names must be between %i and %i characters...", minLen, maxLen)
		match = false
	}
	return match
}

public client_disconnect(id){
	new usrName[32]
	get_user_name(id,usrName,32)
	store_time_data(id,usrName)
	return PLUGIN_CONTINUE
}

public client_connect(id) {
	get_user_name(id,uname,32)
	get_cvar_string("amx_pass_field",pfield,20)
	get_user_info(id,pfield,passwd,10)
	if (!(check_player_name(id,uname))) {
		client_cmd(id,"echo [AMX] If you want to play on this server - change it to match requirements !")
		client_cmd(id,"echo [AMX] Hint: Use command '/name newnick'  ;-) !;disconnect")
		return PLUGIN_HANDLED
	}
	check_user(id)
	return PLUGIN_CONTINUE
}

public plugin_init(){
	register_plugin("MySQLNameMngmt","0.5.4b","Similar")
	register_concmd("amx_regname","admin_regname",0,"- register player name")
	register_concmd("amx_delname","admin_delname",0,"- delete registered player name")
	register_concmd("amx_regclan","admin_regclan",0,"- register clan name")
	register_concmd("amx_delclan","admin_delclan",0,"- delete registered clan name")
	register_concmd("amx_infodb","admin_infodb",0," - information about plugin DB")
	register_concmd("amx_claninfo","admin_claninfo",0," - shows information about selected clan")
	register_clcmd("amx_chpass","user_chpass",0,"- changes password (registered users only)")
	register_cvar("amx_allowallppl","1")		// set to "0" and only reg. players may play
	register_cvar("amx_allowchnick","1")		// change name
	register_cvar("amx_pass_field","_pass")		// password field
	register_cvar("amx_minnicklen","1")			// min. nick lenght (characters)
	register_cvar("amx_maxnicklen","32")		// max. nick lenght (....
	register_cvar("amx_minpasslen","3")			// min. password lenght
	register_cvar("amx_maxpasslen","10")		// max. password lenght
	register_cvar("amx_regdefplflags","c")		// default flags for new registrations
	register_cvar("amx_regusers_table","amx_regusers") // DB users table name
	register_cvar("amx_regclans_table","amx_regclans") // DB clans table name
//	Read README.TXT for these commented lines !!!
//	register_cvar("amx_mysql_host","127.0.0.1")	// MySQL server ip address
//	register_cvar("amx_mysql_user","root")		// database username
//	register_cvar("amx_mysql_pass","")			// database password
//	register_cvar("amx_mysql_db","amx")			// database name
	plugin_initialisation()
	return PLUGIN_CONTINUE
}

