
/**
 * AMX Mod script.
 * * (c) Copyleft 2003, n00ng
 * This file is provided as is (no warranties).
 **/

/**
 * Displays in CS how many players remaining (CT vs. T).
 * Inspired by enemy_remaining.axm (OLO)
 * -> say /nbplayer to activate manually
 **/

#include <amxmod>


public player_remaining() 
{
	new ppl_t[32], pplnum_t
	get_players(ppl_t,pplnum_t,"ae", "TERRORIST") // get all terorist live player
	
	new ppl_ct[32], pplnum_ct
	get_players(ppl_ct, pplnum_ct, "ae", "CT") // get all CT live player

	new message_t [128]   
	new message_ct [128]  
	
	format(message_t,127,"%d Terrorist%s  vs.  %d CT%s", pplnum_t, (pplnum_t==1 || pplnum_t == 0)?"":"s", pplnum_ct, (pplnum_ct==1 || pplnum_ct == 0)?"":"s")  // T vs. CT
	format(message_ct,127,"%d CT%s  vs.  %d Terrorist%s", pplnum_ct, (pplnum_ct==1 || pplnum_ct == 0)?"":"s", pplnum_t, (pplnum_t==1 || pplnum_t == 0)?"":"s") // CT vs. T
	
	set_hudmessage(220, 80, 0, 0.01, 0.91, 0, 2.0, 3.0, 0.5, 5.0, 1)
	
	new ppl[32], pplnum 
	get_players(ppl,pplnum) // get all player
	
	for(new a=0; a<pplnum; ++a) 
	{
		new userteam[32]
		get_user_team(ppl[a], userteam, 31) 		
		if (userteam[0] == 'C')
			show_hudmessage(ppl[a],message_ct) // send to CT player
		else
			show_hudmessage(ppl[a],message_t) // send to T player
	}

	return PLUGIN_CONTINUE
}

public plugin_init() {
	register_plugin("Player remaining","0.1","n00ng")
	register_event("DeathMsg","player_remaining","a")
	register_clcmd("say /nbplayer", "player_remaining", 0, "- display number of player remaining" );
	return PLUGIN_CONTINUE
}

