/* Plugin Coded by -]ToC[-Bludy

IMPORTANT: You must have the Vexd_utilities module, and also the Xtrafun module for this plugin to work properly!!!

CVARS:

amx_rmines 1 or 0    1 = on    0 = off  (default is 0)   - Turns on Remote Mines
amx_tmines 1 or 0    1 = on    0 = off  (default is 0)   - Turns on Timed Mines
amx_lmines 1 or 0    1 = on    0 = off  (default is 0)   - Turns on Land Mines
amx_pmines 1 or 0    1 = on    0 = off  (default is 0)   - Turns on Proximity Mines

amx_mineammo 0 or greater               (default is 1)   - Amount of mines given on roundstart

amx_minetimer 0 or greater              (default is 5)   - Time (in seconds) for Timed mines

amx_pminedelay 0 or greater             (default is 1)   - Time (in seconds) until pmine blows once triggered
amx_pminearmdelay 0 or greater          (default is 3)   - Time (in seconds) until pmine is armed when planted 

amx_minetossforce 0 or greater          (defualt is 1000)- Amount of force when a player throws a mine

amx_minemovetype *Check HLSDK for types (default is 6)   - Movetype of mines when planted, default is Toss.  Warning: bad movetypes will cause server crashes

amx_mine_buying 1 or 0                  (default is 0)   - Toggles Mine Buying

amx_rmine_cost 0 or greater             (default is 1000)- Price for Remote mines
amx_pmine_cost 0 or greater				(default is 900) - Price for Proximity mines
amx_tmine_cost 0 or greater				(default is 350) - Price for Timed mines
amx_lmine_cost 0 or greater				(default is 250) - Price for Land mines

amx_dropmines 1 or 0					(default is 1)   - Toggles Mine dropping

Client Commands:  plant_rmine      plant_lmine      plant_tmine       plant_pmine      mine_menu        mine_buy_menu   
Admin Commands:   amx_rmine        amx_lmine        amx_tmine         amx_pmine        amx_mine_menu    amx_minehelp

Admins can use amx_minehelp for a list of cvars and commands used with this plugin.

mine_menu is an easy way to access all of this plugins features, highly recommended.  (Menus inspired by Ludwigs missile plugin)
amx_mine_menu is an easy way to access the admin commands used by this plugin.

Admin mine planting:  By request of Blunted1, lets admins with proper admin access to plant mines without depleting mine ammo
Use with care, and play fair!!  Change the ADMIN_ACCESS which is just a few lines below this description to the level of your 
liking and recompile.  Note: Not all of the commands are restricted by ADMIN_ACCESS refer to plugin_init() for access levels.

Description: Activate the mines of your choice and bind keys to the proper commands in order to use them.
All players on your server will be able to plant them.  Get them to say /minehelp for detail on the commands,
and a binding tutorial.  Mines can damage Teamates.  When a player is not crouching he will automatically throw
his/her mines, if crouched it will be planted directly below you.

Remote mines: <plant_rmine> - Use once to plant, Use again to detonate
Timed mines: <plant_tmine> - Use once to plant, when timer expires it detonates itself
Land mines: <plant_lmine> - Use once to plant, when somemone steps directly on it, it detonates.
Proximity: <plant_pmine> - Use once to plant, There will be a delay until it is armed. Once armed,
if any player steps into its proximity it will activate and detonate after another delay. 

- All delays are time in seconds and can be changed  

Mineammo is pooled, so all types of mines share the same ammo.
Example if amx_mineammo is set to 3, you could plant 1 of each mine, or 2 of one type then one more of another.

When amx_mine_buying is set to one a Mine Purchase Menu will appear on round start so players don't have to bind the
menu command.  The purchase menu can also be accessed via the mine_menu, or if you like just bind a key to mine_buy_menu.
Also mineammo will not be pooled, you can use the mines that you buy, none are for free.

Clients can also say /mineammo to see how many mines they start with on each round.

Have fun!!

*/


#include <amxmod> 
#include <amxmisc> 
#include <Xtrafun_to_Vexd> 

#define ADMIN_ACCESS ADMIN_IMMUNITY

new boom
new rmine[33], tmine[33], lmine[33], pmine[33]
new idtransfer[33]
new mineammo[33], rmineammo[33], lmineammo[33], tmineammo[33], pmineammo[33]
new holdammo[33], holdrammo[33], holdlammo[33], holdtammo[33], holdpammo[33]
new ammobox[33]
new bool:planted[33]
new bool:tmineplanted[33]
new bool:pminearmed[33]
new bool:pmineplanted[33]
new bool:minepickup[33]



public entity_touch(entity1, entity2) { 
if(entity1 > 0 && entity2 > 0)
{
   new mineClassName[32], playerClassname[32]
   Entvars_Get_String(entity1, EV_SZ_classname, mineClassName, 32);
   Entvars_Get_String(entity2, EV_SZ_classname, playerClassname, 32) 

   new owner = Entvars_Get_Edict(entity1, EV_ENT_owner)

   if(equal(mineClassName,"mineammo_pickup") && equal(playerClassname,"player"))
   {
   
   if(owner == entity2)
   {
   if(!minepickup[owner])
   return PLUGIN_CONTINUE
   else
   minepickup[owner] = false
   }
   
   emit_sound(entity1, CHAN_WEAPON, "weapons/equip_nvg.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
   
   if(get_cvar_num("amx_mine_buying") == 0)
   {
   mineammo[entity2] = mineammo[entity2] + holdammo[owner]
   client_print(entity2,print_chat,"[AMX Mines] **** You just picked up %i mines ****",holdammo[owner])
   }
   else
   {
   rmineammo[entity2] = rmineammo[entity2] + holdrammo[owner]
   pmineammo[entity2] = pmineammo[entity2] + holdpammo[owner]
   tmineammo[entity2] = tmineammo[entity2] + holdtammo[owner]
   lmineammo[entity2] = lmineammo[entity2] + holdlammo[owner]
   client_print(entity2,print_chat,"[AMX Mines] **** You picked up %i Rmines, %i Pmines, %i Tmines, %i Lmines ****",holdrammo[owner],holdpammo[owner],holdtammo[owner],holdlammo[owner])
   }
   RemoveEntity(entity1)
   }
   
   if((equal(mineClassName,"land_mine") || equal(mineClassName,"proximity_mine") || equal(mineClassName,"timed_mine") || equal(mineClassName,"remote_mine")) && equal(playerClassname,"Bullet"))
   {
   
   new Float: vExplodeAt[3] 
   Entvars_Get_Vector(entity1, EV_VEC_origin, vExplodeAt) 
	  
   radius_damage(owner, 50.0, vExplodeAt, 200.0, DMG_BLAST, "mine")
      	
   message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
   write_byte(3) 
   write_coord(floatround(vExplodeAt[0])) 
   write_coord(floatround(vExplodeAt[1])) 
   write_coord(floatround(vExplodeAt[2])) 
   write_short(boom) 
   write_byte(50) 
   write_byte(15) 
   write_byte(0) 
   message_end() 

   RemoveEntity(entity1) 

   return PLUGIN_CONTINUE
   }

   if(equal(mineClassName, "land_mine") && equal(playerClassname,"player")) { 

     
      new Float: vExplodeAt[3] 
      Entvars_Get_Vector(entity1, EV_VEC_origin, vExplodeAt) 
	  
      radius_damage(owner, 50.0, vExplodeAt, 200.0, DMG_BLAST, "mine")
      	
      message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
      write_byte(3) 
      write_coord(floatround(vExplodeAt[0])) 
      write_coord(floatround(vExplodeAt[1])) 
      write_coord(floatround(vExplodeAt[2])) 
      write_short(boom) 
      write_byte(50) 
      write_byte(15) 
      write_byte(0) 
      message_end() 

      RemoveEntity(entity1) 

   } 

   if(equal(mineClassName, "proximity_mine") && equal(playerClassname,"player")) { 
      
      if (pminearmed[idtransfer[owner]])
      {
      new params[1]
      params[0] = entity1
      set_task( get_cvar_float("amx_pminedelay"),"pmine_delay",345+entity1, params, 1)
      emit_sound(entity1, CHAN_WEAPON, "weapons/c4_click.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
      }
   } 
}
return 0; 
}

public pmine_delay(params[])
{	
	new owner = Entvars_Get_Edict(params[0], EV_ENT_owner)
	
	new Float: vExplodeAt[3] 
	Entvars_Get_Vector(params[0], EV_VEC_origin, vExplodeAt)	
	
	radius_damage(owner, 50.0, vExplodeAt, 200.0, DMG_BLAST, "mine")
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
	write_byte(3) 
	write_coord(floatround(vExplodeAt[0]))
	write_coord(floatround(vExplodeAt[1])) 
	write_coord(floatround(vExplodeAt[2])) 
	write_short(boom) 
	write_byte(50) 
	write_byte(15) 
	write_byte(0) 
	message_end()

	RemoveEntity(params[0])
	pminearmed[idtransfer[owner]] = false
	pmineplanted[idtransfer[owner]] = false
	remove_task(345+params[0])

	return PLUGIN_HANDLED
}

public plant_lmine(id)
{

	new args[32]
	read_argv(0,args,31)
	new cvar = get_cvar_num("amx_lmines")
	
	if(equal(args,"amx_lmine"))
	{
		if(!(get_user_flags(id)&ADMIN_ACCESS))
		{
			client_print(id,print_chat,"[AMX Mines] **** You have no access to that command ****")
			return PLUGIN_HANDLED
		}
		lmineammo[id] = 1	
	}
		
	if (cvar == 1 || equal(args,"amx_lmine"))
	{
	
		if (!is_user_alive(id))
		{
		client_print(id,print_chat,"[AMX Mines] **** You cannot plant mines while you are dead ****")
		return PLUGIN_HANDLED
		}
		
		if (get_cvar_num("amx_mine_buying") == 0)
		{
		if (mineammo[id] == 0)
		{
		client_print(id,print_chat,"[AMX Mines] **** You currently have no mines ****")
		return PLUGIN_HANDLED
		}
		}
		else if(lmineammo[id] == 0)
		{
		client_print(id,print_chat,"[AMX Mines] **** You currently have no Land mines ****")
		return PLUGIN_HANDLED
		}
		
		pminearmed[id] = false
		lmine[id] = CreateEntity("info_target") 

        	if(lmine[id] == 0) { 
		return PLUGIN_HANDLED_MAIN 
        	} 
		Entvars_Set_String(lmine[id], EV_SZ_classname, "land_mine") 

        	ENT_SetModel(lmine[id], "models/w_hegrenade.mdl") 

		new Float:MinBox[3]
		new Float:MaxBox[3]
		MinBox[0] = -1.0
		MinBox[1] = -1.0
		MinBox[2] = -1.0
		MaxBox[0] = 1.0
		MaxBox[1] = 1.0
		MaxBox[2] = 1.0

		entity_set_size(lmine[id], MinBox, MaxBox) 

		new Float: porigin[3]
		Entvars_Get_Vector(id, EV_VEC_origin, porigin)
		
		new Float:Angles[3]
		Entvars_Get_Vector(id, EV_VEC_v_angle, Angles)

		ENT_SetOrigin(lmine[id], porigin)

		Entvars_Set_Vector(lmine[id], EV_VEC_angles, Angles)

		Entvars_Set_Int(lmine[id], EV_INT_effects, 32) 
		Entvars_Set_Int(lmine[id], EV_INT_solid, 2)    
		Entvars_Set_Int(lmine[id], EV_INT_movetype, get_cvar_num("amx_minemovetype"))
		Entvars_Set_Edict(lmine[id], EV_ENT_owner, id)

		if(!(get_user_button(id)&IN_DUCK))
		{
		new Float:velocity[3]
		VelocityByAim(id, get_cvar_num("amx_minetossforce") , velocity)
		Entvars_Set_Vector(lmine[id], EV_VEC_velocity, velocity)
		}
	
		emit_sound(lmine[id], CHAN_WEAPON, "weapons/c4_click.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		
		if(equal(args,"amx_lmine"))
		{
		client_print(id,print_chat,"[AMX Mines] **** You just used amx_lmine ****")
		lmineammo[id] = 0
		}
		else
		{
		if(get_cvar_num("amx_mine_buying") == 0)
		{
		mineammo[id] = mineammo[id] - 1
		client_print(id,print_center,"[AMX Mines] **** You have %i mine(s) left ****",mineammo[id])
		}
		else
		{
		lmineammo[id] = lmineammo[id] - 1
		client_print(id,print_center,"[AMX Mines **** You have %i Land Mine(s) left ****",lmineammo[id])
		}
		}
		
	}
	else
	{
	client_print(id,print_chat,"[AMX Mines] **** Land Mines are disabled ****")
	return PLUGIN_HANDLED
	}

	return PLUGIN_HANDLED
}

public plant_pmine(id)
{

	new args[32]
	read_argv(0,args,31)
	new cvar = get_cvar_num("amx_pmines")

	if(equal(args,"amx_pmine"))
	{
		if(!(get_user_flags(id)&ADMIN_ACCESS))
		{
			client_print(id,print_chat,"[AMX Mines] **** You have no access to that command ****")
			return PLUGIN_HANDLED
		}
		pmineammo[id] = 1	
	}

	if (cvar == 1 || equal(args,"amx_pmine"))
	{
	
		if (!is_user_alive(id))
		{
		client_print(id,print_chat,"[AMX Mines] **** You cannot plant mines while you are dead ****")
		return PLUGIN_HANDLED
		}
		
		if(get_cvar_num("amx_mine_buying") == 0)
		{
		if (mineammo[id] == 0)
		{
		client_print(id,print_chat,"[AMX Mines] **** You currently have no mines ****")
		return PLUGIN_HANDLED
		}
		}
		else if(pmineammo[id] == 0)
		{
		client_print(id,print_chat,"[AMX Mines] **** You currently have no Proximity mines ****")
		return PLUGIN_HANDLED
		}
		
		if (pmineplanted[id])
		{
		client_print(id,print_chat,"[AMX Mines] **** You can only plant one proximity mine at a time ****")
		return PLUGIN_HANDLED
		}
		
		pmine[id] = CreateEntity("info_target") 

        	if(pmine[id] == 0) { 
		return PLUGIN_HANDLED_MAIN 
        	} 
		Entvars_Set_String(pmine[id], EV_SZ_classname, "proximity_mine") 

        	ENT_SetModel(pmine[id], "models/w_grenade.mdl") 

		new Float:MinBox[3]
		new Float:MaxBox[3]
		MinBox[0] = -1.0
		MinBox[1] = -1.0
		MinBox[2] = -1.0
		MaxBox[0] = 1.0
		MaxBox[1] = 1.0
		MaxBox[2] = 1.0

		entity_set_size(pmine[id], MinBox, MaxBox)

		new Float: porigin[3]
		Entvars_Get_Vector(id, EV_VEC_origin, porigin)

		new Float:Angles[3]
		Entvars_Get_Vector(id, EV_VEC_v_angle, Angles)

		ENT_SetOrigin(pmine[id], porigin)
		
		Entvars_Set_Vector(pmine[id], EV_VEC_angles, Angles)
		
		Entvars_Set_Int(pmine[id], EV_INT_effects, 32) 
		Entvars_Set_Int(pmine[id], EV_INT_solid, 1)    
		Entvars_Set_Int(pmine[id], EV_INT_movetype, get_cvar_num("amx_minemovetype"))
		Entvars_Set_Edict(pmine[id], EV_ENT_owner, id)

		if(!(get_user_button(id)&IN_DUCK))
		{
		new Float:velocity[3]
		VelocityByAim(id, get_cvar_num("amx_minetossforce") , velocity)
		Entvars_Set_Vector(pmine[id], EV_VEC_velocity, velocity)
		}
	
		emit_sound(pmine[id], CHAN_WEAPON, "weapons/c4_click.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		
		pmineplanted[id] = true
		
		if(equal(args,"amx_pmine"))
		{
		client_print(id,print_chat,"[AMX Mines] **** You just used amx_pmine ****")
		pmineammo[id] = 0
		}
		else
		{
		if(get_cvar_num("amx_mine_buying") == 0)
		{
		mineammo[id] = mineammo[id] - 1
		client_print(id,print_center,"[AMX Mines] **** You have %i mine(s) left ****",mineammo[id])
		}
		else
		{
		pmineammo[id] = pmineammo[id] - 1
		client_print(id,print_center,"[AMX Mines] **** You have %i Proximity mine(s) left ****",pmineammo[id])
		}
		}
		
		new ids[1]
		ids[0] = id
		new owner = Entvars_Get_Edict(pmine[id], EV_ENT_owner)
		idtransfer[owner] = ids[0]
		set_task( get_cvar_float("amx_pminearmdelay") ,"pmine_arm_delay", 456+id, ids, 1)
	}
	else
	{
	client_print(id,print_chat,"[AMX Mines] **** Proximity Mines are disabled ****")
	return PLUGIN_HANDLED
	}
	

	return PLUGIN_HANDLED
}

public pmine_arm_delay(ids[])
{
	new Float:pminedudorigin[3]
	new Float:pmineairspeed[3]
	Entvars_Get_Vector(pmine[ids[0]], EV_VEC_origin, pminedudorigin)
	Entvars_Get_Vector(pmine[ids[0]], EV_VEC_velocity, pmineairspeed)
	
	new Float:MinBox[3]
	new Float:MaxBox[3]
	MinBox[0] = -75.0
	MinBox[1] = -75.0
	MinBox[2] = -1.0
	MaxBox[0] = 75.0
	MaxBox[1] = 75.0
	MaxBox[2] = 75.0

	entity_set_size(pmine[ids[0]], MinBox, MaxBox) 

	ENT_SetOrigin(pmine[ids[0]], pminedudorigin)
	
	Entvars_Set_Vector(pmine[ids[0]], EV_VEC_velocity, pmineairspeed)
	
	pminearmed[ids[0]] = true
	emit_sound(pmine[ids[0]], CHAN_WEAPON, "weapons/c4_click.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	remove_task(456+ids[0])

	return PLUGIN_HANDLED
}

public plant_rmine(id){ 

	new args[32]
	read_argv(0,args,31)
	new cvar = get_cvar_num("amx_rmines")

	if(equal(args,"amx_rmine"))
	{
		if(!(get_user_flags(id)&ADMIN_ACCESS))
		{
			client_print(id,print_chat,"[AMX Mines] **** You have no access to that command ****")
			return PLUGIN_HANDLED
		}
		rmineammo[id] = 1	
	}

	if (cvar == 1 || equal(args,"amx_rmine"))
	{

		if (!is_user_alive(id))
		{
		client_print(id,print_chat,"[AMX Mines] ****You cannot plant mines while you are dead****")
		return PLUGIN_HANDLED
		}

		if (planted[id])
		{
		new Float: vExplodeAt[33][3]

		Entvars_Get_Vector(rmine[id], EV_VEC_origin, vExplodeAt[id]) 

		radius_damage(id, 50.0, vExplodeAt[id], 200.0, DMG_BLAST, "mine")

		message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
		write_byte(3) 
		write_coord(floatround(vExplodeAt[id][0])) 
		write_coord(floatround(vExplodeAt[id][1])) 
		write_coord(floatround(vExplodeAt[id][2])) 
		write_short(boom) 
		write_byte(50) 
		write_byte(15) 
		write_byte(0) 
		message_end() 

		RemoveEntity(rmine[id])
		planted[id] = false
	
		return PLUGIN_HANDLED
		}
		else if (!planted[id])
		{
		
		if(get_cvar_num("amx_mine_buying") == 0)
		{
		if (mineammo[id] == 0)
		{
		client_print(id,print_chat,"[AMX Mines] **** You currently have no mines ****")
		return PLUGIN_HANDLED
		}
		}
		else if(rmineammo[id] == 0)
		{
		client_print(id,print_chat,"[AMX Mines] **** You currently have no Remote mines ****")
		return PLUGIN_HANDLED
		}

		rmine[id] = CreateEntity("info_target") 

        	if(rmine[id] == 0) { 
            	return PLUGIN_HANDLED_MAIN 
        	} 
		Entvars_Set_String(rmine[id], EV_SZ_classname, "remote_mine")

        	ENT_SetModel(rmine[id], "models/w_c4.mdl") 
		
		new Float:MinBox[3]
		new Float:MaxBox[3]
		MinBox[0] = -1.0
		MinBox[1] = -1.0
		MinBox[2] = -1.0
		MaxBox[0] = 1.0
		MaxBox[1] = 1.0
		MaxBox[2] = 1.0

		entity_set_size(rmine[id], MinBox, MaxBox) 

		new Float: porigin[3]
		Entvars_Get_Vector(id, EV_VEC_origin, porigin)

		new Float:Angles[3]
		Entvars_Get_Vector(id, EV_VEC_v_angle, Angles)

		ENT_SetOrigin(rmine[id], porigin) 
		Entvars_Set_Vector(rmine[id], EV_VEC_angles, Angles)

		Entvars_Set_Int(rmine[id], EV_INT_effects, 32) 
		Entvars_Set_Int(rmine[id], EV_INT_solid, 0)    
		Entvars_Set_Int(rmine[id], EV_INT_movetype, get_cvar_num("amx_minemovetype"))
		Entvars_Set_Edict(rmine[id], EV_ENT_owner, id)

		if(!(get_user_button(id)&IN_DUCK))
		{
		new Float:velocity[3]
		VelocityByAim(id, get_cvar_num("amx_minetossforce") , velocity)
		Entvars_Set_Vector(rmine[id], EV_VEC_velocity, velocity)
		}

		emit_sound(rmine[id], CHAN_WEAPON, "weapons/c4_plant.wav", 1.0, ATTN_NORM, 0, PITCH_NORM) 

		planted[id] = true
		
		if(equal(args,"amx_rmine"))
		{
		client_print(id,print_chat,"[AMX Mines] **** You just used amx_rmine ****")
		rmineammo[id] = 0
		}
		else
		{
		if(get_cvar_num("amx_mine_buying") == 0)
		{
		mineammo[id]= mineammo[id] - 1
		client_print(id,print_center,"[AMX Mines] **** You have %i mine(s) left ****",mineammo[id])
		}
		else
		{
		rmineammo[id] = rmineammo[id] - 1
		client_print(id,print_center,"[AMX Mines] **** You have %i Remote mine(s) left ****",rmineammo[id])
		}
		}
		}
	
	}
	else
	{
	client_print(id,print_chat,"[AMX Mines] **** Remote Mines are disabled****")
	return PLUGIN_HANDLED
	}
	

	return PLUGIN_HANDLED
}

public plant_tmine(id)
{
	new args[32]
	read_argv(0,args,31)
	new cvar = get_cvar_num("amx_tmines")

	if(equal(args,"amx_tmine"))
	{
		if(!(get_user_flags(id)&ADMIN_ACCESS))
		{
			client_print(id,print_chat,"[AMX Mines] **** You have no access to that command ****")
			return PLUGIN_HANDLED
		}
		tmineammo[id] = 1
	}

	if (cvar == 1 || equal(args,"amx_tmine"))
	{
		if (!tmineplanted[id])
		{
	
		if (!is_user_alive(id))
		{
		client_print(id,print_chat,"[AMX Mines] **** You cannot plant mines while you are dead ****")
		return PLUGIN_HANDLED
		}

		if(get_cvar_num("amx_mine_buying") == 0)
		{
		if (mineammo[id] == 0)
		{
		client_print(id,print_chat,"[AMX Mines] **** You currently have no mines ****")
		return PLUGIN_HANDLED
		}
		}
		else if(tmineammo[id] == 0)
		{
		client_print(id,print_chat,"[AMX Mines] **** You currently have no Timed mines ****")
		return PLUGIN_HANDLED
		}

		tmine[id] = CreateEntity("info_target") 

        	if(tmine[id] == 0) { 
		return PLUGIN_HANDLED_MAIN 
        	} 
		Entvars_Set_String(tmine[id], EV_SZ_classname, "timed_mine") 

        	ENT_SetModel(tmine[id], "models/w_adrenaline.mdl") 

		new Float:MinBox[3]
		new Float:MaxBox[3]
		MinBox[0] = -1.0
		MinBox[1] = -1.0
		MinBox[2] = -1.0
		MaxBox[0] = 1.0
		MaxBox[1] = 1.0
		MaxBox[2] = 1.0

		entity_set_size(tmine[id], MinBox, MaxBox)  

		new Float: porigin[3]
		Entvars_Get_Vector(id, EV_VEC_origin, porigin)

		new Float:Angles[3]
		Entvars_Get_Vector(id, EV_VEC_v_angle, Angles)

		ENT_SetOrigin(tmine[id], porigin) 
		Entvars_Set_Vector(tmine[id], EV_VEC_angles, Angles)

		Entvars_Set_Int(tmine[id], EV_INT_effects, 32) 
		Entvars_Set_Int(tmine[id], EV_INT_solid, 0)    
		Entvars_Set_Int(tmine[id], EV_INT_movetype, get_cvar_num("amx_minemovetype"))
		Entvars_Set_Edict(tmine[id], EV_ENT_owner, id) 

		if(!(get_user_button(id)&IN_DUCK))
		{
		new Float:velocity[3]
		VelocityByAim(id, get_cvar_num("amx_minetossforce") , velocity)
		Entvars_Set_Vector(tmine[id], EV_VEC_velocity, velocity)
		}

		emit_sound(tmine[id], CHAN_WEAPON, "weapons/c4_plant.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	
		tmineplanted[id] = true
		
		if(equal(args,"amx_tmine"))
		{
		client_print(id,print_chat,"[AMX Mines] **** You just used amx_tmine ****")
		tmineammo[id] = 0
		}
		else
		{
		if(get_cvar_num("amx_mine_buying") == 0)
		{
		mineammo[id]= mineammo[id] - 1
		client_print(id,print_center,"[AMX Mines] **** You have %i mine(s) left ****",mineammo[id])
		}
		else
		{
		tmineammo[id] = tmineammo[id] - 1
		client_print(id,print_center,"[AMX Mines] **** You have %i mine(s) left ****",tmineammo[id])
		}
		}
		
		new ids[1]
		ids[0] = id
		set_task( get_cvar_float("amx_minetimer") ,"tmine_delay", 123+id, ids, 1)
		}
		else
		{
		client_print(id,print_chat,"[AMX Mines] **** You can only plant one timed mine at a time ****")
		return PLUGIN_HANDLED
		}

	}
	else
	{
	client_print(id,print_chat,"[AMX Mines] **** Timed Mines are disabled ****")
	return PLUGIN_HANDLED
	}


	return PLUGIN_HANDLED
}

public tmine_delay(ids[])
{
	remove_task(123+ids[0])
	tExplode(ids[0])

	return PLUGIN_HANDLED
}

public tExplode(id)
{
	new Float: tmineExplodeAt[33][3]

	Entvars_Get_Vector(tmine[id], EV_VEC_origin, tmineExplodeAt[id]) 
	
	radius_damage(id, 50.0, tmineExplodeAt[id], 200.0, DMG_BLAST, "mine")

	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
	write_byte(3) 
	write_coord(floatround(tmineExplodeAt[id][0])) 
	write_coord(floatround(tmineExplodeAt[id][1])) 
	write_coord(floatround(tmineExplodeAt[id][2])) 
	write_short(boom) 
	write_byte(50) 
	write_byte(15) 
	write_byte(0) 
	message_end() 

	RemoveEntity(tmine[id]) 
	tmineplanted[id] = false

	return PLUGIN_CONTINUE
}

public new_round(id)
{
	new teamname[20]
	get_user_team(id,teamname,19)
	
	if(get_cvar_num("amx_mine_buying") == 0 && mineammo[id] < get_cvar_num("amx_mineammo"))
	mineammo[id] = get_cvar_num("amx_mineammo")
	
	planted[id] = false
	pminearmed[id] = false
	tmineplanted[id] = false
	pmineplanted[id] = false
	minepickup[id] = false
	
	if(get_cvar_num("amx_mine_buying") == 1 && (equal(teamname,"CT") || equal(teamname,"TERRORIST")))
	client_cmd(id,"mine_buy_menu")
	
	remove_entities("mineammo_pickup")
	remove_entities("remote_mine")
	remove_entities("proximity_mine")
	remove_entities("timed_mine")
	remove_entities("land_mine")

	return PLUGIN_CONTINUE
}


public minehelp(id)
{
	new mine_motd[1300]
	new text[768]
	text = "To use your mines you have to bind keys to:^n^n\
	plant_tmine   |   plant_rmine   |   plant_lmine   |   plant_pmine^n\
	Or you can access them all by binding a key to mine_menu^n^n\
	In order to do that you must open your console and use the bind command: ^n^n\
	bind ^"key^" ^"command^" ^n^n\
	In this case the command is ^"plant_rmine^".  Here are some examples:^n^n\
	bind f mine_plant            bind MOUSE3 mine_plant^n^n"
	add(mine_motd,1299,text)
	text = "- For Timed, Proximity, and Land mines, you need to use the command ^n\
	only once.^n- For Remote mines you  need to use it once to plant, then^n\
	once more to detonate.^n- You can't plant while dead^n- There is an ammo limit^n\
	based on whether mine buying is enabled or not.^n- To plant a mine without throwing^n\
	plant while you are crouched.^n"
	add(mine_motd,1299,text)
	text = "- Players will drop mines on death, unless otherwise set by admins^n^n\
	say /mineammo to find out how much ammo you have per round.^n^n Admins type amx_minehelp in console for help"
	add(mine_motd,1299,text)
	show_motd(id,mine_motd,"Mine Help:")
	
	return PLUGIN_HANDLED
}

public say_mineammo(id)
{

	if(get_cvar_num("amx_mine_buying") == 0)
	{
	client_print(id,print_chat,"[AMX Mines] ****   You have %i mine(s) remaining    ****",mineammo[id])
	}
	else
	{
	new rmines,tmines,lmines,pmines
	rmines = rmineammo[id]
	tmines = tmineammo[id]
	lmines = lmineammo[id]
	pmines = pmineammo[id]
	client_print(id,print_chat,"[AMX Mines] **** %i Remote Mine(s) | %i Proximity Mine(s) ****",rmines,pmines)
	client_print(id,print_chat,"[AMX Mines] **** %i Land Mine(s) | %i Timed Mine(s) ****",lmines,tmines)
	}
	return PLUGIN_HANDLED
}

public show_main_menu(id){ 
   
   if(get_cvar_num("amx_rmines") == 0 && get_cvar_num("amx_pmines") == 0 && get_cvar_num("amx_tmines") == 0 && get_cvar_num("amx_lmines") == 0)
   {
   client_print(id,print_chat,"[AMX Mines] **** Mines are currently Disabled ****")
   return PLUGIN_HANDLED
   }
   
   new menu_body[256] 
   new modname[33]
   get_modname(modname,32)
   
   if(equal(modname,"cstrike"))
   {
   copy(menu_body,255,"\yMine Menu^n\w^n1. Remote Mine (Detonate)^n2. Proximity Mine^n\ 
   3. Timed Mine^n4. Land Mine^n^n5. Mine Help Window^n6. Check Mine Ammo^n^n7. Mine Buy Menu^n^n8. Drop Mines^n^n0. Exit") 
   }
   else
   {
   copy(menu_body,255,"Mine Menu^n^n1. Remote Mine (Detonate)^n2. Proximity Mine^n\ 
   3. Timed Mine^n4. Land Mine^n^n5. Mine Help Window^n 6. Check Mine Ammo^n^n7. Mine Buy Menu^n^n8. Drop Mines^n^n0. Exit") 
   }
  
   new a1,a2,a3,a4,a5,a6,a7,a8, keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<9) 
   
   format(menu_body,255,menu_body,a1,a2,a3,a4,a5,a6,a7,a8) 
   show_menu(id,keys,menu_body) 
   return PLUGIN_HANDLED 
}

public show_mine_buymenu(id){ 
   
   if(get_cvar_num("amx_mine_buying") == 0)
   {
   client_print(id,print_chat,"[AMX Mines] **** Mines are free right now, you have %i ****", mineammo[id])
   return PLUGIN_HANDLED
   }
   
   new menu_body[256] 
   new modname[33]
   get_modname(modname,32)
   
   new rminecost,pminecost,tminecost,lminecost
   rminecost = get_cvar_num("amx_rmine_cost")
   pminecost = get_cvar_num("amx_pmine_cost")
   tminecost = get_cvar_num("amx_tmine_cost")
   lminecost = get_cvar_num("amx_lmine_cost")
   
   if(equal(modname,"cstrike"))
   {
   copy(menu_body,255,"\yMine Purchase Menu^n\w^n1. Remote Mine $%i^n2. Proximity Mine $%i^n\ 
   3. Timed Mine $%i^n4. Land Mine $%i^n^n^n^n^n0. Exit") 
   }
   else
   {
   copy(menu_body,255,"Mine Purchase Menu^n^n1. Remote Mine $%i^n2. Proximity Mine $%i^n\ 
   3. Timed Mine $%i^n4. Land Mine $%i^n^n^n^n^n0. Exit") 
   }
  
   new keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<9) 
   
   format(menu_body,255,menu_body,rminecost,pminecost,tminecost,lminecost) 
   show_menu(id,keys,menu_body) 
   return PLUGIN_HANDLED 
}

public show_admin_menu(id){ 
   
   if(!(get_user_flags(id)&ADMIN_ACCESS))
   {
   client_print(id,print_chat,"[AMX Mines] **** You have no access to that command ****")
   return PLUGIN_HANDLED
   }
   
   new menu_body[256] 
   new modname[33]
   get_modname(modname,32)
   
   if(equal(modname,"cstrike"))
   {
   copy(menu_body,255,"\yMine Admin Menu^n\w^n1. amx_rmine^n2. amx_pmine^n\ 
   3. amx_tmine^n4. amx_lmine^n^n5. Admin Help Menu^n^n6. Enable(Disable) Mines^n0. Exit") 
   }
   else
   {
   copy(menu_body,255,"Mine Admin Menu^n^n1. amx_rmine^n2. amx_pmine^n\ 
   3. amx_tmine^n4. amx_lmine^n^n5. Admin Help Menu^n^n6. Enable(Disable) Mines^n0. Exit") 
   }
  
   new a1,a2,a3,a4,a5, keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<9) 
   
   format(menu_body,255,menu_body,a1,a2,a3,a4,a5) 
   show_menu(id,keys,menu_body) 
   return PLUGIN_HANDLED 
}

public action_main_menu(id,key){ 
   switch(key){ 
      case 0: client_cmd(id,"plant_rmine") 
      case 1: client_cmd(id,"plant_pmine")  
      case 2: client_cmd(id,"plant_tmine")  
      case 3: client_cmd(id,"plant_lmine") 
      case 4: client_cmd(id,"say /minehelp") 
      case 5: client_cmd(id,"say /mineammo") 
      case 6: client_cmd(id,"mine_buy_menu")
      case 7: player_drop_mines(id)
   } 
   return PLUGIN_HANDLED 
} 

public action_buy_mines(id,key)
{
	
	new money = get_user_money(id)
	
	new rminecost,pminecost,tminecost,lminecost
	rminecost = get_cvar_num("amx_rmine_cost")
	pminecost = get_cvar_num("amx_pmine_cost")
	tminecost = get_cvar_num("amx_tmine_cost")
	lminecost = get_cvar_num("amx_lmine_cost")
	
	if(key == 0)
	{
	
    if(money < rminecost)
    {
    client_print(id,print_chat,"[AMX Mines] **** You have insufficient funds for a Remote Mine ****")
    return PLUGIN_HANDLED
    }
	
    set_user_money(id,money - rminecost)
    rmineammo[id] = rmineammo[id] + 1
    client_print(id,print_chat,"[AMX Mines] **** You just purchased a Remote Mine ****")
    return PLUGIN_HANDLED
    }
    
   	if(key == 1)
   	{
   	
   	if(money < pminecost)
	{
	client_print(id,print_chat,"[AMX Mines] **** You have insufficient funds for a Proximity Mine ****")
	return PLUGIN_HANDLED
	}
   	
	set_user_money(id,money - pminecost)
	pmineammo[id] = pmineammo[id] + 1
	client_print(id,print_chat,"[AMX Mines] **** You just purchased a Proximity Mine ****")
	return PLUGIN_HANDLED
	}
	
	if(key == 2)
	{
	
	if(money < tminecost)
	{
		client_print(id,print_chat,"[AMX Mines] **** You have insufficient funds for a Timed Mine ****")
		return PLUGIN_HANDLED
	}
	
	set_user_money(id,money - tminecost)
	tmineammo[id] = tmineammo[id] + 1
	client_print(id,print_chat,"[AMX Mines] **** You just purchased a Timed Mine ****")
	return PLUGIN_HANDLED
	}
	
	if(key == 3)
	{
	
    if(money < lminecost)
    {
        client_print(id,print_chat,"[AMX Mines] **** You have insufficient funds for a Land Mine ****")
        return PLUGIN_HANDLED
    }
	
    set_user_money(id,money - lminecost)
    lmineammo[id] = lmineammo[id] + 1
    client_print(id,print_chat,"[AMX Mines] **** You just purchased a Land Mine ****")
    return PLUGIN_HANDLED
    }
	
	return PLUGIN_HANDLED
}

public action_admin_menu(id,key)
{
	switch(key)
	{
	case 0: client_cmd(id,"amx_rmine")
	case 1: client_cmd(id,"amx_pmine")
	case 2: client_cmd(id,"amx_tmine")
	case 3: client_cmd(id,"amx_lmine")
	case 4: client_cmd(id,"amx_minehelp")
	case 5: client_cmd(id,"amx_mines")
	}
	return PLUGIN_HANDLED
}
	
public mine_switch(id)
{
	if(get_cvar_num("amx_rmines") == 1 || get_cvar_num("amx_pmines") == 1 || get_cvar_num("amx_lmines") == 1 || get_cvar_num("amx_tmines") == 1)
	{
	set_cvar_string("amx_rmines", "0")
	set_cvar_string("amx_tmines", "0")
	set_cvar_string("amx_pmines", "0")
	set_cvar_string("amx_lmines", "0")
	client_print(0,print_chat,"[AMX Mines] **** All mines have been disabled ****") 
	return PLUGIN_HANDLED
	}
	
	if(get_cvar_num("amx_rmines") == 0 || get_cvar_num("amx_pmines") == 0 || get_cvar_num("amx_lmines") == 0 || get_cvar_num("amx_tmines") == 0)
	{
	set_cvar_string("amx_rmines", "1")
	set_cvar_string("amx_tmines", "1")
	set_cvar_string("amx_pmines", "1")
	set_cvar_string("amx_lmines", "1")
	client_print(0,print_chat,"[AMX Mines] **** All mines have been enabled ****") 
	return PLUGIN_HANDLED
	}	
	return PLUGIN_HANDLED
}

public show_admin_help(id)
{
	new mine_motd[1300]
	new text[768]
	text = "Cvar List:^n^namx_mineammo | Amount of free mines every round^namx_rmines | Toggles Remote Mines^n\
	amx_tmines | Toggles Timed Mines^namx_lmines | Toggles Land Mines^namx_pmines | Toggles Proximity Mines^n\
	amx_minetimer | Amount of time for a Timed Mine^namx_pminedelay | Delay before pmine is explodes when triggered^n\
	amx_pminearmdelay | Delay before pmine is armed^n"
	add(mine_motd,1299,text)
	text = "amx_minetossforce | Force at which mines are thrown^namx_minemovetype | Movetype of mines (Warning: Must be valid type)^n\
	amx_mine_buying | Toggles mine buying^namx_rmine_cost | Cost to buy Remote Mine^namx_pmine_cost | Cost to buy a Proximity Mine^n\
	amx_tmine_cost | Cost to buy a Timed Mine^namx_lmine_cost | Cost to buy a Land Mine^namx_dropmines | Toggles mine dropping^n^n"
	add(mine_motd,1299,text)
	text = "Commands:^n^namx_mines | Turns ON/OFF All mines^nsay /minehelp | Brings up minehelp Motd^n\
	say /mineammo | Brings up ammo check Motd^nmine_menu | Brings up Main mine menu^nmine_buy_menu | Brings up Mine buy Menu^n\
	amx_rmine | Admin rmine that doesn't deplete ammo^namx_pmine | Admin pmine that doesn't deplete ammo^namx_tmine | Admin tmine that doesn't deplete ammo^n\
	amx_lmine | Admin lmine that doesn't deplete ammo^n"
	add(mine_motd,1299,text)
	show_motd(id,mine_motd,"Admin Mine Help:")
	
	return PLUGIN_HANDLED
}

public player_death()
{
	
	new id = read_data(2)
	
	new c1,c2,c3,c4
	c1 = get_cvar_num("amx_rmines")
	c2 = get_cvar_num("amx_pmines")
	c3 = get_cvar_num("amx_tmines")
	c4 = get_cvar_num("amx_lmines")
	
	if(c1 == 1 || c2 == 1 || c3 == 1 || c4 == 1)
	{
	player_drop_mines(id)
	}
	
	return PLUGIN_CONTINUE
}

public player_drop_mines(id)
{

	if(get_cvar_num("amx_dropmines") == 0)
	{
	client_print(id,print_chat,"[AMX Mines] **** Mines cannot be dropped ****")
	return PLUGIN_HANDLED
	}
	
	if(get_cvar_num("amx_mine_buying") == 0)
	{
	if(mineammo[id] == 0)
	return PLUGIN_HANDLED
	}
	else if(get_cvar_num("amx_mine_buying") == 1)
	{
	if(rmineammo[id] == 0 && pmineammo[id] == 0 && tmineammo[id] == 0 && lmineammo[id] == 0)
	return PLUGIN_HANDLED
	}
	ammobox[id] = CreateEntity("info_target") 

	if(ammobox[id] == 0) { 
	return PLUGIN_HANDLED_MAIN 
    } 
	Entvars_Set_String(ammobox[id], EV_SZ_classname, "mineammo_pickup") 

	ENT_SetModel(ammobox[id], "models/w_backpack.mdl") 

	new Float:MinBox[3]
	new Float:MaxBox[3]
	MinBox[0] = -1.0
	MinBox[1] = -1.0
	MinBox[2] = -1.0
	MaxBox[0] = 1.0
	MaxBox[1] = 1.0
	MaxBox[2] = 1.0

	entity_set_size(ammobox[id], MinBox, MaxBox)  

	new Float: porigin[3]
	Entvars_Get_Vector(id, EV_VEC_origin, porigin)

	new Float:Angles[3]
	Entvars_Get_Vector(id, EV_VEC_v_angle, Angles)

	ENT_SetOrigin(ammobox[id], porigin) 
	Entvars_Set_Vector(ammobox[id], EV_VEC_angles, Angles)

	Entvars_Set_Int(ammobox[id], EV_INT_effects, 32) 
	Entvars_Set_Int(ammobox[id], EV_INT_solid, 1)    
	Entvars_Set_Int(ammobox[id], EV_INT_movetype, 6)
	Entvars_Set_Edict(ammobox[id], EV_ENT_owner, id)
	
	new Float:velocity[3]
	VelocityByAim(id, 400 , velocity)
	Entvars_Set_Vector(ammobox[id], EV_VEC_velocity, velocity)
	
	emit_sound(ammobox[id], CHAN_WEAPON, "weapons/boltdown.wav", 1.0, ATTN_NORM, 0, PITCH_NORM) 
	client_print(id,print_chat,"[AMX Mines] **** You just dropped your mines ****")
	
	holdammo[id] = mineammo[id]
	holdrammo[id] = rmineammo[id]
	holdpammo[id] = pmineammo[id]
	holdtammo[id] = tmineammo[id]
	holdlammo[id] = lmineammo[id]
	
	mineammo[id] = 0
	rmineammo[id] = 0
	pmineammo[id] = 0
	tmineammo[id] = 0 
	lmineammo[id] = 0
	
	new idpass[1]
	idpass[0] = id
	
	set_task(1.0,"true_ownerpickup",1001+id,idpass,1)
	
	return PLUGIN_HANDLED
}

public true_ownerpickup(idpass[])
{
	minepickup[idpass[0]] = true
	remove_task(1001+idpass[0])
	return PLUGIN_HANDLED
}


public plugin_init(){

	register_plugin("Mines","0.9.2.3","-]ToC[-Bludy") 
	
	register_clcmd("plant_rmine","plant_rmine",0,": Plants a Remote Mine")
	register_clcmd("plant_tmine","plant_tmine",0,": Plants a Timed Mine")
	register_clcmd("plant_lmine","plant_lmine",0,": Plants a Land Mine")
	register_clcmd("plant_pmine","plant_pmine",0,": Plants a Proximity Mine")
	register_clcmd("amx_rmine","plant_rmine",ADMIN_ACCESS,": Plants a mine but doesnt deplete mine ammo")
	register_clcmd("amx_tmine","plant_tmine",ADMIN_ACCESS,": Plants a mine but doesnt deplete mine ammo")
	register_clcmd("amx_lmine","plant_lmine",ADMIN_ACCESS,": Plants a mine but doesnt deplete mine ammo")
	register_clcmd("amx_pmine","plant_pmine",ADMIN_ACCESS,": Plants a mine but doesnt deplete mine ammo")
	register_clcmd("say /minehelp","minehelp",0,": Opens the MineHelp Window")
	register_clcmd("say /mineammo","say_mineammo",0,": Shows current mine ammo")
	register_clcmd("mine_menu","show_main_menu",0,": Opens Mine Menu")
	register_clcmd("mine_buy_menu","show_mine_buymenu",0,": Opens Mine Purchase Menu")
	register_clcmd("amx_mine_menu","show_admin_menu",ADMIN_ACCESS,": Opens Admin Mine Menu")
	register_clcmd("amx_minehelp","show_admin_help",ADMIN_SLAY,":gets a help window for admins about mines")
	
	register_concmd("amx_mines","mine_switch",ADMIN_SLAY,": Turns mines on and off")
	
	register_menucmd(register_menuid("Mine Menu"),1023,"action_main_menu") 
	register_menucmd(register_menuid("Mine Purchase Menu"),1023,"action_buy_mines")
	register_menucmd(register_menuid("Mine Admin Menu"),1023,"action_admin_menu")
	
	register_cvar("amx_mineammo","1")
	register_cvar("amx_rmines","0")
	register_cvar("amx_tmines","0")
	register_cvar("amx_lmines","0")
	register_cvar("amx_pmines","0")
	register_cvar("amx_minetimer","5")
	register_cvar("amx_pminedelay","1")
	register_cvar("amx_pminearmdelay","3")
	register_cvar("amx_minetossforce","1000")
	register_cvar("amx_minemovetype","6")
	register_cvar("amx_mine_buying","0")
	register_cvar("amx_rmine_cost","1000")
	register_cvar("amx_pmine_cost","900")
	register_cvar("amx_tmine_cost","350")
	register_cvar("amx_lmine_cost","250")
	register_cvar("amx_dropmines","1")
	
	register_event("ResetHUD", "new_round", "b")
	register_event("DeathMsg", "player_death","a")
	
	return PLUGIN_CONTINUE 
} 

public plugin_precache() {
	precache_sound("weapons/c4_plant.wav") 
	precache_sound("weapons/c4_beep1.wav")
	precache_sound("weapons/c4_beep4.wav")
	precache_sound("weapons/c4_click.wav")
	precache_sound("weapons/equip_nvg.wav")
	precache_sound("weapons/boltdown.wav")
	precache_model("models/w_c4.mdl")
	precache_model("models/w_backpack.mdl")
	precache_model("models/w_grenade.mdl")
	precache_model("models/w_adrenaline.mdl")
	precache_model("models/w_hegrenade.mdl")
	boom = precache_model("sprites/zerogxplode.spr") 
	
	return PLUGIN_CONTINUE 
} 
