/* AMX Mod script. 
* 
* (c) Copyright 2002-2003, f117bomb 
* This file is provided as is (no warranties). 
*/ 

#include <amxmod> 
#include <amxmisc> 

/* 
* amx_rr <restart times> <delay> 
  amx_rr 3 3      - 3 restarts, 3sec delay each
  
  below added y _KaszpiR_
  amx_rr 3        - 3 restarts, 1 sec delay each
  amx_rr          - 1 restat, 1 second
* 
*/ 

public drestart(param[]) 
   set_cvar_string("sv_restart",param) 

public admin_rr(id, level, cid) { 
   if (!cmd_access(id, level, cid, 3)) 
      return PLUGIN_HANDLED 
   new delay,times
   new sdelay[4], stimes[4] 

   if (read_argc() == 1){
        delay = 1
        times = 1
	sdelay="1"

   }
   else 
   if(read_argc() == 2){
        delay = 1
        read_argv(1,stimes,3) 
        times = strtonum(stimes)
        sdelay="1"
   }
   else
   {
        read_argv(1,stimes,3) 
        read_argv(2,sdelay,3) 
        delay = strtonum(sdelay) 
        times = strtonum(stimes) 
   }
   for(new a = times;a > 0;--a) 
     set_task( float(delay * a) + 1.0 , "drestart", 0, sdelay, 4) 
   console_print(id,"[AMX] RR - The Game will restart %d times with a %d sec. delay between restarts",times,delay) 
   
   new authid[32],name[32] 
   get_user_authid(id,authid,15) 
   get_user_name(id,name,31) 
 
   log_message("[AMX] RR - '%s<%s>' triggered RoundRestart.",name, authid) 
   log_message("[AMX] RR - The Game will restart %d times with a %d sec. delay between restarts",times,delay) 
   return PLUGIN_HANDLED 
} 

public plugin_init() { 
   register_plugin("Admin RestartRound","0.9.2a","f117bomb") 
   register_concmd("amx_rr","admin_rr",ADMIN_LEVEL_A,"[restart times] [delay]") 
   return PLUGIN_CONTINUE 
} 



