/*AMXMOD script.
*=====
* server_rules
* Server Rules
*=====
* (server_rules.sma)
* Version 1.3 
* http://djeyl.net/forum/index.php?showtopic=11675&st=0
* (c) Copyright 2004, DoubleTap <doubletap@twazz.org>
* http://www.twazz.org
* Display Rules - ClanMod Style
* Much thanks to Deagles3 for giving this plugin some life !
* Command say /showrules 
* Added: additional say commands to display rules on more ways
* rules - showrules - serverrules - /rules - /showrules - /serverrules
* Can execute rules on players like ClanMod - amx_showrules username
* Can force rules on players at logon with cvar in amx.cfg: forcerules 1
*/  

#include <amxmod> 

public informclient(strindex[]) 
{ 
  new myindex 
  myindex=str_to_num(strindex) 
  if(myindex>0) 
    client_print(myindex,print_chat,"Say ^"RULES^" to see the rules everyone is expected to follow on this server") 

} 

#include <amxmisc>

public mandatoryinform(strindex[]) 
{ 
  new myindex 
  myindex=str_to_num(strindex) 
  if(myindex>0) 
    show_motd(myindex,"/addons/amx/rules.txt","Server Rules") 

} 

public client_putinserver(id){ 
  new str[4] 
  num_to_str(id,str,2) 
  set_task(10.0,"informclient",432211+id,str,2) 
  if(get_cvar_num("forcerules")) 
  set_task(11.0,"mandatoryinform",432611+id,str,2) 

} 

public client_disconnect(id){ 
  remove_task(432211+id) 
  remove_task(432611+id) 

} 

public server_rules(id){ 
   show_motd(id,"/addons/amx/rules.txt","Server Rules") 
   return PLUGIN_HANDLED 

} 

public admin_showthem(id,level,cid){ 
if (!cmd_access(id,level,cid,2)) 
  return PLUGIN_HANDLED 
new arg[32] 
read_argv(1,arg,31) 
new player = cmd_target(id,arg,5) 
if (!player) return PLUGIN_HANDLED 

//new name[32] 
//get_user_name(player,name,31) 
client_cmd(player,"say Don't shoot! I'm reading the rules!") 
show_motd(player,"/addons/amx/rules.txt","READ THE RULES!") 
  return PLUGIN_HANDLED 
} 

public plugin_init()  

{  
   register_plugin("Server Rules","1.2a","DoubleTap")  
   register_clcmd("say /showrules", "server_rules") 
   register_clcmd("say showrules", "server_rules") 
   register_clcmd("say /rules", "server_rules") 
   register_clcmd("say rules", "server_rules") 
   register_clcmd("say /serverrules", "server_rules") 
   register_clcmd("say serverrules", "server_rules") 
   register_cvar("forcerules","0") 
   register_concmd("amx_showrules","admin_showthem",ADMIN_SLAY,"<authid, nick or #userid>") 
   return PLUGIN_CONTINUE  
      
} 
