/*
 *  AMX Mod Script
 *
 *  AMX Mod is (c) Copyright 2002, OLO
 *  This file is provided as is (no warranties).
 */

/*
 *  Server-Side Buy Script
 *
 *  Code By: SpaceDude
 *  E-mail: eayumns@nottingham.ac.uk
 *
 *  Maintained By: JudicatorOmega
 *  E-mail: JudicatorOmega@hotmail.com 
 *
 *
 *  Installation Instructions: (from the ZIP file)
 *    Compile with the newest version of AMX Mod.
 *      Extract "buyscript.sma" to your "examples" folder and run "sc.bat"
 *      Enter your "compiled" folder and rename "BUYSCR~1.amx" to "buyscript.amx"
 *      Move "buyscript.amx" to your "plugins" folder.
 *      Add "buyscript.amx" to plugins.ini, on a new line.
 *
 *  Client Instructions (Optional):
 *    Extract "kb_act.lst" to:
 *      CS Retail:  C:\Sierra\Counter-Strike\cstrike\gfx\shell\
 *      CS MOD:     C:\Sierra\Half-Life\cstrike\gfx\shell\
 *    Play Counter-Strike and go to the controls setup menu.
 *    There should be a new section called "JudicatorOmega's Buy Script"
 *    Bind the weapons you want to quickly buy, I suggest you use the numpad.
 *    Bind the "Jump / Exit Menu" part. This is incase the menu ever does stay up,
 *    all you would have to do is jump, and the menu would exit itself.
 *
 *  Client-Side Commands:
 *
 *    "buy_usp"
 *    "buy_glock18"
 *    "buy_deagle"
 *    "buy_p228"
 *    "buy_elite"
 *    "buy_fiveseven"
 *
 *    "buy_m3"
 *    "buy_xm1014"
 *
 *    "buy_mp5navy"
 *    "buy_tmp"
 *    "buy_p90"
 *    "buy_mac10"
 *    "buy_ump45"
 *
 *    "buy_ak47"
 *    "buy_sg552"
 *    "buy_m4a1"
 *    "buy_aug"
 *    "buy_scout"
 *    "buy_awp"
 *    "buy_g3sg1"
 *    "buy_sg550"
 *
 *    "buy_m249"
 *
 *    "primeammo"
 *    "secondaryammo"
 *
 *    "buy_kevlar"
 *    "buy_kevlar&helmet"
 *    "buy_flash"
 *    "buy_he"
 *    "buy_smoke"
 *    "buy_kit"
 *    "buy_nightvision"
 *
 *  Revision History:
 *
 *    v1.00
 *      - First Release.
 */

#include <amxmod>
#define buyAmt 31 /* Total amount of buy commands below */

new clientcmd[buyAmt][33] =
{
	"buy_usp",\
	"buy_glock18",\
	"buy_deagle",\
	"buy_p228",\
	"buy_elite",\
	"buy_fiveseven",\
	"buy_m3",\
	"buy_xm1014",\
	"buy_mp5navy",\
	"buy_tmp",\
	"buy_p90",\
	"buy_mac10",\
	"buy_ump45",\
	"buy_ak47",\
	"buy_sg552",\
	"buy_m4a1",\
	"buy_aug",\
	"buy_scout",\
	"buy_awp",\
	"buy_g3sg1",\
	"buy_sg550",\
	"buy_m249",\
	"primeammo",\
	"secondaryammo",\
	"buy_kevlar",\
	"buy_kevlar&helmet",\
	"buy_flash",\
	"buy_he",\
	"buy_smoke",\
	"buy_kit",\
	"buy_nightvision"
}

new tlmenu[buyAmt] = {1, 1, 1, 1, 1, 1, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8}
new llmenu[buyAmt] = {1, 2, 3, 4, 5, 6, 1, 2, 1, 2, 3, 4, 5, 1, 2, 3, 4, 5, 6, 7, 8, 1, 0, 0, 1, 2, 3, 4, 5, 6, 7}

public buy(id)
{
	new cmd[33]
	read_argv(0,cmd,32)
	new index = -1
	for(new i = 0; i<buyAmt; i++)
	{
		if(equal(clientcmd[i],cmd))
		{
			index = i
			break
		}
	}
	if(index == -1)
	return PLUGIN_HANDLED
	if((tlmenu[index] == 6) || (tlmenu[index] == 7))
	{
		client_cmd(id, "buy; menuselect %i", tlmenu[index])
		return PLUGIN_HANDLED
	}
	client_cmd(id,"buy; menuselect %i; menuselect %i; slot10", tlmenu[index], llmenu[index])
	new idS[2]
	idS[0] = id
	set_task(1.0,"close_CLM",0,idS, 1)
	return PLUGIN_HANDLED
}

public close_CLM(idS[])
{
	new id = idS[0]
	client_cmd(id, "slot10")
	return PLUGIN_HANDLED
}

public plugin_init()
{
  register_plugin("Server-Side Buy Script", "1.0", "SpaceDude")
	for(new  i = 0; i<buyAmt; i++)
	{
		register_clcmd(clientcmd[i], "buy")
	}
	return PLUGIN_CONTINUE
}
