/* AMX Mod
*   csstats Rank to .htm Plugin
*
*  originally developed by Kindzhon  from China
*
*  This cs-htm.amx can convert csstats Rank to *.htm per hour, like 1:00,2:00,3:00.......
*
*  And you can set "amx_csstatshtm dir&filename " in server.cfg ,just as:
*  amx_csstatshtm "addons/amx/csstats27015"
*  amx_csstatshtm "../../bbs/csstats27016"
*  default dir&filename is "addons/amx/csstats.htm"
*
* Usage: amx_csstatshtm "dir&filename"
*
*  My web: http://61.144.228.61
*          http://kindzhon.126.com
*  Email:kindzhon@szonline.net
*/

#define STATS_NUM 15


#include <amxmod>
#include <amxmisc>
#include <csstats>

new g_Buffer[2048]
new g_fileToSavehtm[64]

public plugin_init() {

  register_plugin("CS Stats-html","0.16","Kindzhon.126.com")
  register_cvar("amx_csstatshtm","addons/amx/csstats")
  set_task(60.0,"htm",0,"",0,"b") 
}

public htm() {
  get_cvar_string("amx_csstatshtm",g_fileToSavehtm,63)
  format(g_fileToSavehtm, 63, "%s.php",g_fileToSavehtm)
  writehtm(g_fileToSavehtm)
  return PLUGIN_CONTINUE
}

writehtm(filename[]) {
  new pos, stats[8], body[8], name[32]
  new state[4]
  if (file_exists(filename)) delete_file(filename)
  pos = copy(g_Buffer,2047,"<html><head><body><table><tr><td bgcolor=#0000FF align=center>Kindzhon.126.com Rank List</td></tr></table></body>")
  pos += copy(g_Buffer[pos],2047-pos,"<body><style type=^"text/css^">")
  pos += copy(g_Buffer[pos],2047-pos,"body{font-family:Arial,sans-serif;font-size:12px;color:#FFCC99;background-color:#000000;margin-left:8px;margin-top:3px}.header{background-color:#9C0000;}.one{background-color:#310000;}.two{background-color:#630000;}")
  pos += copy(g_Buffer[pos],2047-pos,"</style></head><body><table><tr class=^"header^"><td>Rank</td><td>name</td><td>Kills</td><td>Death</td><td>hits</td><td>Shots</td><td>Headshots</td></tr>")
  write_file(filename,g_Buffer)
  for(new a = 0; a < STATS_NUM; ++a){
    if (equal(state,"one")) copy(state,3,"two")
    else copy(state,3,"one")
    get_stats(a,stats,body,name,31)
    format(g_Buffer,2047,"<tr class=^"%s^"><td>%d.</td><td>%s</td><td>%d</td><td>%d</td><td>%d</td><td>%d</td><td>%d</td></tr>",state,a+1,name,stats[0],stats[1],stats[5],stats[4],stats[2])
    write_file(filename,g_Buffer)
  }
  new ctime[64]  
  get_time("%m.%d.%Y- %H:%M:%S",ctime,63)  
  format(g_Buffer,2047,"</table><body><table><tr><td bgcolor=#00007F align=center>Update time: %s</td></tr></table></body></body></html>",ctime)
  write_file(filename,g_Buffer)
}
