#include <amxmod>
#include <amxmisc>
#include <csstats>

const left_red = 127
const left_green = 255        // endround teams and most active players stats
const left_blue = 127

const attackers_red = 255
const attackers_green = 127   // attackers list
const attackers_blue = 127

const victims_red = 127
const victims_green = 127     // victims list
const victims_blue = 255

const center_red = 255
const center_green = 127      // multikill and killing spree messages a la UnrealTournament
const center_blue = 255

new kills[32] = {0,...}
new bomber, g_defuser, c4timer
new Float:lastkill[32]
new seria[32] = {0,...}
new ryad[32] = {0,...}
new vip_name[32]
new vip = 45
new give_av, klr
new buffor[2048]
new user_position[33]
new user_players[33][32]

public bdef_g(id){
        new plist[32]
        new name[32]
        new pnum
        get_players(plist,pnum)
        if (get_user_team(id) == 1) {
            bomber = id
            get_user_name(id, name , 31)
            for (new i=0; i<pnum; ++i)
                if (plist[i]!=id)
                    if (get_user_team(plist[i]) == 1) {
                        client_print(plist[i],print_center,"%s is planting the bomb",name)
                    }
        } else {
            g_defuser = id
            get_user_name(id, name , 31)
            for (new i=0; i<pnum; ++i)
                if (plist[i]!=id)
                    if (get_user_team(plist[i]) == 2) {
                        client_print(plist[i],print_center,"%s is defusing the bomb",name)
                    }
        }
}

public disable_c4(){
	c4timer = 0
    remove_task(8038)
}

public bomb_pickup(id){
    new pnum
    new plist[32]
    new name[32]
    client_print(id,print_center,"You have picked up the bomb")
    get_user_name(id, name , 31)
    get_players(plist,pnum)
    for (new i=0; i<pnum; ++i)
        if (plist[i]!=id)
            if (get_user_team(plist[i]) == 1) {
                client_print(plist[i],print_center,"%s has picked up the bomb",name)
            }
}

public got_bomb(id) {
    bomber = id
    disable_c4()
}


public bomb_drop(){
    new name[32]
    get_user_name(bomber, name , 31)
    client_print(0,print_center,"%s has dropped the bomb", name)
}

public bomb_planted(){
	new name[32]
    get_user_name(bomber, name , 31)
    client_print(0,print_center,"%s has planted the bomb!", name)
    c4timer = get_cvar_num("mp_c4timer") - 2
    set_task(1.0,"bomb_c",8038,"",0,"b")
}

public bomb_c(){
    if (--c4timer > 0) {
        client_print(0,print_center,"%d", c4timer)
    } else remove_task(8038)
}

public bomb_defused() {
	new name[32]
    get_user_name(g_defuser, name, 31)
    client_print(0,print_center,"%s has defused the bomb!", name)
    client_print(g_defuser,print_center,"You have defused the bomb!", name)
    disable_c4()
}

public avlist(id) {
    new pnum
    new plist[32]
    new name[32]
    new wpn[32]
    new hs[32]
    new stats[8]
    new body[8]
    new found = 0
    new lst[1024]
    get_players(plist,pnum)
    get_user_vstats(id,0,stats,body)
    new pos = format(lst,1023,"Victims (%d shots):^n",stats[4])
    for (new i=0; i<pnum; ++i) {
        if(get_user_vstats(id,plist[i],stats,body,wpn,31)){
            found = 1
	    if (body[1])
		format(hs,31," - %d hs",body[1])
			else
				hs[0] = 0
            if (stats[1])
                format(wpn,31," - %s",wpn)
			else
				wpn[0] = 0
            get_user_name(plist[i],name,31)
            pos += format(lst[pos],1023-pos,"%s - %d dmg - %d hit%c%s%s^n",name,stats[6],stats[5],iss(stats[5]),hs,wpn)
		}
    }
    if (found) {
        set_hudmessage(victims_red,victims_green,victims_blue,0.6,0.6,0, 6.0, 12.0, 1.0, 2.0, 2)
        show_hudmessage(id,lst)
    }
    found = 0
    pos = format(lst,1023,"Attackers:^n")
    for (new i=0; i<pnum; ++i) {
        if(get_user_astats(id,plist[i],stats,body,wpn,31)){
            found = 1
	    if (body[1])
		format(hs,31," - %d hs",body[1])
			else
				hs[0] = 0
            if (stats[0])
                format(wpn,31," - %s",wpn)
			else
				wpn[0] = 0
            get_user_name(plist[i],name,31)
            pos += format(lst[pos],1023-pos,"%s - %d dmg - %d hit%c%s%s^n",name,stats[6],stats[5],iss(stats[5]),hs,wpn)
        }
	}
    if (found) {
        set_hudmessage(attackers_red,attackers_green,attackers_blue,0.6,0.3,0, 6.0, 12.0, 1.0, 2.0, 1)
        show_hudmessage(id,lst)
    }
}

public round_end()
    set_task(0.01,"m_list")

public m_list() {
    new shots[32] = {0,...}
    new hits[32] = {0,...}
    new dmg[32] = {0,...}
    new hs[32] = {0,...}
    new ct_kills,ct_shots,ct_hits,ct_dmg,ct_hs
    new t_kills,t_shots,t_hits,t_dmg,t_hs
    new m_dmg,m_kills
    new m_killer,mosts[256],teams[256],pnum,m_dmgr
    new plist[32]
    new vstats[32][8]
    new astats[32][8]
    new bodyhits[8]
    new m_d_name[32]
    new m_k_name[32]
    disable_c4()
    vip = 100
    ct_kills = 0
    ct_shots = 0
    ct_hits = 0
    ct_dmg = 0
    ct_hs = 0
    t_kills = 0
    t_shots = 0
    t_hits = 0
    t_dmg = 0
    t_hs = 0
    m_dmg = 0
    m_kills = 0
    get_players(plist,pnum)
    for (new i=0; i<pnum; ++i) {
        get_user_astats(plist[i],0,astats[plist[i]],bodyhits)
        if (!astats[plist[i]][0]) avlist(plist[i])
		get_user_vstats(plist[i],0,vstats[plist[i]],bodyhits)
        shots[plist[i]] = vstats[plist[i]][4]
        hits[plist[i]] = vstats[plist[i]][5]
        dmg[plist[i]] = vstats[plist[i]][6]
	hs[plist[i]] = bodyhits[1]
        if (get_user_team(plist[i]) == 1) {
            t_shots = t_shots + shots[plist[i]]
            t_hits = t_hits + hits[plist[i]]
            t_dmg = t_dmg + dmg[plist[i]]
            t_kills = t_kills + kills[plist[i]]
	    t_hs = t_hs + hs[plist[i]]
        } else {
            ct_shots = ct_shots + shots[plist[i]]
            ct_hits = ct_hits + hits[plist[i]]
            ct_dmg = ct_dmg + dmg[plist[i]]
            ct_kills = ct_kills + kills[plist[i]]
	    ct_hs = ct_hs + hs[plist[i]]
        }
        if(dmg[plist[i]] > m_dmg){
            m_dmg = dmg[plist[i]]
            m_dmgr = plist[i]
		}
        if (kills[plist[i]] > m_kills) {
            m_kills = kills[plist[i]]
            m_killer = plist[i]
        }
    }
    if (kills[m_dmgr] == m_kills) {
        get_user_name(m_dmgr,m_d_name,31)
        format(mosts,255,"Most damage and kills: %s^n    He made %d dmg, %d kill%c, %d shots, %d hits and %d hs",
            m_d_name,m_dmg,m_kills,iss(m_kills),shots[m_dmgr],hits[m_dmgr],hs[m_dmgr])
    } else {
        get_user_name(m_dmgr,m_d_name,31)
        get_user_name(m_killer,m_k_name,31)
        format(mosts,255,"Most damage: %s^n    He made %d dmg, %d kill%c, %d shots, %d hits and %d hs^nMost kills: %s^n    He made %d dmg, %d kill%c, %d shots, %d hits and %d hs",
            m_d_name,m_dmg,kills[m_dmgr],iss(kills[m_dmgr]),shots[m_dmgr],hits[m_dmgr],hs[m_dmgr],
            m_k_name,dmg[m_killer],m_kills,iss(m_kills),shots[m_killer],hits[m_killer],hs[m_killer])
    }
    format(teams,255,"This round Terrorists made^n    %d dmg, %d kill%c, %d shots, %d hits and %d hs^nThis round Counter-Terrorists made^n    %d dmg, %d kill%c, %d shots, %d hits and %d hs",
        t_dmg,t_kills,iss(t_kills),t_shots,t_hits,t_hs,ct_dmg,ct_kills,iss(ct_kills),ct_shots,ct_hits,ct_hs)
    set_hudmessage(left_red,left_green,left_blue,0.05,0.3,0, 6.0, 12.0, 1.0, 2.0, 3)
    show_hudmessage(0,"%s^n^n^n^n^n^n^n%s^n",teams,mosts)
    for (new i=0; i<33; i++) kills[i] = 0
}

public pereh() {
    new kname[32], vname[32], stats[8], body[8]
    new pos = 0
    new body_part[8][] = {"whole body","head","chest","stomach","left arm","right arm","left leg","right leg"}
    new vorigin[3], korigin[3]
    get_user_origin(give_av,vorigin)
    get_user_origin(klr,korigin)
    get_user_name(klr,kname,31)
    get_user_name(give_av,vname,31)
    avlist(give_av)
    get_user_vstats(klr,give_av,stats,body)
    for(new i = 1; i < 8; ++i)
        if(body[i]) pos += format(buffor[pos],2047-pos," %s x%d,",body_part[i],body[i])
    format(buffor[pos-1],2048-pos," from distance of %.2f meters",float(get_distance(vorigin,korigin)) * 0.0254)
    client_print(klr,print_chat,"* You hit %s in%s",vname,buffor)
    client_print(give_av,print_chat,"* %s hit you in%s",kname,buffor)
}

public deathmsg_event() {
    new killer = read_data(1)
    new victim = read_data(2)
    new kname[32], vname[32]
    give_av = victim
    klr = killer
    set_task(0.01,"pereh")
    get_user_name(killer,kname,31)
    get_user_name(victim,vname,31)
    set_hudmessage(center_red,center_green,center_blue, -1.0, 0.9, 0, 1.0, 4.0, 1.0, 2.0, 4)
    if (killer != victim && killer) {
        if (victim==vip) {
	    client_print(0,print_center,"%s killed VIP (%s)!",kname,vip_name)
	    client_print(0,print_chat,"* %s killed VIP (%s)!",kname,vip_name)
	}
        kills[killer]++
        seria[killer]++
        if (seria[victim]>4) {
            show_hudmessage(0,"%s's killing spree (%d) ended by %s", vname, seria[victim], kname)
        }
        switch (seria[killer]) {
            case 5: {
		show_hudmessage(0,"%s is in a killing spree", kname)
		client_print(0,print_chat,"* %s is in a killing spree", kname)
		}
            case 10: {
		show_hudmessage(0,"%s is in a rampage", kname)
		client_print(0,print_chat,"* %s is in a rampage", kname)
		}
            case 15: {
		show_hudmessage(0,"%s is dominating!", kname)
		client_print(0,print_chat,"* %s is dominating!", kname)
		}
            case 20: {
		show_hudmessage(0,"%s is unstoppable!", kname)
		client_print(0,print_chat,"* %s is unstoppable!", kname)
		}
            case 25: {
		show_hudmessage(0,"%s is Godlike!", kname)
		client_print(0,print_chat,"* %s is Godlike!", kname)
		}
            case 30: {
		show_hudmessage(0,"%s is WICKED SICK!", kname)
		client_print(0,print_chat,"* %s is WICKED SICK!", kname)
		}
        }
        if (get_gametime()-lastkill[killer]<4) {
            ryad[killer]++
            switch (ryad[killer]) {
                case 1: show_hudmessage(killer,"Double kill")
                case 2: show_hudmessage(killer,"Multi kill")
                case 3: show_hudmessage(killer,"Mega kill!")
                case 4: show_hudmessage(killer,"ULTRA KILL!")
                case 5: show_hudmessage(killer,"M O N S T E R   K I L L !")
                case 6: show_hudmessage(killer,"L U D I C R O U S   K I L L !")
                default: show_hudmessage(0,"H  O  L  L  Y      S  H  I  T  !")
            }
        } else {
            ryad[killer] = 0
        }
        lastkill[killer] = get_gametime()
    } else if (seria[killer]>4) {
	show_hudmessage(0,"%s was looking good until he killed self", kname)
	client_print(0,print_chat,"* %s was looking good until he killed self", kname)
    }
    seria[victim] = 0
}

public vip_spawn(id) {
    new pnum
    new plist[32]
    get_players(plist,pnum)
    get_user_name(id,vip_name,31)
    vip=id
    for (new i=0; i<pnum; ++i)
        if (plist[i]!=id)
            if (get_user_team(plist[i]) == 2) {
                client_print(plist[i],print_center,"This round %s is a VIP",vip_name)
		client_print(plist[i],print_chat,"* This round %s is a VIP",vip_name)
            }
    client_print(id,print_center,"THIS ROUND YOU ARE A VIP")
}

public vip_notess() {
    client_print(0,print_center,"The VIP (%s) has not escaped!",vip_name)
    client_print(0,print_chat,"* The VIP (%s) has not escaped!",vip_name)
}

public vip_ess() {
    client_print(0,print_center,"The VIP (%s) has escaped!",vip_name)
    client_print(0,print_chat,"* The VIP (%s) has escaped!",vip_name)
}

// Stats tables

public end_game_stats(){
    new plist[32], pnum
    get_players(plist,pnum)
    for(new i = 0; i < pnum; ++i)
        display_stats(plist[i],plist[i])
}

public intermission_event()
    set_task(0.1,"end_game_stats")

public disp_pplstats(id){
    show_ppl_menu(id,user_position[id]=0)
    return PLUGIN_HANDLED
}

public action_ppl_menu(id,key){
	switch(key){
	case 8: show_ppl_menu(id,++user_position[id])
	case 9:	show_ppl_menu(id,--user_position[id])
	default:{
        new option = user_position[id] * 8 + key
		new index = user_players[id][option]
        if (is_user_connected(index))
				display_stats(index,id)
		show_ppl_menu(id,user_position[id])
		}
	}
	return PLUGIN_HANDLED
}

show_ppl_menu(id,pos){
	if (pos < 0) return PLUGIN_HANDLED
    new menu_body[512], pnum, start = pos * 8
    get_players(user_players[id],pnum)
    if (start >= pnum) start = pos = user_position[id] = 0
    new len = format(menu_body,511,"\yAMX Stats\R%d/%d^n\w^n",pos + 1,((pnum/8)+((pnum%8)?1:0)))
    new name[32], end = start + 8, keys = (1<<9)|(1<<7)
    if (end > pnum) end = pnum
	pos = 0
	for(new a = start; a < end; ++a){
		get_user_name(user_players[id][a],name,31)
		keys |= (1<<pos)
		len += format(menu_body[len],511-len,"%d. %s^n\w",++pos,name)
	}
    if (end != pnum){
		len += format(menu_body[len],511-len,"^n9. More...^n0. Back")
        keys |= (1<<8)
	}
	else {
		len += format(menu_body[len],511-len,"^n0. Back")
	}
	show_menu(id,keys,menu_body)
	return PLUGIN_HANDLED
}

public disp_stats(id){
    display_stats(id,id)
	return PLUGIN_CONTINUE
}

iss (num) {
    new s1 = 's'
    if (num==1) s1=0
    return s1
}

public display_stats(id,dest) {
	new name[32], stats[8], body[8]
    new acc1, eff1
	get_user_wstats(id,0,stats,body)
    if (stats[4]!=0) {
        acc1 = ( stats[5] * 100 ) / stats[4]
    } else acc1 = 0
    if (stats[0]+stats[1]!=0) {
        eff1 = ( stats[0] * 100 ) / ( stats[0] + stats[1] )
    } else eff1 = 0
    new cent = '%'
    new pos = format(buffor,2047,"Total: %d shots, %d hits, %d dmg, %d kill%c, %d death%c, %d hs, %d%c acc, %d%c eff^n^n",
        stats[4],stats[5],stats[6],stats[0],iss(stats[0]),stats[1],iss(stats[1]),body[1],acc1,cent,eff1,cent)
    for(new i = 1; i < 31; ++i) {
        if (get_user_wstats(id,i,stats,body)){
            get_weaponname(i,name,31)
            acc1 = ( stats[5] * 100 ) / stats[4]
            if (stats[0]+stats[1]!=0) {
                eff1 = ( stats[0] * 100 ) / ( stats[0] + stats[1] )
            } else eff1 = 0
            pos += format(buffor[pos],2047-pos,"%s: %d shots, %d hits, %d dmg, %d kill%c, %d death%c, %d hs, %d%c acc, %d%c eff^n",
                name[7],stats[4],stats[5],stats[6],stats[0],iss(stats[0]),stats[1],iss(stats[1]),body[1],acc1,cent,eff1,cent)
		}
	}
	get_user_name(id,name,31)
	show_motd(dest,buffor,name)
	return PLUGIN_CONTINUE
}

public plugin_init() {
    register_plugin("Uber Stat","0.9.3","CapOne")
    // VIP events
    register_event("Battery","vip_spawn","b","1=200")
	register_event("TextMsg","vip_notess","a","2&#VIP_N")
    register_event("TextMsg","vip_ess","a","2&#VIP_E")
    // Bomb events
    register_event("StatusIcon", "got_bomb", "be", "1=1", "1=2", "2=c4")
    register_event("TextMsg", "bomb_pickup", "bc", "2&#Got_bomb")
    register_event("TextMsg", "bomb_drop", "bc", "2&#Game_bomb_d")
    register_event("SendAudio", "bomb_planted", "a", "2&%!MRAD_BOMBPL")
    register_event("SendAudio", "bomb_defused", "a", "2&%!MRAD_BOMBDEF")
    register_event("SendAudio", "disable_c4", "a", "2&%!MRAD_terwin","2&%!MRAD_ctwin","2&%!MRAD_rounddraw")
    register_event("TextMsg","disable_c4","a","2&#Game_C","2&#Game_w")
    register_event("BarTime", "bdef_g", "be", "1=10", "1=5","1=3")
    // General events
    register_event("30","intermission_event","a")
    register_event("SendAudio","round_end", "a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw")
    register_event("DeathMsg","deathmsg_event", "a")
    register_menucmd(register_menuid("\yAMX Stats"),1023,"action_ppl_menu")
    register_clcmd("say /statsme","disp_stats",0,"- displays your stats")
    register_clcmd("say /stats","disp_pplstats",0,"- displays others stats")
    register_clcmd("mystats","disp_stats",0,"- displays your stats")
    register_clcmd("stats","disp_pplstats",0,"- displays others stats")
    return PLUGIN_CONTINUE
}
